-- Scorchio! 2
-- A multi-mob vulnerability manager
-- ennui@bloodhoof-eu
-- Email: ennuilg@gmail.com

-- GLOBALS: LibStub
-- GLOBALS: UIParent
local _G = _G
local PlaySoundFile = PlaySoundFile
local InCombatLockdown = InCombatLockdown
local GetTalentInfo = GetTalentInfo
local UnitClass = UnitClass
local UnitExists = UnitExists
local UnitGUID = UnitGUID
local UnitDebuff = UnitDebuff
local UnitName = UnitName
local UnitIsPlayer = UnitIsPlayer
local GetTime = GetTime
local COMBATLOG_OBJECT_TYPE_PLAYER = COMBATLOG_OBJECT_TYPE_PLAYER
local COMBATLOG_OBJECT_AFFILIATION_MINE = COMBATLOG_OBJECT_AFFILIATION_MINE
local pairs = pairs
local unpack = unpack
local tostring = tostring
local gsub = gsub
local strfind = strfind
local floor = floor
local bit_bor = bit.bor
local bit_band = bit.band
local client4 = select(4, _G.GetBuildInfo()) >= 40000

local mobTable
local DB
local Scorchio2
local lastTargetGUID
local waterElementalGUID
local localSpellNames
local combatFlag

Scorchio2 = LibStub("AceAddon-3.0"):NewAddon("Scorchio2", "AceEvent-3.0", "AceConsole-3.0", "AceTimer-3.0", "LibBars-1.0", "LibSink-2.0")
_G.Scorchio2 = Scorchio2
local L = LibStub:GetLibrary("AceLocale-3.0"):GetLocale("Scorchio2")
local SM = LibStub("LibSharedMedia-3.0")
local AceConfig = LibStub("AceConfig-3.0")
local AceConfigDialog = LibStub("AceConfigDialog-3.0")

-- Constants for mobTable
local MOBNAME = 1
local REFRESHTIME = 2
local EXPIRATIONTIME = 3
local DURATION = 4
local STACK = 5
local CASTS = 6
local TIMER = 7
local BAR = 8

local AFFILIATION = bit_bor(COMBATLOG_OBJECT_AFFILIATION_MINE, COMBATLOG_OBJECT_AFFILIATION_PARTY, COMBATLOG_OBJECT_AFFILIATION_RAID)

-- Register some sounds
SM:Register("sound", "AchievementSound", [[Sound\Spells\AchievmentSound1.wav]])
SM:Register("sound", "Rubber Ducky", [[Sound\Doodad\Goblin_Lottery_Open01.wav]])
SM:Register("sound", "Cartoon FX", [[Sound\Doodad\Goblin_Lottery_Open03.wav]])
SM:Register("sound", "Explosion", [[Sound\Doodad\Hellfire_Raid_FX_Explosion05.wav]])
SM:Register("sound", "Shing!", [[Sound\Doodad\PortcullisActive_Closed.wav]])
SM:Register("sound", "Wham!", [[Sound\Doodad\PVP_Lordaeron_Door_Open.wav]])
SM:Register("sound", "Simon Chime", [[Sound\Doodad\SimonGame_LargeBlueTree.wav]])
SM:Register("sound", "War Drums", [[Sound\Event Sounds\Event_wardrum_ogre.wav]])
SM:Register("sound", "Cheer", [[Sound\Event Sounds\OgreEventCheerUnique.wav]])
SM:Register("sound", "Humm", [[Sound\Spells\SimonGame_Visual_GameStart.wav]])
SM:Register("sound", "Short Circuit", [[Sound\Spells\SimonGame_Visual_BadPress.wav]])
SM:Register("sound", "Fel Portal", [[Sound\Spells\Sunwell_Fel_PortalStand.wav]])
SM:Register("sound", "Fel Nova", [[Sound\Spells\SeepingGaseous_Fel_Nova.wav]])

SM:Register("sound", "Bats", "Sound\\Doodad\\BatsFlyAway.wav")
SM:Register("sound", "Firework", "Sound\\Doodad\\G_FireworkBoomGeneral2.wav")
SM:Register("sound", "Clockwork", "Sound\\Doodad\\G_GasTrapOpen.wav")
SM:Register("sound", "Gong", "Sound\\Doodad\\G_GongTroll01.wav")
SM:Register("sound", "Wisp", "Sound\\Event Sounds\\Wisp\\WispPissed1.wav")
SM:Register("sound", "Fog Horn", "Sound\\Doodad\\ZeppelinHorn.wav")
SM:Register("sound", "Error", "Sound\\interface\\Error.wav")
SM:Register("sound", "Drop", "Sound\\interface\\DropOnGround.wav")
SM:Register("sound", "Whisper",	"Sound\\interface\\igTextPopupPing02.wav")
SM:Register("sound", "Friend Login", "Sound\\interface\\FriendJoin.wav")
SM:Register("sound", "Socket Clunk", "Sound\\interface\\JewelcraftingFinalize.wav")
SM:Register("sound", "Ping", "Sound\\interface\\MapPing.wav")


-- vulnKeys
local T = { "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "o", "o", "o", "o", "p", "p", "p", "q"}
 
-- Spell Constants
local SPELLIDS
if client4 then
	SPELLIDS = {
        { [2948]=true  }, -- Scorch
        { [116]=true, -- Frostbolt
          [122]=true, -- Frost Nova
          [120]=true, -- Cone of Cold
          [30455]=true, -- Ice Lance
          [44614]=true, -- Frostfire Bolt
          [10]=true -- Blizzard
        },
        { --[[ [44461]=true --]] }, -- Living Bomb
        { [118]=true, -- Polymorph
          [28271]=true, -- Polymorph: Turtle
          [28272]=true, -- Polymorph: Pig
          [61025]=true, -- Polymorph: Serpent
          [61305]=true, -- Polymorph: Black Cat
		  [61721]=true, -- Polymorph: Rabbit
		  [61780]=true -- Polymorph: Turkey
        },
        { [31589]=true  }, -- Slow
        { }, -- Hot Streak
        { [133]=true },-- Fireball
        { }, -- Clearcasting
        { [30451]=true }, -- Arcane Blast
        { }, -- Brain Freeze
        { }, -- Fingers of Frost
        { [686]=true }, -- Shadow Bolt
        { [31687] = true }, -- Summon Water Elemental
        { [55342] = true }, -- Mirror Image
		{ }, -- Torment the Weak
		{ }, -- 8% Spell Damage
		{ [44614] = true }, -- Frostfire Bolt
    }
else
	SPELLIDS = {
        { [2948]=true, [8444]=true, [8445]=true, [8446]=true, [10205]=true, [10206]=true, [10207]=true, [27903]=true, [27074]=true, [42858]=true, [42859]=true   }, -- Scorch
        { [116]=true, [205]=true, [837]=true, [7322]=true, [8406]=true, [8407]=true, [8408]=true, [10179]=true, [10180]=true, [10181]=true, [25304]=true, [27071]=true, [27072]=true, [38697]=true, [42841]=true, [42842]=true, -- Frostbolt
          [122]=true, [865]=true, [6131]=true, [10230]=true, [27088]=true, [42917]=true, -- Frost Nova
          [120]=true, [8492]=true, [10159]=true, [10160]=true, [10161]=true, [27087]=true, [42930]=true, [42931]=true, -- Cone of Cold
          [30455]=true, [42913]=true, [42914]=true, -- Ice Lance
          [44614]=true, [47610]=true, -- Frostfire Bolt
          [106]=true, [6141]=true, [8427]=true, [10185]=true, [10186]=true, [10187]=true, [27085]=true, [42939]=true, [42940]=true -- Blizzard
        },
        { --[[ [44461]=true, [55361]=true, [55362]=true --]] }, -- Living Bomb
        { [118]=true, [12824]=true, [12825]=true, [12826]=true, -- Polymorph
          [28271]=true, -- Polymorph: Turtle
          [28272]=true, -- Polymorph: Pig
          [61025]=true, -- Polymorph: Serpent
          [61305]=true, -- Polymorph: Black Cat
		  [61721]=true, -- Polymorph: Rabbit
		  [61780]=true -- Polymorph: Turkey
        },
        { [31589]=true  }, -- Slow
        { }, -- Hot Streak
        { [133]=true, [143]=true, [145]=true, [3140]=true, [8400]=true, [8401]=true, [8402]=true, [10148]=true, [10149]=true, [10150]=true, [10151]=true, [25306]=true, [27070]=true, [38692]=true, [42832]=true, [42833]=true },-- Fireball
        { }, -- Clearcasting
        { [30451]=true, [42894]=true, [42896]=true, [42897]=true }, -- Arcane Blast
        { }, -- Brain Freeze
        { }, -- Fingers of Frost
        { [686]=true, [695]=true, [705]=true, [1088]=true, [1106]=true, [7641]=true, [11659]=true, [11660]=true, [11661]=true, [25307]=true, [27209]=true, [47808]=true, [47809]=true }, -- Shadow Bolt
        { [31687] = true }, -- Summon Water Elemental
        { [55342] = true }, -- Mirror Image
		{ }, -- Torment the Weak
		{ } -- 13% Spell Damage
    }
end
    
local VULNERABILITIES
if client4 then
	VULNERABILITIES = {
        { [22959]=true, -- Critical Mass
          [38715]=true -- Fire Vulnerability
        },
        { [12579]=true -- Winter's Chill
        },
        { [44457]=true -- Living Bomb
        },
        { [118]=true, -- Polymorph
          [28271]=true, -- Polymorph: Turtle
          [28272]=true, -- Polymorph: Pig
          [61025]=true, -- Polymorph: Serpent
          [61305]=true, -- Polymorph: Black Cat
		  [61721]=true, -- Polymorph: Rabbit
		  [61780]=true -- Polymorph: Turkey
        },
        { [31589]=true -- Slow
        },
        { [48108]=true -- Hot Streak
        },
        { [79683]=true -- Missile Barrage, and actually it's just "Arcane Missiles" now, but redoing names & localization is another project
        },
        { [12536]=true -- Clearcasting
        },
        { [36032]=true -- Arcane Blast
        },
        { [57761]=true -- Brain Freeze (Fireball!)
        },
        { [44544]=true -- Fingers of Frost
        },
        { [17794]=true, [17797]=true, [17798]=true, [17799]=true, [17800]=true -- Shadow Mastery
        },
        { --[[ [31687] --]]  -- Water Elemental
        },
        { [55342]=true -- Mirror Image
        },
		{ [31589]=true }, -- TtW Slow
		{ [6343]=true }, -- TtW Thunderclap
		{ [55095]=true }, -- TtW Frost Fever
		{ [48483]=true, [48484]=true }, -- TtW Infected Wounds
		{
		  [53696]=true, [68055]=true -- TtW Judgements of the Just
--		  [20184]=true, [20185]=true, [20186]=true -- Paladin Judgements which may be talented with Judgement of the Just
		},
        { [65142]=true -- Ebon Plaguebringer
        },
        { [1490]=true -- Curse of Elements
        },
        { [60433]=true -- Earth and Moon
        },
		{ [44614]=true }, -- Frostfire Bolt
    }
else
	VULNERABILITIES = {
        { [22959]=true, -- Improved Scorch
          [38715]=true -- Fire Vulnerability
        },
        { [12579]=true -- Winter's Chill
        },
        { [44457]=true, -- Living Bomb I
          [55359]=true, -- Living Bomb II
          [55360]=true -- Living Bomb III
        },
        { [118]=true, [12824]=true, [12825]=true, [12826]=true, -- Polymorph
          [28271]=true, -- Polymorph: Turtle
          [28272]=true, -- Polymorph: Pig
          [61025]=true, -- Polymorph: Serpent
          [61305]=true, -- Polymorph: Black Cat
		  [61721]=true, -- Polymorph: Rabbit
		  [61780]=true -- Polymorph: Turkey
        },
        { [31589]=true -- Slow
        },
        { [48108]=true -- Hot Streak
        },
        { [44401]=true -- Missile Barrage
        },
        { [12536]=true -- Clearcasting
        },
        { [36032]=true -- Arcane Blast
        },
        { [57761]=true -- Brain Freeze (Fireball!)
        },
        { [44544]=true -- Fingers of Frost
        },
        { [17794]=true, [17797]=true, [17798]=true, [17799]=true, [17800]=true -- Shadow Mastery
        },
        { --[[ [31687] --]]  -- Water Elemental
        },
        { [55342]=true -- Mirror Image
        },
		{ [31589]=true }, -- TtW Slow
		{ [6343]=true, [8198]=true, [8204]=true, [8205]=true, [11580]=true, [11581]=true, [25264]=true, [47501]=true, [47502]=true }, -- TtW Thunderclap
		{ [55095]=true }, -- TtW Frost Fever
		{ [48483]=true, [48484]=true, [48485]=true }, -- TtW Infected Wounds
		{
		  [53696]=true, [68055]=true -- TtW Judgements of the Just
--		  [20184]=true, [20185]=true, [20186]=true -- Paladin Judgements which may be talented with Judgement of the Just
		},
        { [51735]=true -- Ebon Plaguebringer
        },
        { [47865]=true -- Curse of Elements
        },
        { [60433]=true -- Earth and Moon
        }
    }
end
	
local VULNDATA = {
    { -- Scorch
        self = false,
        durationpve = 30,
        durationpvp = 30,
        maxstacks = 1,
        unique = false,
        valid = 4294967295,
    },
    { -- Winter's Chill
        self = false,
        durationpve = 15,
        durationpvp = 15,
        maxstacks = 5,
        unique = false,
        valid = 4294967295,
    },
    { -- Living Bomb
        self = false,
        durationpve = 12,
        durationpvp = 12,
        maxstacks = 1,
        unique = false,
        valid = COMBATLOG_OBJECT_AFFILIATION_MINE,
    },
    { -- Polymorph
        self = false,
        durationpve = 50,
        durationpvp = 10,
        maxstacks = 1,
        unique = true,
        valid = 4294967295,
    },
    { -- Slow
        self = false,
        durationpve = 15,
        durationpvp = 10,
        maxstacks = 1,
        unique = true,
        valid = 4294967295,
    },
    { -- Hot Streak
        self = true,
        durationpve = (client4) and 15 or 10,
        durationpvp = (client4) and 15 or 10,
        maxstacks = 1,
        unique = true,
        valid = COMBATLOG_OBJECT_AFFILIATION_MINE,
	},
    { -- Missile Barrage
        self = true,
        durationpve = 15,
        durationpvp = 15,
        maxstacks = 1,
        unique = true,
        valid = COMBATLOG_OBJECT_AFFILIATION_MINE,
	},
    { -- Clearcasting
        self = true,
        durationpve = 15,
        durationpvp = 15,
        maxstacks = 1,
        unique = true,
        valid = COMBATLOG_OBJECT_AFFILIATION_MINE,
	},
    { -- Arcane Blast
        self = true,
        durationpve = 6,
        durationpvp = 6,
        maxstacks = 4,
        unique = true,
        valid = COMBATLOG_OBJECT_AFFILIATION_MINE,
	},
    { -- Brain Freeze
        self = true,
        durationpve = 15,
        durationpvp = 15,
        maxstacks = 1,
        unique = true,
        valid = COMBATLOG_OBJECT_AFFILIATION_MINE,
    },
    { -- Fingers of Frost
        self = true,
        durationpve = 15,
        durationpvp = 15,
        maxstacks = (client4) and 2 or 1,
        unique = true,
        valid = COMBATLOG_OBJECT_AFFILIATION_MINE,
	},
    {  -- Shadow Mastery
        self = false,
        durationpve = 30,
        durationpvp = 30,
        maxstacks = 1,
        unique = false,
        valid = 4294967295,
    },
    {  -- Water Elemental
        self = true,
        durationpve = 45,
        durationpvp = 45,
        maxstacks = 1,
        unique = true,
        valid = COMBATLOG_OBJECT_AFFILIATION_MINE,
    },
    {  -- Mirror Image
        self = true,
        durationpve = 30,
        durationpvp = 30,
        maxstacks = 1,
        unique = true,
        valid = COMBATLOG_OBJECT_AFFILIATION_MINE,
    },
    { -- TtW Slow
        self = false,
        durationpve = 15,
        durationpvp = 10,
        maxstacks = 1,
        unique = false,
        valid = 4294967295,
    },
	{  -- TtW Thunderclap
		self = false,
		durationpve = 30,
		durationpvp = 10,
		maxstacks = 1,
		unique = false,
		valid = 4294967295,
	},
	{  -- TtW Frost Fever
		self = false,
		durationpve = 15,
		durationpvp = 10,
		maxstacks = 1,
		unique = false,
		valid = 4294967295,
	},
	{  -- TtW Infected Wounds
		self = false,
		durationpve = 12,
		durationpvp = 10,
		maxstacks = 1,
		unique = false,
		valid = 4294967295,
	},
	{  -- TtW Pally Judgements
		self = false,
		durationpve = 20,
		durationpvp = 10,
		maxstacks = 1,
		unique = false,
		valid = 4294967295,
    },
	{  -- Ebon Plaguebringer
		self = false,
		durationpve = 20,
		durationpvp = 10,
		maxstacks = 1,
		unique = false,
		valid = 4294967295,
	},
	{  -- Curse of Elements
		self = false,
		durationpve = 300,
		durationpvp = 10,
		maxstacks = 1,
		unique = false,
		valid = 4294967295,
	},
	{  -- Earth and Moon
		self = false,
		durationpve = 12,
		durationpvp = 10,
		maxstacks = 1,
		unique = false,
		valid = 4294967295,
	},
    { -- Frostfire Bolt
        self = false,
        durationpve = 12,
        durationpvp = 12,
        maxstacks = 3,
        unique = false,
        valid = COMBATLOG_OBJECT_AFFILIATION_MINE,
    },
}
    

-- Utility Functions    
local function Colours(pack, alpha)
    local r, g, b = unpack(pack)
    return r, g, b, alpha
end
Scorchio2.Colours = Colours
    
local function GetSMIndex(t, value)
	for k, v in pairs(SM:List(t)) do
	if v == value then
		return k
		end
	end
	return nil
end
Scorchio2.GetSMIndex = GetSMIndex

local function SubTokens( inputText, mobName, spellCount)
    if mobName ~= nil then
        inputText = gsub(inputText, "$m", tostring(mobName))
    end
    if spellCount ~= nil then
        inputText = gsub(inputText, "$s", tostring(spellCount))
    end
    return inputText
end
Scorchio2.SubTokens = SubTokens

-- Defaults and Options Tables
local defaults = {
    profile = {
		anchoroptions = {
			custom = { },
			targeted = {
				position = {
					pr = "CENTER",
					p = "CENTER",
					py = -300,
					px = 0
					},
				growth = true,
				orientation = 1,
				scale = 1.0,
				fadetime = -1,
				flash = false,
				flashtime = 6,
				iconshow = true,
				iconside = "LEFT",
				raidiconshow = false,
				raidiconpos = -10,
				texture = "Blizzard",
				width = 200,
				height = 18,
				maxbars = 0,
				font = "Arial Narrow",
				fontsize = 12
			},
			nontargeted = {
				position = {
					pr = "LEFT",
					p = "LEFT",
					py = -230,
					px = 150
					},
				growth = true,
				orientation = 1,
				scale = 1.0,
				fadetime = -1,
				flash = false,
				flashtime = 6,
				iconshow = true,
				iconside = "LEFT",
				raidiconshow = false,
				raidiconpos = -10,
				texture = "Blizzard",
				width = 200,
				height = 18,
				maxbars = 0,
				font = "Arial Narrow",
				fontsize = 12
			},
			buffs = {
				position = {
					pr = "CENTER",
					p = "CENTER",
					py = 0,
					px = 0
					},
				growth = true,
				orientation = 1,
				scale = 1.0,
				fadetime = -1,
				flash = false,
				flashtime = 6,
				iconshow = true,
				iconside = "LEFT",
				raidiconshow = false,
				raidiconpos = -10,
				texture = "Blizzard",
				width = 200,
				height = 18,
				maxbars = 0,
				font = "Arial Narrow",
				fontsize = 12
			},
		},
        baroptions = {
            a = {
				message = L["Improved Scorch Expired on $m"],
				warning = L["Rescorch $m!"],
                track = true,
                show = true,
                showproc = false,
                showwarning = true,
                showexpire = true,
                warningtime = 6,
                soundson = true,
                warningsound = "Bell",
                expiredsound = "Info",
                bar = "$m",
                fg = { 0, 1, 0 },
                bg = { 0.2, 0.2, 0.2 },
                nontargetanchor = "nontargeted",
                targetanchor = "targeted",
				nontargetalpha = 1.0,
				targetalpha = 1.0,
                clearooc = true,
				icon = "Interface\\Icons\\Spell_Fire_SoulBurn"
            },
            b = {
				message = L["Winter's Chill Expired on $m"],
				warning = L["Reapply Winter's Chill on $m!"],
                track = true,
                show = true,
                showproc = false,
                showwarning = true,
                showexpire = true,
                warningtime = 5,
                soundson = true,
                bar = "$s x $m",
                warningsound = "Bell",
                expiredsound = "Info",
                fg = { 0, 0, 1 },
                bg = { 0.2, 0.2, 0.2 },
                nontargetanchor = "nontargeted",
                targetanchor = "targeted",
				nontargetalpha = 1.0,
				targetalpha = 1.0,	
                clearooc = true,
				icon = "Interface\\Icons\\Spell_Frost_ChillingBlast"
            },
            c = {
				message = L["Living Bomb Exploded on $m"],
				warning = L["$m Is About To Blow!"],
                track = true,
                show = true,
                showproc = false,
                showwarning = true,
                showexpire = true,
                warningtime = 0,
                soundson = true,
                bar = "$m",
                warningsound = "Bell",
                expiredsound = "Info",                
                fg = { 1, 0, 0 },
                bg = { 0.2, 0.2, 0.2 },
                nontargetanchor = "nontargeted",
                targetanchor = "targeted",
				nontargetalpha = 1.0,
				targetalpha = 1.0,
                clearooc = true,
				icon = "Interface\\Icons\\Ability_Mage_LivingBomb"
            },
            d = {
				message = L["Polymorph Broken on $m"],
				warning = L["Resheep $m!"],
                track = true,
                show = true,
                showproc = false,
                showwarning = true,
                showexpire = true,
                telltale = true,
                warningtime = 6,
                soundson = true,
                bar = "$m",
                warningsound = "Bell",
                expiredsound = "Info",                
                fg = { 1, 0, 0.5 },
                bg = { 0.2, 0.2, 0.2 },
                nontargetanchor = "nontargeted",
                targetanchor = "targeted",
				nontargetalpha = 1.0,
				targetalpha = 1.0,
                clearooc = true,
				icon = "Interface\\Icons\\Spell_Nature_Polymorph"
            },
            e = {
				message = L["Slow Faded on $m"],
				warning = L["Recast Slow on $m"],
                track = true,
                show = true,
                showproc = false,
                showwarning = true,
                showexpire = true,
                warningtime = 6,
                soundson = true,
                bar = "$m",
                warningsound = "Bell",
                expiredsound = "Info",                
                fg = { 0, 0, 0.5 },
                bg = { 0.2, 0.2, 0.2 },
                nontargetanchor = "nontargeted",
                targetanchor = "targeted",
				nontargetalpha = 1.0,
				targetalpha = 1.0,
                clearooc = true,
				icon = "Interface\\Icons\\Spell_Nature_Slow"
            },
            f = {
				apply = L["HOT STREAK!"],
				message = L["Hot Streak Faded"],
				warning = L["Use Hot Streak Soon!"],
                track = true,
                show = true,
                showproc = true,
                showwarning = true,
                showexpire = true,
                warningtime = 3,
                soundson = true,
                bar = L["Hot Streak"],
                procsound = "Ping",
                warningsound = "Bell",
                expiredsound = "Info",                
                fg = { 1, 0.2, 0 },
                bg = { 0.2, 0.2, 0.2 },
                nontargetanchor = "buffs",
                targetanchor = "buffs",
				nontargetalpha = 1.0,
				targetalpha = 1.0,
                clearooc = false,
				icon = "Interface\\Icons\\Ability_Mage_HotStreak"
            },
            g = {
				apply = L["MISSILE BARRAGE!"],
				message = L["Missile Barrage Faded"],
				warning = L["Use Missile Barrage Soon!"],
                track = true,
                show = true,
                showproc = true,
                showwarning = true,
                showexpire = true,
                warningtime = 5,
                soundson = true,
                bar = L["Missile Barrage"],
                procsound = "Ping",
                warningsound = "Bell",
                expiredsound = "Info",                
                fg = { 0.4, 0.8, 1 },
                bg = { 0.2, 0.2, 0.2 },
                nontargetanchor = "buffs",
                targetanchor = "buffs",
				nontargetalpha = 1.0,
				targetalpha = 1.0,
                clearooc = false,
				icon = "Interface\\Icons\\Ability_Mage_MissileBarrage"
            },
            h = {
				apply = L["CLEARCASTING!"],
				message = L["Clearcasting Faded"],
				warning = L["Use Clearcasting Soon!"],
                track = true,
                show = true,
                showproc = true,
                showwarning = true,
                showexpire = true,
                warningtime = 5,
                soundson = true,
                bar = L["Clearcasting"],
                procsound = "Ping",
                warningsound = "Bell",
                expiredsound = "Info",                
                fg = { 0.4, 1, 0.4 },
                bg = { 0.2, 0.2, 0.2 },
                nontargetanchor = "buffs",
                targetanchor = "buffs",
				nontargetalpha = 1.0,
				targetalpha = 1.0,
                clearooc = false,
				icon = "Interface\\Icons\\Spell_Shadow_ManaBurn"
            },
            i = {
				message = L["Arcane Blast Faded"],
				warning = L["Arcane Blast Fading Soon!"],
                track = true,
                show = true,
                showproc = false,
                showwarning = true,
                showexpire = true,
                warningtime = 3,
                soundson = true,
                bar = "$s x " .. L["Arcane Blast"],
                procsound = "Ping",
                warningsound = "Bell",
                expiredsound = "Info",                
                fg = { 1, 0.8, 0.4 },
                bg = { 0.2, 0.2, 0.2 },
                nontargetanchor = "buffs",
                targetanchor = "buffs",
				nontargetalpha = 1.0,
				targetalpha = 1.0,
                clearooc = false,
				icon = "Interface\\Icons\\Spell_Arcane_Blast"
            },
            j = {
				apply = L["BRAIN FREEZE!"],
				message = L["Brain Freeze Faded"],
				warning = L["Use Fireball Soon!"],
                track = true,
                show = true,
                showproc = true,
                showwarning = true,
                showexpire = true,
                warningtime = 5,
                soundson = true,
                bar = L["Brain Freeze"],
                procsound = "Ping",
                warningsound = "Bell",
                expiredsound = "Info",                
                fg = { 0.2, 0.4, 1 },
                bg = { 0.2, 0.2, 0.2 },
                nontargetanchor = "buffs",
                targetanchor = "buffs",
				nontargetalpha = 1.0,
				targetalpha = 1.0,
                clearooc = false,
				icon = "Interface\\Icons\\Ability_Mage_BrainFreeze"
            },
            k = {
				apply = L["FINGERS OF FROST!"],
				message = L["Fingers of Frost Faded!"],
				warning = L["Use Fingers of Frost Soon!"],
                track = true,
                show = true,
                showproc = true,
                showwarning = true,
                showexpire = true,
                warningtime = 5,
                soundson = true,
                bar = L["Fingers of Frost"],
                procsound = "Ping",
                warningsound = "Bell",
                expiredsound = "Info",
                fg = { 0.2, 0.2, 1 },
                bg = { 0.2, 0.2, 0.2 },
                nontargetanchor = "buffs",
                targetanchor = "buffs",
				nontargetalpha = 1.0,
				targetalpha = 1.0,
                clearooc = false,
				icon = "Interface\\Icons\\Ability_Mage_Wintersgrasp"
            },
            l = {
				message = L["Shadow Mastery Faded on $m"],
				warning = L["Shadow Mastery is Running Out on $m!"],
                track = true,
                show = true,
                showproc = false,
                showwarning = true,
                showexpire = true,
                warningtime = 6,
                soundson = true,
                bar = L["Shadow Mastery"],
                warningsound = "Bell",
                expiredsound = "Info",
                fg = { 0.2, 0, 0.4 },
                bg = { 0.2, 0.2, 0.2 },
                nontargetanchor = "nontargeted",
                targetanchor = "targeted",
				nontargetalpha = 1.0,
				targetalpha = 1.0,
                clearooc = true,
				icon = "Interface\\Icons\\Spell_Shadow_Shadowbolt"
            },
            m = {
				message = L["Water Elemental Dead"],
				warning = L["Water Elemental Fading!"],
                track = true,
                show = true,
                showproc = false,
                showwarning = true,
                showexpire = true,
                warningtime = 10,
                soundson = true,
                bar = L["Water Elemental"],
                warningsound = "Bell",
                expiredsound = "Info",
                fg = { 0.2, 1, 1 },
                bg = { 0.2, 0.2, 0.2 },
                nontargetanchor = "buffs",
                targetanchor = "buffs",
				nontargetalpha = 1.0,
				targetalpha = 1.0,
                clearooc = false,
				icon = "Interface\\Icons\\Spell_Frost_SummonWaterElemental_2"
            },
            n = {
				message = L["Mirror Image: Full Threat Restored"],
				warning = L["Mirror Image: Threat Reduction Fading Shortly!"],
                track = true,
                show = true,
                showwarning = true,
                showexpire = true,
                warningtime = 5,
                soundson = true,
                bar = L["Mirror Image"],
                warningsound = "Bell",
                expiredsound = "Info",
                fg = { 0.2, 1, 0 },
                bg = { 0.2, 0.2, 0.2 },
                nontargetanchor = "buffs",
                targetanchor = "buffs",
				nontargetalpha = 1.0,
				targetalpha = 1.0,
                clearooc = false,
				icon = "Interface\\Icons\\Spell_Magic_LesserInvisibilty"
            },
			o = {
				message = L["Torment the Weak Faded on $m"],
				warning = "",
				track = true,
				show = true,
				showwarning = false,
				showexpire = true,
				warningtime = 0,
				soundson = true,
				bar = L["Torment The Weak on"] .. " $m",
				warningsound = "None",
				expiredsound = "Info",
				fg = { 0, 0, 0 },
				bg = { 0.2, 0.2, 0.2 },
				nontargetanchor = "nontargeted",
				targetanchor = "targeted",
				nontargetalpha = 1.0,
				targetalpha = 1.0,
                clearooc = true,
				icon = "Interface\\Icons\\Ability_Mage_TormentoftheWeak"
			},
			p = {
				message = L["13% Spell Damage Faded on $m"],
				warning = "",
				track = true,
				show = true,
				showwarning = false,
				showexpire = true,
				warningtime = 0,
				soundson = true,
				bar = L["13% Spell Damage on"] .. " $m",
				warningsound = "None",
				expiredsound = "Info",
				fg = { 0, 0, 0 },
				bg = { 0.2, 0.2, 0.2 },
				nontargetanchor = "nontargeted",
				targetanchor = "targeted",
				nontargetalpha = 1.0,
				targetalpha = 1.0,
                clearooc = true,
				icon = "Interface\\Icons\\INV_Enchant_EssenceMagicLarge"
			},
            q = {
				message = L["Frostfire Bolt Expired on $m"],
				warning = L["Reapply Frostfire Bolt on $m!"],
                track = true,
                show = true,
                showproc = false,
                showwarning = true,
                showexpire = true,
                warningtime = 5,
                soundson = true,
                bar = "$s x $m",
                warningsound = "Bell",
                expiredsound = "Info",
                fg = { 0.2, 0.2, 1 },
                bg = { 0.2, 0.2, 0.2 },
                nontargetanchor = "nontargeted",
                targetanchor = "targeted",
				nontargetalpha = 1.0,
				targetalpha = 1.0,	
                clearooc = true,
				icon = "Interface\\Icons\\Ability_Mage_FrostFireBolt"
            },
        },
        sinkoptions = { },
        debug = {
            duplicates = false,
            sync = false,
            mob = false,
            code = false,
            timers = false,
            log = false
        },
    },
}

local options = {
	type = 'group',
	name = "Options",
    args = {
		anchoroptions = {
			type = 'group',
			name = "Anchor Options",
			args = {
				heading = {
					type = 'header',
					name = "Presets",
					order = 100,
				},
				gap = {
					type = 'description',
					name = L["\nThese presets only store anchor and alpha information. " ..
						"If you want to save an entire configuration (including bar colours, warning sounds, etc) " ..
						"use the Profiles feature.\n"],
					width = "full",
					order = 101,
				},
				modern = {
					type = 'execute',
					name = L["Modern Anchors"],
					order = 105,
					func = function()
						for k, v in pairs(VULNERABILITIES) do
							if VULNDATA[k].self then
								DB.profile.baroptions[T[k]].targetanchor = "buffs"
								DB.profile.baroptions[T[k]].nontargetanchor = "buffs"
								DB.profile.baroptions[T[k]].targetalpha = 1.0
								DB.profile.baroptions[T[k]].nontargetalpha = 1.0
							else
								DB.profile.baroptions[T[k]].targetanchor = "targeted"
								DB.profile.baroptions[T[k]].nontargetanchor = "nontargeted"
								DB.profile.baroptions[T[k]].targetalpha = 1.0
								DB.profile.baroptions[T[k]].nontargetalpha = 1.0
							end
						end
						Scorchio2:Print("Loaded 'Modern Anchors' Preset")
					end
				},
				moderndesc = {
					type = 'description',
					name = L["(Three anchors: Targeted, Non-Targeted and Buffs. All alphas 1.0)"],
					order = 107
				},
				gaptwo = {
					type = 'description',
					name = '\n',
					width = "full",
					order = 109,
				},
				classic = {
					type = 'execute',
					name = L["Classic Anchors"],
					order = 110,
					func = function()
						for k, v in pairs(VULNERABILITIES) do
							if VULNDATA[k].self then
								DB.profile.baroptions[T[k]].targetanchor = "targeted"
								DB.profile.baroptions[T[k]].nontargetanchor = "targeted"
								DB.profile.baroptions[T[k]].targetalpha = 1.0
								DB.profile.baroptions[T[k]].nontargetalpha = 1.0
							else
								DB.profile.baroptions[T[k]].targetanchor = "targeted"
								DB.profile.baroptions[T[k]].nontargetanchor = "targeted"
								DB.profile.baroptions[T[k]].targetalpha = 1.0
								DB.profile.baroptions[T[k]].nontargetalpha = 0.2
							end
						end
						Scorchio2:Print("Loaded 'Classic Anchors' Preset")
					end
				},
				classicdesc = {
					type = 'description',
					name = L["(One anchor: Targeted. Bars of non-targeted mobs are dimmed)"],
					order = 112
				},
				gapthree = {
					type = 'description',
					name = '\n',
					width = "full",
					order = 114,
				},
				targetonly = {
					type = 'execute',
					name = L["My Target Only"],
					order = 115,
					func = function()
						for k, v in pairs(VULNERABILITIES) do
							if VULNDATA[k].self then
								DB.profile.baroptions[T[k]].targetanchor = "buffs"
								DB.profile.baroptions[T[k]].nontargetanchor = "buffs"
								DB.profile.baroptions[T[k]].targetalpha = 1.0
								DB.profile.baroptions[T[k]].nontargetalpha = 1.0
							else
								DB.profile.baroptions[T[k]].targetanchor = "targeted"
								DB.profile.baroptions[T[k]].nontargetanchor = "none"
								DB.profile.baroptions[T[k]].targetalpha = 1.0
								DB.profile.baroptions[T[k]].nontargetalpha = 1.0
							end
						end
						Scorchio2:Print("Loaded 'My Target Only' Preset")
					end
				},
				targetonlydesc = {
					type = 'description',
					name = L["(Two anchors: Targeted and Buffs. Only show debuffs on my target)"],
					order = 117
				},
				gapfour = {
					type = 'description',
					name = '\n',
					width = "full",
					order = 119,
				},
				custom = {
					type = 'execute',
					name = L["Custom Anchors"],
					desc = L["(Stores your current configuration, or restores a saved one.)"],
					order = 120,
					disabled = function()
						return not DB.profile.anchoroptions.custom
					end,
					func = function()
						for k, v in pairs(VULNERABILITIES) do
							DB.profile.baroptions[T[k]].targetanchor,
								DB.profile.baroptions[T[k]].nontargetanchor,
								DB.profile.baroptions[T[k]].targetalpha, 
								DB.profile.baroptions[T[k]].nontargetalpha = unpack(DB.profile.anchoroptions.custom[k])
						end
						Scorchio2:Print("Loaded 'Custom Anchors' Preset")
					end
				},
				customsave = {
					type = 'execute',
					name = L["Save Current"],
					desc = L["(Stores your current configuration, or restores a saved one.)"],
					order = 121,
					func = function()
						for k, v in pairs(VULNERABILITIES) do
							DB.profile.anchoroptions.custom[k] = { 
								DB.profile.baroptions[T[k]].targetanchor,
								DB.profile.baroptions[T[k]].nontargetanchor,
								DB.profile.baroptions[T[k]].targetalpha,
								DB.profile.baroptions[T[k]].nontargetalpha
							}
						end
						Scorchio2:Print("Saved 'Custom Anchors' Preset")
					end
				},
				customdesc = {
					type = 'description',
					name = L["(Stores your current configuration, or restores a saved one.)"],
					order = 124
				},
				gapfive = {
					type = 'description',
					name = '\n',
					width = "full",
					order = 125,
				},
				resetbars = {
					type = 'execute',
					name = L["Reset Anchors"],
					desc = L["Reset bars to their default positions on the screen"],
					order = 130,
					func = function()
						DB.profile.anchoroptions.targeted.position = {
							pr = "CENTER",
							p = "CENTER",
							py = -300,
							px = 0
						}
						DB.profile.anchoroptions.nontargeted.position = {
							pr = "LEFT",
							p = "LEFT",
							py = -230,
							px = 150
						}
						DB.profile.anchoroptions.buffs.position = {
							pr = "CENTER",
							p = "CENTER",
							py = 0,
							px = 0
						}
						Scorchio2:UpdateAnchors()
					end
				},
				resetdesc = {
					type = 'description',
					name = L["Reset bars to their default positions on the screen"],
					order = 131
				},
				targeted = {
					type = 'group',
					name = L["Targeted"],
					desc = L["Targeted"],
					order = 200,
					args = {
					toggle = {
						type = 'execute',
						name = L["Toggle Anchor"],
						desc = L["Shows/Hides the draggable anchor"],
						func = function()
							Scorchio2:ToggleAnchors("targeted")
						end,
					},
					test = {
						type = 'execute',
						name = L["Test"],
						desc = L["Shows test bars"],
						func = function()
							   Scorchio2:RunTest("targeted")
						end,
					},
					barwidth = {
						type = 'range',
						name = L["Width"],
						desc = L["Change the width of the bars"],
						order = 120,
						get = function()
							return DB.profile.anchoroptions.targeted.width
						end,
						set = function(info, v)
							DB.profile.anchoroptions.targeted.width = v
							Scorchio2:UpdateAnchors()                   
						end,
						min = 24,
						max = 512,
						step = 8,
					},
					barheight = {
						type = 'range',
						name = L["Height"],
						desc = L["Change the height of the bars"],
						order = 121,
						get = function()
							return DB.profile.anchoroptions.targeted.height
						end,
						set = function(info, v)
							DB.profile.anchoroptions.targeted.height = v
							Scorchio2:UpdateAnchors()
						end,
						min = 6,
						max = 64,
						step = 2,
					},
					scale = {
						type = 'range',
						name = L["Scale"],
						desc = L["Change the scale of the bars"],
						order = 122,
						min = 0.5,
						max = 2,
						get = function()
							return DB.profile.anchoroptions.targeted.scale
						end,
						set = function(info, v)
							DB.profile.anchoroptions.targeted.scale = v
							Scorchio2:UpdateAnchors()
						end
					},
					maxbars = {
						type = 'range',
						name = L["Max Bars"],
						desc = L["Maximum number of bars to show at any one time. Set to 0 to show all bars."],
						order = 123,
						min = 0,
						max = 10,
						step = 1,
						get = function()
						return DB.profile.anchoroptions.targeted.maxbars
						end,
						set = function(info, v)
						DB.profile.anchoroptions.targeted.maxbars = v
						Scorchio2:UpdateAnchors()
						end
					},
					orientation = {
						type = 'select',
						name = L["Orientation"],
						desc = L["Change which way the bars run"],
						order = 124,
						values = { [1]="Left to Right", [3]="Right to Left" },
						get = function()
						return DB.profile.anchoroptions.targeted.orientation
						end,
						set = function(info, v)
						DB.profile.anchoroptions.targeted.orientation = v
						Scorchio2:UpdateAnchors()
						end
					},
					growth = {
						type = 'toggle',
						name = L["Grow Up"],
						desc = L["If checked, bars will stack above the anchor, not below"],
						order = 125,
						get = function()
							return DB.profile.anchoroptions.targeted.growth
						end,
						set = function(info, v)
							DB.profile.anchoroptions.targeted.growth = v
							Scorchio2:UpdateAnchors()
						end
					},
					font = {
						type = 'select',
						name = L["Font"],
						desc = L["Set the bar font"],
						order = 126,
								values = SM:List("font"),
								get = function(info)
									return GetSMIndex("font", DB.profile.anchoroptions.targeted.font)
								end,
								set = function(info, v)
									DB.profile.anchoroptions.targeted.font = SM:List("font")[v]
									Scorchio2:UpdateAnchors()
								end,
							},
						fontsize = {
							type = 'range',
							name = L["Font Size"],
							desc = L["Change the font size"],
							order = 127,
							min = 7,
							max = 24,
							step = 1,
							get = function()
							return DB.profile.anchoroptions.targeted.fontsize
							end,
							set = function(info, v)
							DB.profile.anchoroptions.targeted.fontsize = v
							Scorchio2:UpdateAnchors()
							end
						},
						texture = {
							type = 'select',
								name = L["Texture"],
								desc = L["Change the texture of the bars"],
								order = 128,
								values = SM:List("statusbar"),
								get = function() 
									return GetSMIndex("statusbar", DB.profile.anchoroptions.targeted.texture) 
								end,
								set = function(info, v)
									DB.profile.anchoroptions.targeted.texture = SM:List("statusbar")[v]
									Scorchio2:UpdateAnchors()
								end,
							},
						},
					},
				nontargeted = {
					type = 'group',
					name = L["Non-Targeted"],
					desc = L["Non-Targeted"],
					order = 210,
					args = {
					toggle = {
						type = 'execute',
						name = L["Toggle Anchor"],
						desc = L["Shows/Hides the draggable anchor"],
						func = function()
							Scorchio2:ToggleAnchors("nontargeted")
						end,
					},
					test = {
						type = 'execute',
						name = L["Test"],
						desc = L["Shows test bars"],
						func = function()
							   Scorchio2:RunTest("nontargeted")
						end,
					},
					barwidth = {
						type = 'range',
						name = L["Width"],
						desc = L["Change the width of the bars"],
						order = 120,
						get = function()
							return DB.profile.anchoroptions.nontargeted.width
						end,
						set = function(info, v)
							DB.profile.anchoroptions.nontargeted.width = v
							Scorchio2:UpdateAnchors()                   
						end,
						min = 24,
						max = 512,
						step = 8,
					},
					barheight = {
						type = 'range',
						name = L["Height"],
						desc = L["Change the height of the bars"],
						order = 121,
						get = function()
							return DB.profile.anchoroptions.nontargeted.height
						end,
						set = function(info, v)
							DB.profile.anchoroptions.nontargeted.height = v
							Scorchio2:UpdateAnchors()
						end,
						min = 6,
						max = 64,
						step = 2,
					},
					scale = {
						type = 'range',
						name = L["Scale"],
						desc = L["Change the scale of the bars"],
						order = 122,
						min = 0.5,
						max = 2,
						get = function()
							return DB.profile.anchoroptions.nontargeted.scale
						end,
						set = function(info, v)
							DB.profile.anchoroptions.nontargeted.scale = v
							Scorchio2:UpdateAnchors()
						end
					},
					maxbars = {
						type = 'range',
						name = L["Max Bars"],
						desc = L["Maximum number of bars to show at any one time. Set to 0 to show all bars."],
						order = 123,
						min = 0,
						max = 10,
						step = 1,
						get = function()
						return DB.profile.anchoroptions.nontargeted.maxbars
						end,
						set = function(info, v)
						DB.profile.anchoroptions.nontargeted.maxbars = v
						Scorchio2:UpdateAnchors()
						end
					},
					orientation = {
						type = 'select',
						name = L["Orientation"],
						desc = L["Change which way the bars run"],
						order = 124,
						values = { [1]="Left to Right", [3]="Right to Left" },
						get = function()
						return DB.profile.anchoroptions.nontargeted.orientation
						end,
						set = function(info, v)
						DB.profile.anchoroptions.nontargeted.orientation = v
						Scorchio2:UpdateAnchors()
						end
					},
					growth = {
						type = 'toggle',
						name = L["Grow Up"],
						desc = L["If checked, bars will stack above the anchor, not below"],
						order = 125,
						get = function()
							return DB.profile.anchoroptions.nontargeted.growth
						end,
						set = function(info, v)
							DB.profile.anchoroptions.nontargeted.growth = v
							Scorchio2:UpdateAnchors()
						end
					},
					font = {
						type = 'select',
						name = L["Font"],
						desc = L["Set the bar font"],
						order = 126,
								values = SM:List("font"),
								get = function(info)
									return GetSMIndex("font", DB.profile.anchoroptions.nontargeted.font)
								end,
								set = function(info, v)
									DB.profile.anchoroptions.nontargeted.font = SM:List("font")[v]
									Scorchio2:UpdateAnchors()
								end,
							},
						fontsize = {
							type = 'range',
							name = L["Font Size"],
							desc = L["Change the font size"],
							order = 127,
							min = 7,
							max = 24,
							step = 1,
							get = function()
							return DB.profile.anchoroptions.nontargeted.fontsize
							end,
							set = function(info, v)
							DB.profile.anchoroptions.nontargeted.fontsize = v
							Scorchio2:UpdateAnchors()
							end
						},
						texture = {
							type = 'select',
								name = L["Texture"],
								desc = L["Change the texture of the bars"],
								order = 128,
								values = SM:List("statusbar"),
								get = function() 
									return GetSMIndex("statusbar", DB.profile.anchoroptions.nontargeted.texture) 
								end,
								set = function(info, v)
									DB.profile.anchoroptions.nontargeted.texture = SM:List("statusbar")[v]
									Scorchio2:UpdateAnchors()
								end,
							},
						},
					},
				buffs = {
					type = 'group',
					name = L["Buffs"],
					desc = L["Buffs"],
					order = 220,
					args = {
					toggle = {
						type = 'execute',
						name = L["Toggle Anchor"],
						desc = L["Shows/Hides the draggable anchor"],
						func = function()
							Scorchio2:ToggleAnchors("buffs")
						end,
					},
					test = {
						type = 'execute',
						name = L["Test"],
						desc = L["Shows test bars"],
						func = function()
							   Scorchio2:RunTest("buffs")
						end,
					},
					barwidth = {
						type = 'range',
						name = L["Width"],
						desc = L["Change the width of the bars"],
						order = 120,
						get = function()
							return DB.profile.anchoroptions.buffs.width
						end,
						set = function(info, v)
							DB.profile.anchoroptions.buffs.width = v
							Scorchio2:UpdateAnchors()                   
						end,
						min = 24,
						max = 512,
						step = 8,
					},
					barheight = {
						type = 'range',
						name = L["Height"],
						desc = L["Change the height of the bars"],
						order = 121,
						get = function()
							return DB.profile.anchoroptions.buffs.height
						end,
						set = function(info, v)
							DB.profile.anchoroptions.buffs.height = v
							Scorchio2:UpdateAnchors()
						end,
						min = 6,
						max = 64,
						step = 2,
					},
					scale = {
						type = 'range',
						name = L["Scale"],
						desc = L["Change the scale of the bars"],
						order = 122,
						min = 0.5,
						max = 2,
						get = function()
							return DB.profile.anchoroptions.buffs.scale
						end,
						set = function(info, v)
							DB.profile.anchoroptions.buffs.scale = v
							Scorchio2:UpdateAnchors()
						end
					},
					maxbars = {
						type = 'range',
						name = L["Max Bars"],
						desc = L["Maximum number of bars to show at any one time. Set to 0 to show all bars."],
						order = 123,
						min = 0,
						max = 10,
						step = 1,
						get = function()
						return DB.profile.anchoroptions.buffs.maxbars
						end,
						set = function(info, v)
						DB.profile.anchoroptions.buffs.maxbars = v
						Scorchio2:UpdateAnchors()
						end
					},
					orientation = {
						type = 'select',
						name = L["Orientation"],
						desc = L["Change which way the bars run"],
						order = 124,
						values = { [1]="Left to Right", [3]="Right to Left" },
						get = function()
						return DB.profile.anchoroptions.buffs.orientation
						end,
						set = function(info, v)
						DB.profile.anchoroptions.buffs.orientation = v
						Scorchio2:UpdateAnchors()
						end
					},
					growth = {
						type = 'toggle',
						name = L["Grow Up"],
						desc = L["If checked, bars will stack above the anchor, not below"],
						order = 125,
						get = function()
							return DB.profile.anchoroptions.buffs.growth
						end,
						set = function(info, v)
							DB.profile.anchoroptions.buffs.growth = v
							Scorchio2:UpdateAnchors()
						end
					},
					font = {
						type = 'select',
						name = L["Font"],
						desc = L["Set the bar font"],
						order = 126,
								values = SM:List("font"),
								get = function(info)
									return GetSMIndex("font", DB.profile.anchoroptions.buffs.font)
								end,
								set = function(info, v)
									DB.profile.anchoroptions.buffs.font = SM:List("font")[v]
									Scorchio2:UpdateAnchors()
								end,
							},
						fontsize = {
							type = 'range',
							name = L["Font Size"],
							desc = L["Change the font size"],
							order = 127,
							min = 7,
							max = 24,
							step = 1,
							get = function()
							return DB.profile.anchoroptions.buffs.fontsize
							end,
							set = function(info, v)
							DB.profile.anchoroptions.buffs.fontsize = v
							Scorchio2:UpdateAnchors()
							end
						},
						texture = {
							type = 'select',
								name = L["Texture"],
								desc = L["Change the texture of the bars"],
								order = 128,
								values = SM:List("statusbar"),
								get = function() 
									return GetSMIndex("statusbar", DB.profile.anchoroptions.buffs.texture) 
								end,
								set = function(info, v)
									DB.profile.anchoroptions.buffs.texture = SM:List("statusbar")[v]
									Scorchio2:UpdateAnchors()
								end,
							},
						},
					},
				},
			},
		baroptions = {
				type = 'group',
				name = "Bar Options",
				args = {
					a = {
						type = 'group',
						name = L["Scorch"],
						desc = L["Scorch"],
						args = {
							track = {
								type = 'toggle',
								name = L["Track Scorch"],
								desc = L["Track Scorch"],
								order = 100,
								width = "full",
								get = function()
									return DB.profile.baroptions.a.track
								end,
								set = function(info, v)
									DB.profile.baroptions.a.track = v
									Scorchio2:UpdateAnchors()
								end
							},                        
							show = {
								type = 'toggle',
								name = L["Show Scorch Bars"],
								desc = L["Show Scorch Bars"],
								order = 105,
								disabled = function()
									return not DB.profile.baroptions.a.track
								end,
								get = function()
									return DB.profile.baroptions.a.show
								end,
								set = function(info, v)
									DB.profile.baroptions.a.show = v
									Scorchio2:UpdateAnchors()
								end
							},
							clearooc = {
								type = 'toggle',
								name = L["Fade bars when out of combat"],
								desc = L["Fade bars when out of combat"],
								order = 107,
								disabled = function()
									return not DB.profile.baroptions.a.track
								end,
								get = function()
									return DB.profile.baroptions.a.clearooc
								end,
								set = function(info, v)
									DB.profile.baroptions.a.clearooc = v
								end
							},
							bartext = {
								type = 'input',
								name = L["Bar Text String"],
								desc = L["Enter text to appear on Scorch Bars."] .. L[" $s will be replaced by the spell stack. $m will be replaced by the mob name. Everything else will remain as-is."],
								width = "full",
								order = 110,
								disabled = function()
									return not DB.profile.baroptions.a.track
								end,
								get = function()
									return DB.profile.baroptions.a.bar
								end,
								set = function(info, v)
									DB.profile.baroptions.a.bar = v
									Scorchio2:UpdateAnchors()
								end
							},
							barcolour = {
								type = 'color',
								name = L["Bar Colour"],
								desc = L["Change bar colour"],
								order = 115,
								disabled = function()
									return not DB.profile.baroptions.a.track
								end,
								get = function(info)
									return unpack(DB.profile.baroptions.a.fg)
								end,
								set = function(info, r, g, b)
									DB.profile.baroptions.a.fg = {r, g, b}
									Scorchio2:UpdateAnchors()
								end,
								hasAlpha = false
							},
							backgroundcolour = {
								type = 'color',
								name = L["Background Colour"],
								desc = L["Change background colour"],
								order = 120,
								disabled = function()
									return not DB.profile.baroptions.a.track
								end,
								get = function(info)
									return unpack(DB.profile.baroptions.a.bg)
								end,
								set = function(info, r, g, b)
									DB.profile.baroptions.a.bg = {r, g, b}
									Scorchio2:UpdateAnchors()
								end,
								hasAlpha = false
							},
							targetanchor = {
								type = 'select',
								name = L["Target Anchor"],
								desc = L["Which Anchor to Attach Bars to When Targeted"],
								order = 121,								
								disabled = function()
									return not DB.profile.baroptions.a.track
								end,
								values = { ["targeted"]=L["Targeted"], ["nontargeted"]=L["Non-Targeted"], ["buffs"]=L["Buffs"], ["none"]=L["None"] },
								get = function()
								return DB.profile.baroptions.a.targetanchor
								end,
								set = function(info, v)
								DB.profile.baroptions.a.targetanchor = v
								Scorchio2:UpdateAnchors()
								end
							},
							nontargetanchor = {
								type = 'select',
								name = L["Non-Target Anchor"],
								desc = L["Which Anchor to Attach Bars to When NOT Targeted"],
								order = 123,								
								disabled = function()
									return not DB.profile.baroptions.a.track
								end,
								values = { ["targeted"]=L["Targeted"], ["nontargeted"]=L["Non-Targeted"], ["buffs"]=L["Buffs"], ["none"]=L["None"] },
								get = function()
								return DB.profile.baroptions.a.nontargetanchor
								end,
								set = function(info, v)
								DB.profile.baroptions.a.nontargetanchor = v
								Scorchio2:UpdateAnchors()
								end
							},
							targetalpha = {
								type = 'range',
								name = L["Target Alpha"],
								desc = L["Alpha to Apply to Bars When Targeted"],
								order = 122,
								disabled = function()
									return not DB.profile.baroptions.a.track
								end,
								get = function()
									return DB.profile.baroptions.a.targetalpha
								end,
								set = function(info, v)
									DB.profile.baroptions.a.targetalpha = v
									Scorchio2:UpdateAnchors()                   
								end,
								min = 0,
								max = 1,
								step = 0.1,
							},
							nontargetalpha = {
								type = 'range',
								name = L["Non-Target Alpha"],
								desc = L["Alpha to Apply to Bars When NOT Targeted"],
								order = 124,
								disabled = function()
									return not DB.profile.baroptions.a.track
								end,
								get = function()
									return DB.profile.baroptions.a.nontargetalpha
								end,
								set = function(info, v)
									DB.profile.baroptions.a.nontargetalpha = v
									Scorchio2:UpdateAnchors()                   
								end,
								min = 0,
								max = 1,
								step = 0.1,
							},
							showwarning = {
								type = 'toggle',
								name = L["Show Warnings"],
								desc = L["Show warning when spell is about to expire"],
								order = 125,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.a.track
								end,
								get = function()
									return DB.profile.baroptions.a.showwarning
								end,
								set = function(info, v)
									DB.profile.baroptions.a.showwarning = v
									Scorchio2:UpdateAnchors()
								end
							},
							warningtime = {
								type = 'range',
								name = L["Warning Time"],
								desc = L["Warning Time for Scorch"],
								order = 130,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.a.track
								end,
								get = function()
									return DB.profile.baroptions.a.warningtime
								end,
								set = function(info, v)
									DB.profile.baroptions.a.warningtime = v
									Scorchio2:UpdateAnchors()                   
								end,
								min = 0,
								max = 30,
								step = 1,
							},
							warningtext = {
								type = 'input',
								name = L["Warning Text String"],
								desc = L["Enter warning to appear when Improved Scorch will fade."] .. L[" $s will be replaced by the spell stack. $m will be replaced by the mob name. Everything else will remain as-is."],
								width = "full",
								order = 135,
								disabled = function()
									return not DB.profile.baroptions.a.track
								end,
								get = function()
									return DB.profile.baroptions.a.warning
								end,
								set = function(info, v)
									DB.profile.baroptions.a.warning = v
								end
							},
							showexpire = {
								type = 'toggle',
								name = L["Show Expire Notices"],
								desc = L["Show notice when spell expires"],
								order = 140,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.a.track
								end,
								get = function()
									return DB.profile.baroptions.a.showexpire
								end,
								set = function(info, v)
									DB.profile.baroptions.a.showexpire = v
									Scorchio2:UpdateAnchors()
								end
							},
							expirytext = {
								type = 'input',
								name = L["Expiry Text String"],
								desc = L["Enter warning to appear when Improved Scorch expires."] .. L[" $s will be replaced by the spell stack. $m will be replaced by the mob name. Everything else will remain as-is."],
								width = "full",
								order = 145,
								disabled = function()
									return not DB.profile.baroptions.a.track
								end,
								get = function()
									return DB.profile.baroptions.a.message
								end,
								set = function(info, v)
									DB.profile.baroptions.a.message = v
								end
							},
							on = {
								type = 'toggle',
								name = L["Toggle Sounds"],
								desc = L["Enable/Disable sounds for Scorch"],
								order = 150,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.a.track
								end,
								get = function()
									return DB.profile.baroptions.a.soundson
								end,
								set = function()
									DB.profile.baroptions.a.soundson = not DB.profile.baroptions.a.soundson
								end
							},
							warningsound = {
								type = 'select',
								name = L["Warning Sound"],
								desc = L["Change the sound played when warning time is reached"],
								order = 155,
								disabled = function()
									return not DB.profile.baroptions.a.soundson or not DB.profile.baroptions.a.track
								end,
								values = SM:List("sound"),
								get = function() 
									return GetSMIndex("sound", DB.profile.baroptions.a.warningsound)
								end,
								set = function(info, v)
									DB.profile.baroptions.a.warningsound = SM:List("sound")[v]
									PlaySoundFile(SM:Fetch("sound", DB.profile.baroptions.a.warningsound))
								end,
							},
							expiredsound = {
								type = 'select',
								name = L["Expired Sound"],
								desc = L["Change the sound played when the debuff expires"],
								order = 160,
								disabled = function()
									return not DB.profile.baroptions.a.soundson or not DB.profile.baroptions.a.track
								end,
								values = SM:List("sound"),
								get = function() 
									return GetSMIndex("sound", DB.profile.baroptions.a.expiredsound)
								end,
								set = function(info, v)
									DB.profile.baroptions.a.expiredsound = SM:List("sound")[v]
									PlaySoundFile(SM:Fetch("sound", DB.profile.baroptions.a.expiredsound))
								end,
							},
						},
					},
					b = {
						type = 'group',
						name = L["Winter's Chill"],
						desc = L["Winter's Chill"],
						args = {
							track = {
								type = 'toggle',
								name = L["Track Winter's Chill"],
								desc = L["Track Winter's Chill"],
								order = 100,
								width = "full",
								get = function()
									return DB.profile.baroptions.b.track
								end,
								set = function(info, v)
									DB.profile.baroptions.b.track = v
									Scorchio2:UpdateAnchors()
								end
							}, 
							show = {
								type = 'toggle',
								name = L["Show Winter's Chill Bars"],
								desc = L["Show Winter's Chill Bars"],
								order = 105,
								disabled = function()
									return not DB.profile.baroptions.b.track
								end,
								get = function()
									return DB.profile.baroptions.b.show
								end,
								set = function(info, v)
									DB.profile.baroptions.b.show = v
									Scorchio2:UpdateAnchors()
								end
							},
							clearooc = {
								type = 'toggle',
								name = L["Fade bars when out of combat"],
								desc = L["Fade bars when out of combat"],
								order = 107,
								disabled = function()
									return not DB.profile.baroptions.b.track
								end,
								get = function()
									return DB.profile.baroptions.b.clearooc
								end,
								set = function(info, v)
									DB.profile.baroptions.b.clearooc = v
								end
							},
							bartext = {
								type = 'input',
								name = L["Bar Text String"],
								desc = L["Enter text to appear on Winter's Chill Bars."] .. L[" $s will be replaced by the spell stack. $m will be replaced by the mob name. Everything else will remain as-is."],
								width = "full",
								order = 110,
								disabled = function()
									return not DB.profile.baroptions.b.track
								end,
								get = function()
									return DB.profile.baroptions.b.bar
								end,
								set = function(info, v)
									DB.profile.baroptions.b.bar = v
									Scorchio2:UpdateAnchors()
								end
							},
							barcolour = {
								type = 'color',
								name = L["Bar Colour"],
								desc = L["Change bar colour"],
								order = 115,
								disabled = function()
									return not DB.profile.baroptions.b.track
								end,
								get = function(info)
									return unpack(DB.profile.baroptions.b.fg)
								end,
								set = function(info, r, g, b)
									DB.profile.baroptions.b.fg = {r, g, b}
									Scorchio2:UpdateAnchors()
								end,
								hasAlpha = false
							},
							backgroundcolour = {
								type = 'color',
								name = L["Background Colour"],
								desc = L["Change background colour"],
								order = 120,
								disabled = function()
									return not DB.profile.baroptions.b.track
								end,
								get = function(info)
									return unpack(DB.profile.baroptions.b.bg)
								end,
								set = function(info, r, g, b)
									DB.profile.baroptions.b.bg = {r, g, b}
									Scorchio2:UpdateAnchors()
								end,
								hasAlpha = false
							},
							targetanchor = {
								type = 'select',
								name = L["Target Anchor"],
								desc = L["Which Anchor to Attach Bars to When Targeted"],
								order = 121,
								values = { ["targeted"]=L["Targeted"], ["nontargeted"]=L["Non-Targeted"], ["buffs"]=L["Buffs"], ["none"]=L["None"] },
								get = function()
								return DB.profile.baroptions.b.targetanchor
								end,
								set = function(info, v)
								DB.profile.baroptions.b.targetanchor = v
								Scorchio2:UpdateAnchors()
								end
							},
							nontargetanchor = {
								type = 'select',
								name = L["Non-Target Anchor"],
								desc = L["Which Anchor to Attach Bars to When NOT Targeted"],
								order = 123,
								values = { ["targeted"]=L["Targeted"], ["nontargeted"]=L["Non-Targeted"], ["buffs"]=L["Buffs"], ["none"]=L["None"] },
								get = function()
								return DB.profile.baroptions.b.nontargetanchor
								end,
								set = function(info, v)
								DB.profile.baroptions.b.nontargetanchor = v
								Scorchio2:UpdateAnchors()
								end
							},
							targetalpha = {
								type = 'range',
								name = L["Target Alpha"],
								desc = L["Alpha to Apply to Bars When Targeted"],
								order = 122,
								disabled = function()
									return not DB.profile.baroptions.b.track
								end,
								get = function()
									return DB.profile.baroptions.b.targetalpha
								end,
								set = function(info, v)
									DB.profile.baroptions.b.targetalpha = v
									Scorchio2:UpdateAnchors()                   
								end,
								min = 0,
								max = 1,
								step = 0.1,
							},
							nontargetalpha = {
								type = 'range',
								name = L["Non-Target Alpha"],
								desc = L["Alpha to Apply to Bars When NOT Targeted"],
								order = 124,
								disabled = function()
									return not DB.profile.baroptions.b.track
								end,
								get = function()
									return DB.profile.baroptions.b.nontargetalpha
								end,
								set = function(info, v)
									DB.profile.baroptions.b.nontargetalpha = v
									Scorchio2:UpdateAnchors()                   
								end,
								min = 0,
								max = 1,
								step = 0.1,
							},
							showwarning = {
								type = 'toggle',
								name = L["Show Warnings"],
								desc = L["Show warning when spell is about to expire"],
								order = 125,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.b.track
								end,
								get = function()
									return DB.profile.baroptions.b.showwarning
								end,
								set = function(info, v)
									DB.profile.baroptions.b.showwarning = v
									Scorchio2:UpdateAnchors()
								end
							},
							warningtime = {
								type = 'range',
								name = L["Warning Time"],
								desc = L["Warning Time for Winter's Chill"],
								order = 130,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.b.track
								end,
								get = function()
									return DB.profile.baroptions.b.warningtime
								end,
								set = function(info, v)
									DB.profile.baroptions.b.warningtime = v
									Scorchio2:UpdateAnchors()                   
								end,
								min = 0,
								max = 30,
								step = 1,
							},
							warningtext = {
								type = 'input',
								name = L["Warning Text String"],
								desc = L["Enter warning to appear when Winter's Chill will fade."] .. L[" $s will be replaced by the spell stack. $m will be replaced by the mob name. Everything else will remain as-is."],
								width = "full",
								order = 135,
								disabled = function()
									return not DB.profile.baroptions.b.track
								end,
								get = function()
									return DB.profile.baroptions.b.warning
								end,
								set = function(info, v)
									DB.profile.baroptions.b.warning = v
								end
							},
							showexpire = {
								type = 'toggle',
								name = L["Show Expire Notices"],
								desc = L["Show notice when spell expires"],
								order = 140,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.b.track
								end,
								get = function()
									return DB.profile.baroptions.b.showexpire
								end,
								set = function(info, v)
									DB.profile.baroptions.b.showexpire = v
									Scorchio2:UpdateAnchors()
								end
							},
							expirytext = {
								type = 'input',
								name = L["Expiry Text String"],
								desc = L["Enter message to appear when Winter's Chill expires."] .. L[" $s will be replaced by the spell stack. $m will be replaced by the mob name. Everything else will remain as-is."],
								width = "full",
								order = 145,
								disabled = function()
									return not DB.profile.baroptions.b.track
								end,
								get = function()
									return DB.profile.baroptions.b.message
								end,
								set = function(info, v)
									DB.profile.baroptions.b.message = v
								end
							},
							on = {
								type = 'toggle',
								name = L["Toggle Sounds"],
								desc = L["Enable/Disable sounds for Winter's Chill"],
								order = 150,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.b.track
								end,
								get = function()
									return DB.profile.baroptions.b.soundson
								end,
								set = function()
									DB.profile.baroptions.b.soundson = not DB.profile.baroptions.b.soundson
								end
							},
							warningsound = {
								type = 'select',
								name = L["Warning Sound"],
								desc = L["Change the sound played when warning time is reached"],
								order = 155,
								disabled = function()
									return not DB.profile.baroptions.b.soundson or not DB.profile.baroptions.b.track
								end,
								values = SM:List("sound"),
								get = function() 
									return GetSMIndex("sound", DB.profile.baroptions.b.warningsound)
								end,
								set = function(info, v)
									DB.profile.baroptions.b.warningsound = SM:List("sound")[v]
									PlaySoundFile(SM:Fetch("sound", DB.profile.baroptions.b.warningsound))
								end,
							},
							expiredsound = {
								type = 'select',
								name = L["Expired Sound"],
								desc = L["Change the sound played when the debuff expires"],
								order = 160,
								disabled = function()
									return not DB.profile.baroptions.b.soundson or not DB.profile.baroptions.b.track
								end,
								values = SM:List("sound"),
								get = function() 
									return GetSMIndex("sound", DB.profile.baroptions.b.expiredsound)
								end,
								set = function(info, v)
									DB.profile.baroptions.b.expiredsound = SM:List("sound")[v]
									PlaySoundFile(SM:Fetch("sound", DB.profile.baroptions.b.expiredsound))
								end,
							},
						},
					},
					c = {
						type = 'group',
						name = L["Living Bomb"],
						desc = L["Living Bomb"],
						args = {
							track = {
								type = 'toggle',
								name = L["Track Living Bomb"],
								desc = L["Track Living Bomb"],
								order = 100,
								width = "full",
								get = function()
									return DB.profile.baroptions.c.track
								end,
								set = function(info, v)
									DB.profile.baroptions.c.track = v
									Scorchio2:UpdateAnchors()
								end
							}, 
							show = {
								type = 'toggle',
								name = L["Show Living Bomb Bars"],
								desc = L["Show Living Bomb Bars"],
								order = 105,
								disabled = function()
									return not DB.profile.baroptions.c.track
								end,
								get = function()
									return DB.profile.baroptions.c.show
								end,
								set = function(info, v)
									DB.profile.baroptions.c.show = v
									Scorchio2:UpdateAnchors()
								end
							},
							clearooc = {
								type = 'toggle',
								name = L["Fade bars when out of combat"],
								desc = L["Fade bars when out of combat"],
								order = 107,
								disabled = function()
									return not DB.profile.baroptions.c.track
								end,
								get = function()
									return DB.profile.baroptions.c.clearooc
								end,
								set = function(info, v)
									DB.profile.baroptions.c.clearooc = v
								end
							},
							bartext = {
								type = 'input',
								name = L["Bar Text String"],
								desc = L["Enter text to appear on Living Bomb Bars."] .. L[" $s will be replaced by the spell stack. $m will be replaced by the mob name. Everything else will remain as-is."],
								width = "full",
								order = 110,
								disabled = function()
									return not DB.profile.baroptions.c.track
								end,
								get = function()
									return DB.profile.baroptions.c.bar
								end,
								set = function(info, v)
									DB.profile.baroptions.c.bar = v
									Scorchio2:UpdateAnchors()
								end
							},
							barcolour = {
								type = 'color',
								name = L["Bar Colour"],
								desc = L["Change bar colour"],
								order = 112,
								disabled = function()
									return not DB.profile.baroptions.c.track
								end,
								get = function(info)
									return unpack(DB.profile.baroptions.c.fg)
								end,
								set = function(info, r, g, b)
									DB.profile.baroptions.c.fg = {r, g, b}
									Scorchio2:UpdateAnchors()
								end,
								hasAlpha = false
							},
							backgroundcolour = {
								type = 'color',
								name = L["Background Colour"],
								desc = L["Change background colour"],
								order = 113,
								disabled = function()
									return not DB.profile.baroptions.c.track
								end,
								get = function(info)
									return unpack(DB.profile.baroptions.c.bg)
								end,
								set = function(info, r, g, b)
									DB.profile.baroptions.c.bg = {r, g, b}
									Scorchio2:UpdateAnchors()
								end,
								hasAlpha = false
							},
							targetanchor = {
								type = 'select',
								name = L["Target Anchor"],
								desc = L["Which Anchor to Attach Bars to When Targeted"],
								order = 115,
								disabled = function()
									return not DB.profile.baroptions.c.track
								end,
								values = { ["targeted"]=L["Targeted"], ["nontargeted"]=L["Non-Targeted"], ["buffs"]=L["Buffs"], ["none"]=L["None"] },
								get = function()
								return DB.profile.baroptions.c.targetanchor
								end,
								set = function(info, v)
								DB.profile.baroptions.c.targetanchor = v
								Scorchio2:UpdateAnchors()
								end
							},
							nontargetanchor = {
								type = 'select',
								name = L["Non-Target Anchor"],
								desc = L["Which Anchor to Attach Bars to When NOT Targeted"],
								order = 117,
								disabled = function()
									return not DB.profile.baroptions.c.track
								end,
								values = { ["targeted"]=L["Targeted"], ["nontargeted"]=L["Non-Targeted"], ["buffs"]=L["Buffs"], ["none"]=L["None"] },
								get = function()
								return DB.profile.baroptions.c.nontargetanchor
								end,
								set = function(info, v)
								DB.profile.baroptions.c.nontargetanchor = v
								Scorchio2:UpdateAnchors()
								end
							},
							targetalpha = {
								type = 'range',
								name = L["Target Alpha"],
								desc = L["Alpha to Apply to Bars When Targeted"],
								order = 116,
								disabled = function()
									return not DB.profile.baroptions.c.track
								end,
								get = function()
									return DB.profile.baroptions.c.targetalpha
								end,
								set = function(info, v)
									DB.profile.baroptions.c.targetalpha = v
									Scorchio2:UpdateAnchors()                   
								end,
								min = 0,
								max = 1,
								step = 0.1,
							},
							nontargetalpha = {
								type = 'range',
								name = L["Non-Target Alpha"],
								desc = L["Alpha to Apply to Bars When NOT Targeted"],
								order = 118,
								disabled = function()
									return not DB.profile.baroptions.c.track
								end,
								get = function()
									return DB.profile.baroptions.c.nontargetalpha
								end,
								set = function(info, v)
									DB.profile.baroptions.c.nontargetalpha = v
									Scorchio2:UpdateAnchors()                   
								end,
								min = 0,
								max = 1,
								step = 0.1,
							},
							showwarning = {
								type = 'toggle',
								name = L["Show Warnings"],
								desc = L["Show warning when spell is about to expire"],
								order = 119,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.c.track
								end,
								get = function()
									return DB.profile.baroptions.c.showwarning
								end,
								set = function(info, v)
									DB.profile.baroptions.c.showwarning = v
									Scorchio2:UpdateAnchors()
								end
							},  
							warningtime = {
								type = 'range',
								name = L["Warning Time"],
								desc = L["Warning Time for Living Bomb"],
								order = 120,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.c.track
								end,
								get = function()
									return DB.profile.baroptions.c.warningtime
								end,
								set = function(info, v)
									DB.profile.baroptions.c.warningtime = v
									Scorchio2:UpdateAnchors()                   
								end,
								min = 0,
								max = 12,
								step = 1,
							},
							warningtext = {
								type = 'input',
								name = L["Warning Text String"],
								desc = L["Enter warning to appear when Living Bomb is about to go off."] .. L[" $s will be replaced by the spell stack. $m will be replaced by the mob name. Everything else will remain as-is."],
								width = "full",
								order = 125,
								disabled = function()
									return not DB.profile.baroptions.c.track
								end,
								get = function()
									return DB.profile.baroptions.c.warning
								end,
								set = function(info, v)
									DB.profile.baroptions.c.warning = v
								end
							},
							showexpire = {
								type = 'toggle',
								name = L["Show Expire Notices"],
								desc = L["Show notice when spell expires"],
								order = 130,
								disabled = function()
									return not DB.profile.baroptions.c.track
								end,
								get = function()
									return DB.profile.baroptions.c.showexpire
								end,
								set = function(info, v)
									DB.profile.baroptions.c.showexpire = v
									Scorchio2:UpdateAnchors()
								end
							},
							expirytext = {
								type = 'input',
								name = L["Expiry Text String"],
								desc = L["Enter message to appear when Living Bomb explodes."] .. L[" $s will be replaced by the spell stack. $m will be replaced by the mob name. Everything else will remain as-is."],
								width = "full",
								order = 135,
								disabled = function()
									return not DB.profile.baroptions.c.track
								end,
								get = function()
									return DB.profile.baroptions.c.message
								end,
								set = function(info, v)
									DB.profile.baroptions.c.message = v
								end
							},
							on = {
								type = 'toggle',
								name = L["Toggle Sounds"],
								desc = L["Enable/Disable sounds for Living Bomb"],
								order = 140,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.c.track
								end,
								get = function()
									return DB.profile.baroptions.c.soundson
								end,
								set = function()
									DB.profile.baroptions.c.soundson = not DB.profile.baroptions.c.soundson
								end
							},
							warningsound = {
								type = 'select',
								name = L["Warning Sound"],
								desc = L["Change the sound played when warning time is reached"],
								order = 145,
								disabled = function()
									return not DB.profile.baroptions.c.soundson or not DB.profile.baroptions.c.track
								end,
								values = SM:List("sound"),
								get = function() 
									return GetSMIndex("sound", DB.profile.baroptions.c.warningsound)
								end,
								set = function(info, v)
									DB.profile.baroptions.c.warningsound = SM:List("sound")[v]
									PlaySoundFile(SM:Fetch("sound", DB.profile.baroptions.c.warningsound))
								end,
							},
							expiredsound = {
								type = 'select',
								name = L["Expired Sound"],
								desc = L["Change the sound played when the debuff expires"],
								order = 150,
								disabled = function()
									return not DB.profile.baroptions.c.soundson or not DB.profile.baroptions.c.track
								end,
								values = SM:List("sound"),
								get = function() 
									return GetSMIndex("sound", DB.profile.baroptions.c.expiredsound)
								end,
								set = function(info, v)
									DB.profile.baroptions.c.expiredsound = SM:List("sound")[v]
									PlaySoundFile(SM:Fetch("sound", DB.profile.baroptions.c.expiredsound))
								end,
							}, 
						},
					},
					d = {
						type = 'group',
						name = L["Polymorph"],
						desc = L["Polymorph"],
						args = {
							track = {
								type = 'toggle',
								name = L["Track Polymorph"],
								desc = L["Track Polymorph"],
								order = 100,
								width = "full",
								get = function()
									return DB.profile.baroptions.d.track
								end,
								set = function(info, v)
									DB.profile.baroptions.d.track = v
									Scorchio2:UpdateAnchors()
								end
							}, 
							show = {
								type = 'toggle',
								name = L["Show Polymorph Bars"],
								desc = L["Show Polymorph Bars"],
								order = 105,
								disabled = function()
									return not DB.profile.baroptions.d.track
								end,
								get = function()
									return DB.profile.baroptions.d.show
								end,
								set = function(info, v)
									DB.profile.baroptions.d.show = v
									Scorchio2:UpdateAnchors()
								end
							},
							clearooc = {
								type = 'toggle',
								name = L["Fade bars when out of combat"],
								desc = L["Fade bars when out of combat"],
								order = 107,
								disabled = function()
									return not DB.profile.baroptions.d.track
								end,
								get = function()
									return DB.profile.baroptions.d.clearooc
								end,
								set = function(info, v)
									DB.profile.baroptions.d.clearooc = v
								end
							},
							bartext = {
								type = 'input',
								name = L["Bar Text String"],
								desc = L["Enter text to appear on Polymorph Bars."].. L[" $s will be replaced by the spell stack. $m will be replaced by the mob name. Everything else will remain as-is."],
								width = "full",
								order = 110,
								disabled = function()
									return not DB.profile.baroptions.d.track
								end,
								get = function()
									return DB.profile.baroptions.d.bar
								end,
								set = function(info, v)
									DB.profile.baroptions.d.bar = v
									Scorchio2:UpdateAnchors()
								end
							},
							barcolour = {
								type = 'color',
								name = L["Bar Colour"],
								desc = L["Change bar colour"],
								order = 115,
								disabled = function()
									return not DB.profile.baroptions.d.track
								end,
								get = function(info)
									return unpack(DB.profile.baroptions.d.fg)
								end,
								set = function(info, r, g, b)
									DB.profile.baroptions.d.fg = {r, g, b}
									Scorchio2:UpdateAnchors()
								end,
								hasAlpha = false
							},
							backgroundcolour = {
								type = 'color',
								name = L["Background Colour"],
								desc = L["Change background colour"],
								order = 120,
								disabled = function()
									return not DB.profile.baroptions.d.track
								end,
								get = function(info)
									return unpack(DB.profile.baroptions.d.bg)
								end,
								set = function(info, r, g, b)
									DB.profile.baroptions.d.bg = {r, g, b}
									Scorchio2:UpdateAnchors()
								end,
								hasAlpha = false
							},
							targetanchor = {
								type = 'select',
								name = L["Target Anchor"],
								desc = L["Which Anchor to Attach Bars to When Targeted"],
								order = 121,
								values = { ["targeted"]=L["Targeted"], ["nontargeted"]=L["Non-Targeted"], ["buffs"]=L["Buffs"], ["none"]=L["None"] },
								get = function()
								return DB.profile.baroptions.d.targetanchor
								end,
								set = function(info, v)
								DB.profile.baroptions.d.targetanchor = v
								Scorchio2:UpdateAnchors()
								end
							},
							nontargetanchor = {
								type = 'select',
								name = L["Non-Target Anchor"],
								desc = L["Which Anchor to Attach Bars to When NOT Targeted"],
								order = 123,
								values = { ["targeted"]=L["Targeted"], ["nontargeted"]=L["Non-Targeted"], ["buffs"]=L["Buffs"], ["none"]=L["None"] },
								get = function()
								return DB.profile.baroptions.d.nontargetanchor
								end,
								set = function(info, v)
								DB.profile.baroptions.d.nontargetanchor = v
								Scorchio2:UpdateAnchors()
								end
							},
							targetalpha = {
								type = 'range',
								name = L["Target Alpha"],
								desc = L["Alpha to Apply to Bars When Targeted"],
								order = 122,
								disabled = function()
									return not DB.profile.baroptions.d.track
								end,
								get = function()
									return DB.profile.baroptions.d.targetalpha
								end,
								set = function(info, v)
									DB.profile.baroptions.d.targetalpha = v
									Scorchio2:UpdateAnchors()                   
								end,
								min = 0,
								max = 1,
								step = 0.1,
							},
							nontargetalpha = {
								type = 'range',
								name = L["Non-Target Alpha"],
								desc = L["Alpha to Apply to Bars When NOT Targeted"],
								order = 124,
								disabled = function()
									return not DB.profile.baroptions.d.track
								end,
								get = function()
									return DB.profile.baroptions.d.nontargetalpha
								end,
								set = function(info, v)
									DB.profile.baroptions.d.nontargetalpha = v
									Scorchio2:UpdateAnchors()                   
								end,
								min = 0,
								max = 1,
								step = 0.1,
							},
							showwarning = {
								type = 'toggle',
								name = L["Show Warnings"],
								desc = L["Show warning when spell is about to expire"],
								order = 125,
								disabled = function()
									return not DB.profile.baroptions.d.track
								end,
								get = function()
									return DB.profile.baroptions.d.showwarning
								end,
								set = function(info, v)
									DB.profile.baroptions.d.showwarning = v
									Scorchio2:UpdateAnchors()
								end
							},
							telltale = {
								type = 'toggle',
								name = L["Show Who Broke Polymorph"],
								desc = L["Show Who Broke Polymorph"],
								order = 127,
								disabled = function()
									return not DB.profile.baroptions.d.track
								end,
								get = function()
									return DB.profile.baroptions.d.telltale
								end,
								set = function(info, v)
									DB.profile.baroptions.d.telltale = v
									Scorchio2:UpdateAnchors()
								end
							},
							warningtime = {
								type = 'range',
								name = L["Warning Time"],
								desc = L["Warning Time for Polymorph"],
								order = 130,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.d.track
								end,
								get = function()
									return DB.profile.baroptions.d.warningtime
								end,
								set = function(info, v)
									DB.profile.baroptions.d.warningtime = v
									Scorchio2:UpdateAnchors()                   
								end,
								min = 0,
								max = 12,
								step = 1,
							},
							warningtext = {
								type = 'input',
								name = L["Warning Text String"],
								desc = L["Enter warning to appear when Polymorph is about to break."] .. L[" $s will be replaced by the spell stack. $m will be replaced by the mob name. Everything else will remain as-is."],
								width = "full",
								order = 135,
								disabled = function()
									return not DB.profile.baroptions.d.track
								end,
								get = function()
									return DB.profile.baroptions.d.warning
								end,
								set = function(info, v)
									DB.profile.baroptions.d.warning = v
								end
							},
							showexpire = {
								type = 'toggle',
								name = L["Show Expire Notices"],
								desc = L["Show notice when spell expires"],
								order = 140,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.d.track
								end,
								get = function()
									return DB.profile.baroptions.d.showexpire
								end,
								set = function(info, v)
									DB.profile.baroptions.d.showexpire = v
									Scorchio2:UpdateAnchors()
								end
							},
							expirytext = {
								type = 'input',
								name = L["Expiry Text String"],
								desc = L["Enter message to appear when Polymorph breaks."] .. L[" $s will be replaced by the spell stack. $m will be replaced by the mob name. Everything else will remain as-is."],
								width = "full",
								order = 145,
								disabled = function()
									return not DB.profile.baroptions.d.track
								end,
								get = function()
									return DB.profile.baroptions.d.message
								end,
								set = function(info, v)
									DB.profile.baroptions.d.message = v
								end
							},
							on = {
								type = 'toggle',
								name = L["Toggle Sounds"],
								desc = L["Enable/Disable sounds for Polymorph"],
								order = 150,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.d.track
								end,
								get = function()
									return DB.profile.baroptions.d.soundson
								end,
								set = function()
									DB.profile.baroptions.d.soundson = not DB.profile.baroptions.d.soundson
								end
							},
							warningsound = {
								type = 'select',
								name = L["Warning Sound"],
								desc = L["Change the sound played when warning time is reached"],
								order = 155,
								disabled = function()
									return not DB.profile.baroptions.d.soundson or not DB.profile.baroptions.d.track
								end,
								values = SM:List("sound"),
								get = function() 
									return GetSMIndex("sound", DB.profile.baroptions.d.warningsound)
								end,
								set = function(info, v)
									DB.profile.baroptions.d.warningsound = SM:List("sound")[v]
									PlaySoundFile(SM:Fetch("sound", DB.profile.baroptions.d.warningsound))
								end,
							},
							expiredsound = {
								type = 'select',
								name = L["Expired Sound"],
								desc = L["Change the sound played when the debuff expires"],
								order = 160,
								disabled = function()
									return not DB.profile.baroptions.d.soundson or not DB.profile.baroptions.d.track
								end,
								values = SM:List("sound"),
								get = function() 
									return GetSMIndex("sound", DB.profile.baroptions.d.expiredsound)
								end,
								set = function(info, v)
									DB.profile.baroptions.d.expiredsound = SM:List("sound")[v]
									PlaySoundFile(SM:Fetch("sound", DB.profile.baroptions.d.expiredsound))
								end,
							},
						},
					},
					e = {
						type = 'group',
						name = L["Slow"],
						desc = L["Slow"],
						args = {
							track = {
								type = 'toggle',
								name = L["Track Slow"],
								desc = L["Track Slow"],
								order = 100,
								width = "full",
								get = function()
									return DB.profile.baroptions.e.track
								end,
								set = function(info, v)
									DB.profile.baroptions.e.track = v
									Scorchio2:UpdateAnchors()
								end
							}, 
							show = {
								type = 'toggle',
								name = L["Show Slow Bars"],
								desc = L["Show Slow Bars"],
								order = 105,
								disabled = function()
									return not DB.profile.baroptions.e.track
								end,
								get = function()
									return DB.profile.baroptions.e.show
								end,
								set = function(info, v)
									DB.profile.baroptions.e.show = v
									Scorchio2:UpdateAnchors()
								end
							},
							clearooc = {
								type = 'toggle',
								name = L["Fade bars when out of combat"],
								desc = L["Fade bars when out of combat"],
								order = 107,
								disabled = function()
									return not DB.profile.baroptions.e.track
								end,
								get = function()
									return DB.profile.baroptions.e.clearooc
								end,
								set = function(info, v)
									DB.profile.baroptions.e.clearooc = v
								end
							},
							bartext = {
								type = 'input',
								name = L["Bar Text String"],
								desc = L["Enter text to appear on Slow Bars."] .. L[" $s will be replaced by the spell stack. $m will be replaced by the mob name. Everything else will remain as-is."],
								width = "full",
								order = 110,
								disabled = function()
									return not DB.profile.baroptions.e.track
								end,
								get = function()
									return DB.profile.baroptions.e.bar
								end,
								set = function(info, v)
									DB.profile.baroptions.e.bar = v
									Scorchio2:UpdateAnchors()
								end
							},
							barcolour = {
								type = 'color',
								name = L["Bar Colour"],
								desc = L["Change bar colour"],
								order = 115,
								disabled = function()
									return not DB.profile.baroptions.e.track
								end,
								get = function(info)
									return unpack(DB.profile.baroptions.e.fg)
								end,
								set = function(info, r, g, b)
									DB.profile.baroptions.e.fg = {r, g, b}
									Scorchio2:UpdateAnchors()
								end,
								hasAlpha = false
							},
							backgroundcolour = {
								type = 'color',
								name = L["Background Colour"],
								desc = L["Change background colour"],
								order = 120,
								disabled = function()
									return not DB.profile.baroptions.e.track
								end,
								get = function(info)
									return unpack(DB.profile.baroptions.e.bg)
								end,
								set = function(info, r, g, b)
									DB.profile.baroptions.e.bg = {r, g, b}
									Scorchio2:UpdateAnchors()
								end,
								hasAlpha = false
							}, 
							targetanchor = {
								type = 'select',
								name = L["Target Anchor"],
								desc = L["Which Anchor to Attach Bars to When Targeted"],
								order = 121,
								values = { ["targeted"]=L["Targeted"], ["nontargeted"]=L["Non-Targeted"], ["buffs"]=L["Buffs"], ["none"]=L["None"] },
								get = function()
								return DB.profile.baroptions.e.targetanchor
								end,
								set = function(info, v)
								DB.profile.baroptions.e.targetanchor = v
								Scorchio2:UpdateAnchors()
								end
							},
							nontargetanchor = {
								type = 'select',
								name = L["Non-Target Anchor"],
								desc = L["Which Anchor to Attach Bars to When NOT Targeted"],
								order = 123,
								values = { ["targeted"]=L["Targeted"], ["nontargeted"]=L["Non-Targeted"], ["buffs"]=L["Buffs"], ["none"]=L["None"] },
								get = function()
								return DB.profile.baroptions.e.nontargetanchor
								end,
								set = function(info, v)
								DB.profile.baroptions.e.nontargetanchor = v
								Scorchio2:UpdateAnchors()
								end
							},
							targetalpha = {
								type = 'range',
								name = L["Target Alpha"],
								desc = L["Alpha to Apply to Bars When Targeted"],
								order = 122,
								disabled = function()
									return not DB.profile.baroptions.e.track
								end,
								get = function()
									return DB.profile.baroptions.e.targetalpha
								end,
								set = function(info, v)
									DB.profile.baroptions.e.targetalpha = v
									Scorchio2:UpdateAnchors()                   
								end,
								min = 0,
								max = 1,
								step = 0.1,
							},
							nontargetalpha = {
								type = 'range',
								name = L["Non-Target Alpha"],
								desc = L["Alpha to Apply to Bars When NOT Targeted"],
								order = 124,
								disabled = function()
									return not DB.profile.baroptions.e.track
								end,
								get = function()
									return DB.profile.baroptions.e.nontargetalpha
								end,
								set = function(info, v)
									DB.profile.baroptions.e.nontargetalpha = v
									Scorchio2:UpdateAnchors()                   
								end,
								min = 0,
								max = 1,
								step = 0.1,
							},
							showwarning = {
								type = 'toggle',
								name = L["Show Warnings"],
								desc = L["Show warning when spell is about to expire"],
								order = 125,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.e.track
								end,
								get = function()
									return DB.profile.baroptions.e.showwarning
								end,
								set = function(info, v)
									DB.profile.baroptions.e.showwarning = v
									Scorchio2:UpdateAnchors()
								end
							},
							warningtime = {
								type = 'range',
								name = L["Warning Time"],
								desc = L["Warning Time for Slow"],
								order = 130,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.e.track
								end,
								get = function()
									return DB.profile.baroptions.e.warningtime
								end,
								set = function(info, v)
									DB.profile.baroptions.e.warningtime = v
									Scorchio2:UpdateAnchors()                   
								end,
								min = 0,
								max = 12,
								step = 1,
							},
							warningtext = {
								type = 'input',
								name = L["Warning Text String"],
								desc = L["Enter warning to appear when Slow is about to expire."] .. L[" $s will be replaced by the spell stack. $m will be replaced by the mob name. Everything else will remain as-is."],
								width = "full",
								order = 135,
								disabled = function()
									return not DB.profile.baroptions.e.track
								end,
								get = function()
									return DB.profile.baroptions.e.warning
								end,
								set = function(info, v)
									DB.profile.baroptions.e.warning = v
								end
							},
							showexpire = {
								type = 'toggle',
								name = L["Show Expire Notices"],
								desc = L["Show notice when spell expires"],
								order = 140,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.e.track
								end,
								get = function()
									return DB.profile.baroptions.e.showexpire
								end,
								set = function(info, v)
									DB.profile.baroptions.e.showexpire = v
									Scorchio2:UpdateAnchors()
								end
							},
							expirytext = {
								type = 'input',
								name = L["Expiry Text String"],
								desc = L["Enter message to appear when Slow expires."] .. L[" $s will be replaced by the spell stack. $m will be replaced by the mob name. Everything else will remain as-is."],
								width = "full",
								order = 145,
								disabled = function()
									return not DB.profile.baroptions.e.track
								end,
								get = function()
									return DB.profile.baroptions.e.message
								end,
								set = function(info, v)
									DB.profile.baroptions.e.message = v
								end
							},
							on = {
								type = 'toggle',
								name = L["Toggle Sounds"],
								desc = L["Enable/Disable sounds for Slow"],
								order = 150,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.e.track
								end,
								get = function()
									return DB.profile.baroptions.e.soundson
								end,
								set = function()
									DB.profile.baroptions.e.soundson = not DB.profile.baroptions.e.soundson
								end
							},
							warningsound = {
								type = 'select',
								name = L["Warning Sound"],
								desc = L["Change the sound played when warning time is reached"],
								order =155,
								disabled = function()
									return not DB.profile.baroptions.e.soundson or not DB.profile.baroptions.e.track
								end,
								values = SM:List("sound"),
								get = function() 
									return GetSMIndex("sound", DB.profile.baroptions.e.warningsound)
								end,
								set = function(info, v)
									DB.profile.baroptions.e.warningsound = SM:List("sound")[v]
									PlaySoundFile(SM:Fetch("sound", DB.profile.baroptions.e.warningsound))
								end,
							},
							expiredsound = {
								type = 'select',
								name = L["Expired Sound"],
								desc = L["Change the sound played when the debuff expires"],
								order = 160,
								disabled = function()
									return not DB.profile.baroptions.e.soundson or not DB.profile.baroptions.e.track
								end,
								values = SM:List("sound"),
								get = function() 
									return GetSMIndex("sound", DB.profile.baroptions.e.expiredsound)
								end,
								set = function(info, v)
									DB.profile.baroptions.e.expiredsound = SM:List("sound")[v]
									PlaySoundFile(SM:Fetch("sound", DB.profile.baroptions.e.expiredsound))
								end,
							},
						},
					},
					f = {
						type = 'group',
						name = L["Hot Streak"],
						desc = L["Hot Streak"],
						args = {
							track = {
								type = 'toggle',
								name = L["Track Hot Streak"],
								desc = L["Track Hot Streak"],
								order = 100,
								width = "full",
								get = function()
									return DB.profile.baroptions.f.track
								end,
								set = function(info, v)
									DB.profile.baroptions.f.track = v
									Scorchio2:UpdateAnchors()
								end
							}, 
							show = {
								type = 'toggle',
								name = L["Show Hot Streak Bar"],
								desc = L["Show Hot Streak Bar"],
								order = 105,
								disabled = function()
									return not DB.profile.baroptions.f.track
								end,
								get = function()
									return DB.profile.baroptions.f.show
								end,
								set = function(info, v)
									DB.profile.baroptions.f.show = v
									Scorchio2:UpdateAnchors()
								end
							},
							clearooc = {
								type = 'toggle',
								name = L["Fade bars when out of combat"],
								desc = L["Fade bars when out of combat"],
								order = 107,
								disabled = function()
									return not DB.profile.baroptions.f.track
								end,
								get = function()
									return DB.profile.baroptions.f.clearooc
								end,
								set = function(info, v)
									DB.profile.baroptions.f.clearooc = v
								end
							},
							bartext = {
								type = 'input',
								name = L["Bar Text String"],
								desc = L["Enter text to appear on Hot Streak bars."],
								width = "full",
								order = 110,
								disabled = function()
									return not DB.profile.baroptions.f.track
								end,
								get = function()
									return DB.profile.baroptions.f.bar
								end,
								set = function(info, v)
									DB.profile.baroptions.f.bar = v
									Scorchio2:UpdateAnchors()
								end
							},
							barcolour = {
								type = 'color',
								name = L["Bar Colour"],
								desc = L["Change bar colour"],
								order = 115,
								disabled = function()
									return not DB.profile.baroptions.f.track
								end,
								get = function(info)
									return unpack(DB.profile.baroptions.f.fg)
								end,
								set = function(info, r, g, b)
									DB.profile.baroptions.f.fg = {r, g, b}
									Scorchio2:UpdateAnchors()
								end,
								hasAlpha = false
							},
							backgroundcolour = {
								type = 'color',
								name = L["Background Colour"],
								desc = L["Change background colour"],
								order = 120,
								disabled = function()
									return not DB.profile.baroptions.f.track
								end,
								get = function(info)
									return unpack(DB.profile.baroptions.f.bg)
								end,
								set = function(info, r, g, b)
									DB.profile.baroptions.f.bg = {r, g, b}
									Scorchio2:UpdateAnchors()
								end,
								hasAlpha = false
							},
							targetanchor = {
								type = 'select',
								name = L["Anchor"],
								desc = L["Which Anchor to Attach Bars"],
								order = 123,
								values = { ["targeted"]=L["Targeted"], ["nontargeted"]=L["Non-Targeted"], ["buffs"]=L["Buffs"], ["none"]=L["None"] },
								get = function()
								return DB.profile.baroptions.f.targetanchor
								end,
								set = function(info, v)
								DB.profile.baroptions.f.targetanchor = v
								DB.profile.baroptions.f.nontargetanchor = v
								Scorchio2:UpdateAnchors()
								end
							},
							targetalpha = {
								type = 'range',
								name = L["Alpha"],
								desc = L["Alpha to Apply to Bars"],
								order = 124,
								disabled = function()
									return not DB.profile.baroptions.f.track
								end,
								get = function()
									return DB.profile.baroptions.f.targetalpha
								end,
								set = function(info, v)
									DB.profile.baroptions.f.targetalpha = v
									DB.profile.baroptions.f.nontargetalpha = v
									Scorchio2:UpdateAnchors()                   
								end,
								min = 0,
								max = 1,
								step = 0.1,
							},
							showproc = {
								type = 'toggle',
								name = L["Show Proc"],
								desc = L["Show message when Hot Streak procs"],
								order = 125,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.f.track
								end,
								get = function()
									return DB.profile.baroptions.f.showproc
								end,
								set = function(info, v)
									DB.profile.baroptions.f.showproc = v
									Scorchio2:UpdateAnchors()
								end
							},
							proctext = {
								type = 'input',
								name = L["Proc Text String"],
								desc = L["Enter message to appear when Hot Streak procs"],
								width = "full",
								order = 130,
								disabled = function()
									return not DB.profile.baroptions.f.track
								end,
								get = function()
									return DB.profile.baroptions.f.apply
								end,
								set = function(info, v)
									DB.profile.baroptions.f.apply = v
								end
							},
							showwarning = {
								type = 'toggle',
								name = L["Show Warnings"],
								desc = L["Show warning when spell is about to expire"],
								order = 135,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.f.track
								end,
								get = function()
									return DB.profile.baroptions.f.showwarning
								end,
								set = function(info, v)
									DB.profile.baroptions.f.showwarning = v
									Scorchio2:UpdateAnchors()
								end
							},
							warningtime = {
								type = 'range',
								name = L["Warning Time"],
								desc = L["Warning Time for Hot Streak"],
								order = 140,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.f.track
								end,
								get = function()
									return DB.profile.baroptions.f.warningtime
								end,
								set = function(info, v)
									DB.profile.baroptions.f.warningtime = v
									Scorchio2:UpdateAnchors()                   
								end,
								min = 0,
								max = 12,
								step = 1,
							},
							warningtext = {
								type = 'input',
								name = L["Warning Text String"],
								desc = L["Enter warning to appear when Hot Streak is about to fade."],
								width = "full",
								order = 145,
								disabled = function()
									return not DB.profile.baroptions.f.track
								end,
								get = function()
									return DB.profile.baroptions.f.warning
								end,
								set = function(info, v)
									DB.profile.baroptions.f.warning = v
								end
							},
							showexpire = {
								type = 'toggle',
								name = L["Show Expire Notices"],
								desc = L["Show notice when spell expires"],
								order = 150,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.f.track
								end,
								get = function()
									return DB.profile.baroptions.f.showexpire
								end,
								set = function(info, v)
									DB.profile.baroptions.f.showexpire = v
									Scorchio2:UpdateAnchors()
								end
							},
							expirytext = {
								type = 'input',
								name = L["Expiry Text String"],
								desc = L["Enter message to appear when Hot Streak expires."],
								width = "full",
								order = 155,
								disabled = function()
									return not DB.profile.baroptions.f.track
								end,
								get = function()
									return DB.profile.baroptions.f.message
								end,
								set = function(info, v)
									DB.profile.baroptions.f.message = v
								end
							},
							on = {
								type = 'toggle',
								name = L["Toggle Sounds"],
								desc = L["Enable/Disable sounds for Hot Streak"],
								order = 160,
								disabled = function()
									return not DB.profile.baroptions.f.track
								end,
								get = function()
									return DB.profile.baroptions.f.soundson
								end,
								set = function()
									DB.profile.baroptions.f.soundson = not DB.profile.baroptions.f.soundson
								end
							},
							procsound = {
								type = 'select',
								name = L["Proc Sound"],
								desc = L["Change the sound played when the buff procs"],
								order = 165,
								disabled = function()
									return not DB.profile.baroptions.f.soundson or not DB.profile.baroptions.f.track
								end,
								values = SM:List("sound"),
								get = function() 
									return GetSMIndex("sound", DB.profile.baroptions.f.procsound)
								end,
								set = function(info, v)
									DB.profile.baroptions.f.procsound = SM:List("sound")[v]
									PlaySoundFile(SM:Fetch("sound", DB.profile.baroptions.f.procsound))
								end,
							},
							warningsound = {
								type = 'select',
								name = L["Warning Sound"],
								desc = L["Change the sound played when warning time is reached"],
								order = 170,
								disabled = function()
									return not DB.profile.baroptions.f.soundson or not DB.profile.baroptions.f.track
								end,
								values = SM:List("sound"),
								get = function() 
									return GetSMIndex("sound", DB.profile.baroptions.f.warningsound)
								end,
								set = function(info, v)
									DB.profile.baroptions.f.warningsound = SM:List("sound")[v]
									PlaySoundFile(SM:Fetch("sound", DB.profile.baroptions.f.warningsound))
								end,
							},
							expiredsound = {
								type = 'select',
								name = L["Expired Sound"],
								desc = L["Change the sound played when the buff expires"],
								order = 175,
								disabled = function()
									return not DB.profile.baroptions.f.soundson or not DB.profile.baroptions.f.track
								end,
								values = SM:List("sound"),
								get = function() 
									return GetSMIndex("sound", DB.profile.baroptions.f.expiredsound)
								end,
								set = function(info, v)
									DB.profile.baroptions.f.expiredsound = SM:List("sound")[v]
									PlaySoundFile(SM:Fetch("sound", DB.profile.baroptions.f.expiredsound))
								end,
							},
						},
					},
					g = {
						type = 'group',
						name = L["Missile Barrage"],
						desc = L["Missile Barrage"],
						args = {
							track = {
								type = 'toggle',
								name = L["Track Missile Barrage"],
								desc = L["Track Missile Barrage"],
								order = 100,
								width = "full",
								get = function()
									return DB.profile.baroptions.g.track
								end,
								set = function(info, v)
									DB.profile.baroptions.g.track = v
									Scorchio2:UpdateAnchors()
								end
							}, 
							show = {
								type = 'toggle',
								name = L["Show Missile Barrage Bar"],
								desc = L["Show Missile Barrage Bar"],
								order = 105,
								disabled = function()
									return not DB.profile.baroptions.g.track
								end,
								get = function()
									return DB.profile.baroptions.g.show
								end,
								set = function(info, v)
									DB.profile.baroptions.g.show = v
									Scorchio2:UpdateAnchors()
								end
							},
							clearooc = {
								type = 'toggle',
								name = L["Fade bars when out of combat"],
								desc = L["Fade bars when out of combat"],
								order = 107,
								disabled = function()
									return not DB.profile.baroptions.g.track
								end,
								get = function()
									return DB.profile.baroptions.g.clearooc
								end,
								set = function(info, v)
									DB.profile.baroptions.g.clearooc = v
								end
							},
							bartext = {
								type = 'input',
								name = L["Bar Text String"],
								desc = L["Enter text to appear on Missile Barrage bars."],
								width = "full",
								order = 110,
								disabled = function()
									return not DB.profile.baroptions.g.track
								end,
								get = function()
									return DB.profile.baroptions.g.bar
								end,
								set = function(info, v)
									DB.profile.baroptions.g.bar = v
									Scorchio2:UpdateAnchors()
								end
							},
							barcolour = {
								type = 'color',
								name = L["Bar Colour"],
								desc = L["Change bar colour"],
								order = 115,
								disabled = function()
									return not DB.profile.baroptions.g.track
								end,
								get = function(info)
									return unpack(DB.profile.baroptions.g.fg)
								end,
								set = function(info, r, g, b)
									DB.profile.baroptions.g.fg = {r, g, b}
									Scorchio2:UpdateAnchors()
								end,
								hasAlpha = false
							},
							backgroundcolour = {
								type = 'color',
								name = L["Background Colour"],
								desc = L["Change background colour"],
								order = 120,
								disabled = function()
									return not DB.profile.baroptions.g.track
								end,
								get = function(info)
									return unpack(DB.profile.baroptions.g.bg)
								end,
								set = function(info, r, g, b)
									DB.profile.baroptions.g.bg = {r, g, b}
									Scorchio2:UpdateAnchors()
								end,
								hasAlpha = false
							},
							targetanchor = {
								type = 'select',
								name = L["Anchor"],
								desc = L["Which Anchor to Attach Bars"],
								order = 123,
								values = { ["targeted"]=L["Targeted"], ["nontargeted"]=L["Non-Targeted"], ["buffs"]=L["Buffs"], ["none"]=L["None"] },
								get = function()
								return DB.profile.baroptions.g.targetanchor
								end,
								set = function(info, v)
								DB.profile.baroptions.g.targetanchor = v
								DB.profile.baroptions.g.nontargetanchor = v
								Scorchio2:UpdateAnchors()
								end
							},
							targetalpha = {
								type = 'range',
								name = L["Alpha"],
								desc = L["Alpha to Apply to Bars"],
								order = 124,
								disabled = function()
									return not DB.profile.baroptions.g.track
								end,
								get = function()
									return DB.profile.baroptions.g.targetalpha
								end,
								set = function(info, v)
									DB.profile.baroptions.g.targetalpha = v
									DB.profile.baroptions.g.nontargetalpha = v
									Scorchio2:UpdateAnchors()                   
								end,
								min = 0,
								max = 1,
								step = 0.1,
							},
							showproc = {
								type = 'toggle',
								name = L["Show Proc"],
								desc = L["Show message when Missile Barrage procs"],
								order = 125,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.g.track
								end,
								get = function()
									return DB.profile.baroptions.g.showproc
								end,
								set = function(info, v)
									DB.profile.baroptions.g.showproc = v
									Scorchio2:UpdateAnchors()
								end
							},
							proctext = {
								type = 'input',
								name = L["Proc Text String"],
								desc = L["Enter message to appear when Missile Barrage procs"],
								width = "full",
								order = 130,
								disabled = function()
									return not DB.profile.baroptions.g.track
								end,
								get = function()
									return DB.profile.baroptions.g.apply
								end,
								set = function(info, v)
									DB.profile.baroptions.g.apply = v
								end
							},
							showwarning = {
								type = 'toggle',
								name = L["Show Warnings"],
								desc = L["Show warning when spell is about to expire"],
								order = 135,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.g.track
								end,
								get = function()
									return DB.profile.baroptions.g.showwarning
								end,
								set = function(info, v)
									DB.profile.baroptions.g.showwarning = v
									Scorchio2:UpdateAnchors()
								end
							},
							warningtime = {
								type = 'range',
								name = L["Warning Time"],
								desc = L["Warning Time for Missile Barrage"],
								order = 140,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.g.track
								end,
								get = function()
									return DB.profile.baroptions.g.warningtime
								end,
								set = function(info, v)
									DB.profile.baroptions.g.warningtime = v
									Scorchio2:UpdateAnchors()                   
								end,
								min = 0,
								max = 12,
								step = 1,
							},
							warningtext = {
								type = 'input',
								name = L["Warning Text String"],
								desc = L["Enter warning to appear when Missile Barrage is about to fade."],
								width = "full",
								order = 145,
								disabled = function()
									return not DB.profile.baroptions.g.track
								end,
								get = function()
									return DB.profile.baroptions.g.warning
								end,
								set = function(info, v)
									DB.profile.baroptions.g.warning = v
								end
							},
							showexpire = {
								type = 'toggle',
								name = L["Show Expire Notices"],
								desc = L["Show notice when spell expires"],
								order = 150,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.g.track
								end,
								get = function()
									return DB.profile.baroptions.g.showexpire
								end,
								set = function(info, v)
									DB.profile.baroptions.g.showexpire = v
									Scorchio2:UpdateAnchors()
								end
							},
							expirytext = {
								type = 'input',
								name = L["Expiry Text String"],
								desc = L["Enter message to appear when Missile Barrage expires."],
								width = "full",
								order = 155,
								disabled = function()
									return not DB.profile.baroptions.g.track
								end,
								get = function()
									return DB.profile.baroptions.g.message
								end,
								set = function(info, v)
									DB.profile.baroptions.g.message = v
								end
							},
							on = {
								type = 'toggle',
								name = L["Toggle Sounds"],
								desc = L["Enable/Disable sounds for Missile Barrage"],
								order = 160,
								disabled = function()
									return not DB.profile.baroptions.g.track
								end,
								get = function()
									return DB.profile.baroptions.g.soundson
								end,
								set = function()
									DB.profile.baroptions.g.soundson = not DB.profile.baroptions.g.soundson
								end
							},
							procsound = {
								type = 'select',
								name = L["Proc Sound"],
								desc = L["Change the sound played when the buff procs"],
								order = 165,
								disabled = function()
									return not DB.profile.baroptions.g.soundson or not DB.profile.baroptions.g.track
								end,
								values = SM:List("sound"),
								get = function() 
									return GetSMIndex("sound", DB.profile.baroptions.g.procsound)
								end,
								set = function(info, v)
									DB.profile.baroptions.g.procsound = SM:List("sound")[v]
									PlaySoundFile(SM:Fetch("sound", DB.profile.baroptions.g.procsound))
								end,
							},
							warningsound = {
								type = 'select',
								name = L["Warning Sound"],
								desc = L["Change the sound played when warning time is reached"],
								order = 170,
								disabled = function()
									return not DB.profile.baroptions.g.soundson or not DB.profile.baroptions.g.track
								end,
								values = SM:List("sound"),
								get = function() 
									return GetSMIndex("sound", DB.profile.baroptions.g.warningsound)
								end,
								set = function(info, v)
									DB.profile.baroptions.g.warningsound = SM:List("sound")[v]
									PlaySoundFile(SM:Fetch("sound", DB.profile.baroptions.g.warningsound))
								end,
							},
							expiredsound = {
								type = 'select',
								name = L["Expired Sound"],
								desc = L["Change the sound played when the buff expires"],
								order = 175,
								disabled = function()
									return not DB.profile.baroptions.g.soundson or not DB.profile.baroptions.g.track
								end,
								values = SM:List("sound"),
								get = function() 
									return GetSMIndex("sound", DB.profile.baroptions.g.expiredsound)
								end,
								set = function(info, v)
									DB.profile.baroptions.g.expiredsound = SM:List("sound")[v]
									PlaySoundFile(SM:Fetch("sound", DB.profile.baroptions.g.expiredsound))
								end,
							},
						},
					},
					h = {
						type = 'group',
						name = L["Clearcasting"],
						desc = L["Clearcasting"],
						args = {
							track = {
								type = 'toggle',
								name = L["Track Clearcasting"],
								desc = L["Track Clearcasting"],
								order = 100,
								width = "full",
								get = function()
									return DB.profile.baroptions.h.track
								end,
								set = function(info, v)
									DB.profile.baroptions.h.track = v
									Scorchio2:UpdateAnchors()
								end
							}, 
							show = {
								type = 'toggle',
								name = L["Show Clearcasting Bar"],
								desc = L["Show Clearcasting Bar"],
								order = 105,
								disabled = function()
									return not DB.profile.baroptions.h.track
								end,
								get = function()
									return DB.profile.baroptions.h.show
								end,
								set = function(info, v)
									DB.profile.baroptions.h.show = v
									Scorchio2:UpdateAnchors()
								end
							},
							clearooc = {
								type = 'toggle',
								name = L["Fade bars when out of combat"],
								desc = L["Fade bars when out of combat"],
								order = 107,
								disabled = function()
									return not DB.profile.baroptions.h.track
								end,
								get = function()
									return DB.profile.baroptions.h.clearooc
								end,
								set = function(info, v)
									DB.profile.baroptions.h.clearooc = v
								end
							},
							bartext = {
								type = 'input',
								name = L["Bar Text String"],
								desc = L["Enter text to appear on Clearcasting bars."],
								width = "full",
								order = 110,
								disabled = function()
									return not DB.profile.baroptions.h.track
								end,
								get = function()
									return DB.profile.baroptions.h.bar
								end,
								set = function(info, v)
									DB.profile.baroptions.h.bar = v
									Scorchio2:UpdateAnchors()
								end
							},
							barcolour = {
								type = 'color',
								name = L["Bar Colour"],
								desc = L["Change bar colour"],
								order = 115,
								disabled = function()
									return not DB.profile.baroptions.h.track
								end,
								get = function(info)
									return unpack(DB.profile.baroptions.h.fg)
								end,
								set = function(info, r, g, b)
									DB.profile.baroptions.h.fg = {r, g, b}
									Scorchio2:UpdateAnchors()
								end,
								hasAlpha = false
							},
							backgroundcolour = {
								type = 'color',
								name = L["Background Colour"],
								desc = L["Change background colour"],
								order = 120,
								disabled = function()
									return not DB.profile.baroptions.h.track
								end,
								get = function(info)
									return unpack(DB.profile.baroptions.h.bg)
								end,
								set = function(info, r, g, b)
									DB.profile.baroptions.h.bg = {r, g, b}
									Scorchio2:UpdateAnchors()
								end,
								hasAlpha = false
							},
							targetanchor = {
								type = 'select',
								name = L["Anchor"],
								desc = L["Which Anchor to Attach Bars"],
								order = 123,
								values = { ["targeted"]=L["Targeted"], ["nontargeted"]=L["Non-Targeted"], ["buffs"]=L["Buffs"], ["none"]=L["None"] },
								get = function()
								return DB.profile.baroptions.h.targetanchor
								end,
								set = function(info, v)
								DB.profile.baroptions.h.targetanchor = v
								DB.profile.baroptions.h.nontargetanchor = v
								Scorchio2:UpdateAnchors()
								end
							},
							targetalpha = {
								type = 'range',
								name = L["Alpha"],
								desc = L["Alpha to Apply to Bars"],
								order = 124,
								disabled = function()
									return not DB.profile.baroptions.h.track
								end,
								get = function()
									return DB.profile.baroptions.h.targetalpha
								end,
								set = function(info, v)
									DB.profile.baroptions.h.targetalpha = v
									DB.profile.baroptions.h.nontargetalpha = v
									Scorchio2:UpdateAnchors()                   
								end,
								min = 0,
								max = 1,
								step = 0.1,
							},
							showproc = {
								type = 'toggle',
								name = L["Show Proc"],
								desc = L["Show message when Clearcasting procs"],
								order = 125,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.h.track
								end,
								get = function()
									return DB.profile.baroptions.h.showproc
								end,
								set = function(info, v)
									DB.profile.baroptions.h.showproc = v
									Scorchio2:UpdateAnchors()
								end
							},
							proctext = {
								type = 'input',
								name = L["Proc Text String"],
								desc = L["Enter message to appear when Clearcasting procs"],
								width = "full",
								order = 130,
								disabled = function()
									return not DB.profile.baroptions.h.track
								end,
								get = function()
									return DB.profile.baroptions.h.apply
								end,
								set = function(info, v)
									DB.profile.baroptions.h.apply = v
								end
							},
							showwarning = {
								type = 'toggle',
								name = L["Show Warnings"],
								desc = L["Show warning when spell is about to expire"],
								order = 135,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.h.track
								end,
								get = function()
									return DB.profile.baroptions.h.showwarning
								end,
								set = function(info, v)
									DB.profile.baroptions.h.showwarning = v
									Scorchio2:UpdateAnchors()
								end
							},
							warningtime = {
								type = 'range',
								name = L["Warning Time"],
								desc = L["Warning Time for Clearcasting"],
								order = 140,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.h.track
								end,
								get = function()
									return DB.profile.baroptions.h.warningtime
								end,
								set = function(info, v)
									DB.profile.baroptions.h.warningtime = v
									Scorchio2:UpdateAnchors()                   
								end,
								min = 0,
								max = 12,
								step = 1,
							},
							warningtext = {
								type = 'input',
								name = L["Warning Text String"],
								desc = L["Enter warning to appear when Clearcasting is about to fade."],
								width = "full",
								order = 145,
								disabled = function()
									return not DB.profile.baroptions.h.track
								end,
								get = function()
									return DB.profile.baroptions.h.warning
								end,
								set = function(info, v)
									DB.profile.baroptions.h.warning = v
								end
							},
							showexpire = {
								type = 'toggle',
								name = L["Show Expire Notices"],
								desc = L["Show notice when spell expires"],
								order = 150,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.h.track
								end,
								get = function()
									return DB.profile.baroptions.h.showexpire
								end,
								set = function(info, v)
									DB.profile.baroptions.h.showexpire = v
									Scorchio2:UpdateAnchors()
								end
							},
							expirytext = {
								type = 'input',
								name = L["Expiry Text String"],
								desc = L["Enter message to appear when Clearcasting expires."],
								width = "full",
								order = 155,
								disabled = function()
									return not DB.profile.baroptions.h.track
								end,
								get = function()
									return DB.profile.baroptions.h.message
								end,
								set = function(info, v)
									DB.profile.baroptions.h.message = v
								end
							},
							on = {
								type = 'toggle',
								name = L["Toggle Sounds"],
								desc = L["Enable/Disable sounds for Clearcasting"],
								order = 160,
								disabled = function()
									return not DB.profile.baroptions.h.track
								end,
								get = function()
									return DB.profile.baroptions.h.soundson
								end,
								set = function()
									DB.profile.baroptions.h.soundson = not DB.profile.baroptions.h.soundson
								end
							},
							procsound = {
								type = 'select',
								name = L["Proc Sound"],
								desc = L["Change the sound played when the buff procs"],
								order = 165,
								disabled = function()
									return not DB.profile.baroptions.h.soundson or not DB.profile.baroptions.h.track
								end,
								values = SM:List("sound"),
								get = function() 
									return GetSMIndex("sound", DB.profile.baroptions.h.procsound)
								end,
								set = function(info, v)
									DB.profile.baroptions.h.procsound = SM:List("sound")[v]
									PlaySoundFile(SM:Fetch("sound", DB.profile.baroptions.h.procsound))
								end,
							},
							warningsound = {
								type = 'select',
								name = L["Warning Sound"],
								desc = L["Change the sound played when warning time is reached"],
								order = 170,
								disabled = function()
									return not DB.profile.baroptions.h.soundson or not DB.profile.baroptions.h.track
								end,
								values = SM:List("sound"),
								get = function() 
									return GetSMIndex("sound", DB.profile.baroptions.h.warningsound)
								end,
								set = function(info, v)
									DB.profile.baroptions.h.warningsound = SM:List("sound")[v]
									PlaySoundFile(SM:Fetch("sound", DB.profile.baroptions.h.warningsound))
								end,
							},
							expiredsound = {
								type = 'select',
								name = L["Expired Sound"],
								desc = L["Change the sound played when the buff expires"],
								order = 175,
								disabled = function()
									return not DB.profile.baroptions.h.soundson or not DB.profile.baroptions.h.track
								end,
								values = SM:List("sound"),
								get = function() 
									return GetSMIndex("sound", DB.profile.baroptions.h.expiredsound)
								end,
								set = function(info, v)
									DB.profile.baroptions.h.expiredsound = SM:List("sound")[v]
									PlaySoundFile(SM:Fetch("sound", DB.profile.baroptions.h.expiredsound))
								end,
							},
						},
					},
					i = {
						type = 'group',
						name = L["Arcane Blast"],
						desc = L["Arcane Blast"],
						args = {
							track = {
								type = 'toggle',
								name = L["Track Arcane Blast"],
								desc = L["Track Arcane Blast"],
								order = 100,
								width = "full",
								get = function()
									return DB.profile.baroptions.i.track
								end,
								set = function(info, v)
									DB.profile.baroptions.i.track = v
									Scorchio2:UpdateAnchors()
								end
							},                        
							show = {
								type = 'toggle',
								name = L["Show Arcane Blast Bar"],
								desc = L["Show Arcane Blast Bar"],
								order = 105,
								disabled = function()
									return not DB.profile.baroptions.i.track
								end,
								get = function()
									return DB.profile.baroptions.i.show
								end,
								set = function(info, v)
									DB.profile.baroptions.i.show = v
									Scorchio2:UpdateAnchors()
								end
							},
							clearooc = {
								type = 'toggle',
								name = L["Fade bars when out of combat"],
								desc = L["Fade bars when out of combat"],
								order = 107,
								disabled = function()
									return not DB.profile.baroptions.i.track
								end,
								get = function()
									return DB.profile.baroptions.i.clearooc
								end,
								set = function(info, v)
									DB.profile.baroptions.i.clearooc = v
								end
							},
							bartext = {
								type = 'input',
								name = L["Bar Text String"],
								desc = L["Enter text to appear on Arcane Blast Bars."],
								width = "full",
								order = 110,
								disabled = function()
									return not DB.profile.baroptions.i.track
								end,
								get = function()
									return DB.profile.baroptions.i.bar
								end,
								set = function(info, v)
									DB.profile.baroptions.i.bar = v
									Scorchio2:UpdateAnchors()
								end
							},
							barcolour = {
								type = 'color',
								name = L["Bar Colour"],
								desc = L["Change bar colour"],
								order = 115,
								disabled = function()
									return not DB.profile.baroptions.i.track
								end,
								get = function(info)
									return unpack(DB.profile.baroptions.i.fg)
								end,
								set = function(info, r, g, b)
									DB.profile.baroptions.i.fg = {r, g, b}
									Scorchio2:UpdateAnchors()
								end,
								hasAlpha = false
							},
							backgroundcolour = {
								type = 'color',
								name = L["Background Colour"],
								desc = L["Change background colour"],
								order = 120,
								disabled = function()
									return not DB.profile.baroptions.i.track
								end,
								get = function(info)
									return unpack(DB.profile.baroptions.i.bg)
								end,
								set = function(info, r, g, b)
									DB.profile.baroptions.i.bg = {r, g, b}
									Scorchio2:UpdateAnchors()
								end,
								hasAlpha = false
							},
							targetanchor = {
								type = 'select',
								name = L["Anchor"],
								desc = L["Which Anchor to Attach Bars"],
								order = 123,
								values = { ["targeted"]=L["Targeted"], ["nontargeted"]=L["Non-Targeted"], ["buffs"]=L["Buffs"], ["none"]=L["None"] },
								get = function()
								return DB.profile.baroptions.i.targetanchor
								end,
								set = function(info, v)
								DB.profile.baroptions.i.targetanchor = v
								DB.profile.baroptions.i.nontargetanchor = v
								Scorchio2:UpdateAnchors()
								end
							},
							targetalpha = {
								type = 'range',
								name = L["Alpha"],
								desc = L["Alpha to Apply to Bars"],
								order = 124,
								disabled = function()
									return not DB.profile.baroptions.i.track
								end,
								get = function()
									return DB.profile.baroptions.i.targetalpha
								end,
								set = function(info, v)
									DB.profile.baroptions.i.targetalpha = v
									DB.profile.baroptions.i.nontargetalpha = v
									Scorchio2:UpdateAnchors()                   
								end,
								min = 0,
								max = 1,
								step = 0.1,
							},
							showwarning = {
								type = 'toggle',
								name = L["Show Warnings"],
								desc = L["Show warning when spell is about to expire"],
								order = 125,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.i.track
								end,
								get = function()
									return DB.profile.baroptions.i.showwarning
								end,
								set = function(info, v)
									DB.profile.baroptions.i.showwarning = v
									Scorchio2:UpdateAnchors()
								end
							},
							warningtime = {
								type = 'range',
								name = L["Warning Time"],
								desc = L["Warning Time for Arcane Blast"],
								order = 130,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.i.track
								end,
								get = function()
									return DB.profile.baroptions.i.warningtime
								end,
								set = function(info, v)
									DB.profile.baroptions.i.warningtime = v
									Scorchio2:UpdateAnchors()                   
								end,
								min = 0,
								max = 30,
								step = 1,
							},
							warningtext = {
								type = 'input',
								name = L["Warning Text String"],
								desc = L["Enter warning to appear when Arcane Blast will fade."],
								width = "full",
								order = 135,
								disabled = function()
									return not DB.profile.baroptions.i.track
								end,
								get = function()
									return DB.profile.baroptions.i.warning
								end,
								set = function(info, v)
									DB.profile.baroptions.i.warning = v
								end
							},
							showexpire = {
								type = 'toggle',
								name = L["Show Expire Notices"],
								desc = L["Show notice when spell expires"],
								order = 140,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.i.track
								end,
								get = function()
									return DB.profile.baroptions.i.showexpire
								end,
								set = function(info, v)
									DB.profile.baroptions.i.showexpire = v
									Scorchio2:UpdateAnchors()
								end
							},
							expirytext = {
								type = 'input',
								name = L["Expiry Text String"],
								desc = L["Enter warning to appear when Arcane Blast expires."],
								width = "full",
								order = 145,
								disabled = function()
									return not DB.profile.baroptions.i.track
								end,
								get = function()
									return DB.profile.baroptions.i.message
								end,
								set = function(info, v)
									DB.profile.baroptions.i.message = v
								end
							},
							on = {
								type = 'toggle',
								name = L["Toggle Sounds"],
								desc = L["Enable/Disable sounds for Arcane Blast"],
								order = 150,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.i.track
								end,
								get = function()
									return DB.profile.baroptions.i.soundson
								end,
								set = function()
									DB.profile.baroptions.i.soundson = not DB.profile.baroptions.i.soundson
								end
							},
							warningsound = {
								type = 'select',
								name = L["Warning Sound"],
								desc = L["Change the sound played when warning time is reached"],
								order = 155,
								disabled = function()
									return not DB.profile.baroptions.i.soundson or not DB.profile.baroptions.i.track
								end,
								values = SM:List("sound"),
								get = function() 
									return GetSMIndex("sound", DB.profile.baroptions.i.warningsound)
								end,
								set = function(info, v)
									DB.profile.baroptions.i.warningsound = SM:List("sound")[v]
									PlaySoundFile(SM:Fetch("sound", DB.profile.baroptions.i.warningsound))
								end,
							},
							expiredsound = {
								type = 'select',
								name = L["Expired Sound"],
								desc = L["Change the sound played when the debuff expires"],
								order = 160,
								disabled = function()
									return not DB.profile.baroptions.i.soundson or not DB.profile.baroptions.i.track
								end,
								values = SM:List("sound"),
								get = function() 
									return GetSMIndex("sound", DB.profile.baroptions.i.expiredsound)
								end,
								set = function(info, v)
									DB.profile.baroptions.i.expiredsound = SM:List("sound")[v]
									PlaySoundFile(SM:Fetch("sound", DB.profile.baroptions.i.expiredsound))
								end,
							},
						},
					},
					j = {
						type = 'group',
						name = L["Brain Freeze"],
						desc = L["Brain Freeze"],
						args = {
							track = {
								type = 'toggle',
								name = L["Track Brain Freeze"],
								desc = L["Track Brain Freeze"],
								order = 100,
								width = "full",
								get = function()
									return DB.profile.baroptions.j.track
								end,
								set = function(info, v)
									DB.profile.baroptions.j.track = v
									Scorchio2:UpdateAnchors()
								end
							}, 
							show = {
								type = 'toggle',
								name = L["Show Brain Freeze Bar"],
								desc = L["Show Brain Freeze Bar"],
								order = 105,
								disabled = function()
									return not DB.profile.baroptions.j.track
								end,
								get = function()
									return DB.profile.baroptions.j.show
								end,
								set = function(info, v)
									DB.profile.baroptions.j.show = v
									Scorchio2:UpdateAnchors()
								end
							},
							clearooc = {
								type = 'toggle',
								name = L["Fade bars when out of combat"],
								desc = L["Fade bars when out of combat"],
								order = 107,
								disabled = function()
									return not DB.profile.baroptions.j.track
								end,
								get = function()
									return DB.profile.baroptions.j.clearooc
								end,
								set = function(info, v)
									DB.profile.baroptions.j.clearooc = v
								end
							},
							bartext = {
								type = 'input',
								name = L["Bar Text String"],
								desc = L["Enter text to appear on Brain Freeze bars."],
								width = "full",
								order = 110,
								disabled = function()
									return not DB.profile.baroptions.j.track
								end,
								get = function()
									return DB.profile.baroptions.j.bar
								end,
								set = function(info, v)
									DB.profile.baroptions.j.bar = v
									Scorchio2:UpdateAnchors()
								end
							},
							barcolour = {
								type = 'color',
								name = L["Bar Colour"],
								desc = L["Change bar colour"],
								order = 115,
								disabled = function()
									return not DB.profile.baroptions.j.track
								end,
								get = function(info)
									return unpack(DB.profile.baroptions.j.fg)
								end,
								set = function(info, r, g, b)
									DB.profile.baroptions.j.fg = {r, g, b}
									Scorchio2:UpdateAnchors()
								end,
								hasAlpha = false
							},
							backgroundcolour = {
								type = 'color',
								name = L["Background Colour"],
								desc = L["Change background colour"],
								order = 120,
								disabled = function()
									return not DB.profile.baroptions.j.track
								end,
								get = function(info)
									return unpack(DB.profile.baroptions.j.bg)
								end,
								set = function(info, r, g, b)
									DB.profile.baroptions.j.bg = {r, g, b}
									Scorchio2:UpdateAnchors()
								end,
								hasAlpha = false
							},
							targetanchor = {
								type = 'select',
								name = L["Anchor"],
								desc = L["Which Anchor to Attach Bars"],
								order = 123,
								values = { ["targeted"]=L["Targeted"], ["nontargeted"]=L["Non-Targeted"], ["buffs"]=L["Buffs"], ["none"]=L["None"] },
								get = function()
								return DB.profile.baroptions.j.targetanchor
								end,
								set = function(info, v)
								DB.profile.baroptions.j.targetanchor = v
								DB.profile.baroptions.j.nontargetanchor = v
								Scorchio2:UpdateAnchors()
								end
							},
							targetalpha = {
								type = 'range',
								name = L["Alpha"],
								desc = L["Alpha to Apply to Bars"],
								order = 124,
								disabled = function()
									return not DB.profile.baroptions.j.track
								end,
								get = function()
									return DB.profile.baroptions.j.targetalpha
								end,
								set = function(info, v)
									DB.profile.baroptions.j.targetalpha = v
									DB.profile.baroptions.j.nontargetalpha = v
									Scorchio2:UpdateAnchors()                   
								end,
								min = 0,
								max = 1,
								step = 0.1,
							},
							showproc = {
								type = 'toggle',
								name = L["Show Proc"],
								desc = L["Show message when Brain Freeze procs"],
								order = 125,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.j.track
								end,
								get = function()
									return DB.profile.baroptions.j.showproc
								end,
								set = function(info, v)
									DB.profile.baroptions.j.showproc = v
									Scorchio2:UpdateAnchors()
								end
							},
							proctext = {
								type = 'input',
								name = L["Proc Text String"],
								desc = L["Enter message to appear when Brain Freeze procs"],
								width = "full",
								order = 130,
								disabled = function()
									return not DB.profile.baroptions.j.track
								end,
								get = function()
									return DB.profile.baroptions.j.apply
								end,
								set = function(info, v)
									DB.profile.baroptions.j.apply = v
								end
							},
							showwarning = {
								type = 'toggle',
								name = L["Show Warnings"],
								desc = L["Show warning when spell is about to expire"],
								order = 135,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.j.track
								end,
								get = function()
									return DB.profile.baroptions.j.showwarning
								end,
								set = function(info, v)
									DB.profile.baroptions.j.showwarning = v
									Scorchio2:UpdateAnchors()
								end
							},
							warningtime = {
								type = 'range',
								name = L["Warning Time"],
								desc = L["Warning Time for Brain Freeze"],
								order = 140,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.j.track
								end,
								get = function()
									return DB.profile.baroptions.j.warningtime
								end,
								set = function(info, v)
									DB.profile.baroptions.j.warningtime = v
									Scorchio2:UpdateAnchors()                   
								end,
								min = 0,
								max = 12,
								step = 1,
							},
							warningtext = {
								type = 'input',
								name = L["Warning Text String"],
								desc = L["Enter warning to appear when Brain Freeze is about to fade."],
								width = "full",
								order = 145,
								disabled = function()
									return not DB.profile.baroptions.j.track
								end,
								get = function()
									return DB.profile.baroptions.j.warning
								end,
								set = function(info, v)
									DB.profile.baroptions.j.warning = v
								end
							},
							showexpire = {
								type = 'toggle',
								name = L["Show Expire Notices"],
								desc = L["Show notice when spell expires"],
								order = 150,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.j.track
								end,
								get = function()
									return DB.profile.baroptions.j.showexpire
								end,
								set = function(info, v)
									DB.profile.baroptions.j.showexpire = v
									Scorchio2:UpdateAnchors()
								end
							},
							expirytext = {
								type = 'input',
								name = L["Expiry Text String"],
								desc = L["Enter message to appear when Brain Freeze expires."],
								width = "full",
								order = 155,
								disabled = function()
									return not DB.profile.baroptions.j.track
								end,
								get = function()
									return DB.profile.baroptions.j.message
								end,
								set = function(info, v)
									DB.profile.baroptions.j.message = v
								end
							},
							on = {
								type = 'toggle',
								name = L["Toggle Sounds"],
								desc = L["Enable/Disable sounds for Brain Freeze"],
								order = 160,
								disabled = function()
									return not DB.profile.baroptions.j.track
								end,
								get = function()
									return DB.profile.baroptions.j.soundson
								end,
								set = function()
									DB.profile.baroptions.j.soundson = not DB.profile.baroptions.j.soundson
								end
							},
							procsound = {
								type = 'select',
								name = L["Proc Sound"],
								desc = L["Change the sound played when the buff procs"],
								order = 165,
								disabled = function()
									return not DB.profile.baroptions.j.soundson or not DB.profile.baroptions.j.track
								end,
								values = SM:List("sound"),
								get = function() 
									return GetSMIndex("sound", DB.profile.baroptions.j.procsound)
								end,
								set = function(info, v)
									DB.profile.baroptions.j.procsound = SM:List("sound")[v]
									PlaySoundFile(SM:Fetch("sound", DB.profile.baroptions.j.procsound))
								end,
							},
							warningsound = {
								type = 'select',
								name = L["Warning Sound"],
								desc = L["Change the sound played when warning time is reached"],
								order = 170,
								disabled = function()
									return not DB.profile.baroptions.j.soundson or not DB.profile.baroptions.j.track
								end,
								values = SM:List("sound"),
								get = function() 
									return GetSMIndex("sound", DB.profile.baroptions.j.warningsound)
								end,
								set = function(info, v)
									DB.profile.baroptions.j.warningsound = SM:List("sound")[v]
									PlaySoundFile(SM:Fetch("sound", DB.profile.baroptions.j.warningsound))
								end,
							},
							expiredsound = {
								type = 'select',
								name = L["Expired Sound"],
								desc = L["Change the sound played when the buff expires"],
								order = 175,
								disabled = function()
									return not DB.profile.baroptions.j.soundson or not DB.profile.baroptions.j.track
								end,
								values = SM:List("sound"),
								get = function() 
									return GetSMIndex("sound", DB.profile.baroptions.j.expiredsound)
								end,
								set = function(info, v)
									DB.profile.baroptions.j.expiredsound = SM:List("sound")[v]
									PlaySoundFile(SM:Fetch("sound", DB.profile.baroptions.j.expiredsound))
								end,
							},
						},
					},
					k = {
						type = 'group',
						name = L["Fingers of Frost"],
						desc = L["Fingers of Frost"],
						args = {
							track = {
								type = 'toggle',
								name = L["Track Fingers of Frost"],
								desc = L["Track Fingers of Frost"],
								order = 100,
								width = "full",
								get = function()
									return DB.profile.baroptions.k.track
								end,
								set = function(info, v)
									DB.profile.baroptions.k.track = v
									Scorchio2:UpdateAnchors()
								end
							}, 
							show = {
								type = 'toggle',
								name = L["Show Fingers of Frost Bar"],
								desc = L["Show Fingers of Frost Bar"],
								order = 105,
								disabled = function()
									return not DB.profile.baroptions.k.track
								end,
								get = function()
									return DB.profile.baroptions.k.show
								end,
								set = function(info, v)
									DB.profile.baroptions.k.show = v
									Scorchio2:UpdateAnchors()
								end
							},
							clearooc = {
								type = 'toggle',
								name = L["Fade bars when out of combat"],
								desc = L["Fade bars when out of combat"],
								order = 107,
								disabled = function()
									return not DB.profile.baroptions.k.track
								end,
								get = function()
									return DB.profile.baroptions.k.clearooc
								end,
								set = function(info, v)
									DB.profile.baroptions.k.clearooc = v
								end
							},
							bartext = {
								type = 'input',
								name = L["Bar Text String"],
								desc = L["Enter text to appear on Fingers of Frost bars."],
								width = "full",
								order = 110,
								disabled = function()
									return not DB.profile.baroptions.k.track
								end,
								get = function()
									return DB.profile.baroptions.k.bar
								end,
								set = function(info, v)
									DB.profile.baroptions.k.bar = v
									Scorchio2:UpdateAnchors()
								end
							},
							barcolour = {
								type = 'color',
								name = L["Bar Colour"],
								desc = L["Change bar colour"],
								order = 115,
								disabled = function()
									return not DB.profile.baroptions.k.track
								end,
								get = function(info)
									return unpack(DB.profile.baroptions.k.fg)
								end,
								set = function(info, r, g, b)
									DB.profile.baroptions.k.fg = {r, g, b}
									Scorchio2:UpdateAnchors()
								end,
								hasAlpha = false
							},
							backgroundcolour = {
								type = 'color',
								name = L["Background Colour"],
								desc = L["Change background colour"],
								order = 120,
								disabled = function()
									return not DB.profile.baroptions.k.track
								end,
								get = function(info)
									return unpack(DB.profile.baroptions.k.bg)
								end,
								set = function(info, r, g, b)
									DB.profile.baroptions.k.bg = {r, g, b}
									Scorchio2:UpdateAnchors()
								end,
								hasAlpha = false
							},
							targetanchor = {
								type = 'select',
								name = L["Anchor"],
								desc = L["Which Anchor to Attach Bars"],
								order = 123,
								values = { ["targeted"]=L["Targeted"], ["nontargeted"]=L["Non-Targeted"], ["buffs"]=L["Buffs"], ["none"]=L["None"] },
								get = function()
								return DB.profile.baroptions.k.targetanchor
								end,
								set = function(info, v)
								DB.profile.baroptions.k.targetanchor = v
								DB.profile.baroptions.k.nontargetanchor = v
								Scorchio2:UpdateAnchors()
								end
							},
							targetalpha = {
								type = 'range',
								name = L["Alpha"],
								desc = L["Alpha to Apply to Bars"],
								order = 124,
								disabled = function()
									return not DB.profile.baroptions.k.track
								end,
								get = function()
									return DB.profile.baroptions.k.targetalpha
								end,
								set = function(info, v)
									DB.profile.baroptions.k.targetalpha = v
									DB.profile.baroptions.k.nontargetalpha = v
									Scorchio2:UpdateAnchors()                   
								end,
								min = 0,
								max = 1,
								step = 0.1,
							},
							showproc = {
								type = 'toggle',
								name = L["Show Proc"],
								desc = L["Show message when Fingers of Frost procs"],
								order = 125,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.k.track
								end,
								get = function()
									return DB.profile.baroptions.k.showproc
								end,
								set = function(info, v)
									DB.profile.baroptions.k.showproc = v
									Scorchio2:UpdateAnchors()
								end
							},
							proctext = {
								type = 'input',
								name = L["Proc Text String"],
								desc = L["Enter message to appear when Fingers of Frost procs"],
								width = "full",
								order = 130,
								disabled = function()
									return not DB.profile.baroptions.k.track
								end,
								get = function()
									return DB.profile.baroptions.k.apply
								end,
								set = function(info, v)
									DB.profile.baroptions.k.apply = v
								end
							},
							showwarning = {
								type = 'toggle',
								name = L["Show Warnings"],
								desc = L["Show warning when spell is about to expire"],
								order = 135,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.k.track
								end,
								get = function()
									return DB.profile.baroptions.k.showwarning
								end,
								set = function(info, v)
									DB.profile.baroptions.k.showwarning = v
									Scorchio2:UpdateAnchors()
								end
							},
							warningtime = {
								type = 'range',
								name = L["Warning Time"],
								desc = L["Warning Time for Fingers of Frost"],
								order = 140,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.k.track
								end,
								get = function()
									return DB.profile.baroptions.k.warningtime
								end,
								set = function(info, v)
									DB.profile.baroptions.k.warningtime = v
									Scorchio2:UpdateAnchors()                   
								end,
								min = 0,
								max = 12,
								step = 1,
							},
							warningtext = {
								type = 'input',
								name = L["Warning Text String"],
								desc = L["Enter warning to appear when Fingers of Frost is about to fade."],
								width = "full",
								order = 145,
								disabled = function()
									return not DB.profile.baroptions.k.track
								end,
								get = function()
									return DB.profile.baroptions.k.warning
								end,
								set = function(info, v)
									DB.profile.baroptions.k.warning = v
								end
							},
							showexpire = {
								type = 'toggle',
								name = L["Show Expire Notices"],
								desc = L["Show notice when spell expires"],
								order = 150,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.k.track
								end,
								get = function()
									return DB.profile.baroptions.k.showexpire
								end,
								set = function(info, v)
									DB.profile.baroptions.k.showexpire = v
									Scorchio2:UpdateAnchors()
								end
							},
							expirytext = {
								type = 'input',
								name = L["Expiry Text String"],
								desc = L["Enter message to appear when Fingers of Frost expires."],
								width = "full",
								order = 155,
								disabled = function()
									return not DB.profile.baroptions.k.track
								end,
								get = function()
									return DB.profile.baroptions.k.message
								end,
								set = function(info, v)
									DB.profile.baroptions.k.message = v
								end
							},
							on = {
								type = 'toggle',
								name = L["Toggle Sounds"],
								desc = L["Enable/Disable sounds for Fingers of Frost"],
								order = 160,
								disabled = function()
									return not DB.profile.baroptions.k.track
								end,
								get = function()
									return DB.profile.baroptions.k.soundson
								end,
								set = function()
									DB.profile.baroptions.k.soundson = not DB.profile.baroptions.k.soundson
								end
							},
							procsound = {
								type = 'select',
								name = L["Proc Sound"],
								desc = L["Change the sound played when the buff procs"],
								order = 165,
								disabled = function()
									return not DB.profile.baroptions.k.soundson or not DB.profile.baroptions.k.track
								end,
								values = SM:List("sound"),
								get = function() 
									return GetSMIndex("sound", DB.profile.baroptions.k.procsound)
								end,
								set = function(info, v)
									DB.profile.baroptions.k.procsound = SM:List("sound")[v]
									PlaySoundFile(SM:Fetch("sound", DB.profile.baroptions.k.procsound))
								end,
							},
							warningsound = {
								type = 'select',
								name = L["Warning Sound"],
								desc = L["Change the sound played when warning time is reached"],
								order = 170,
								disabled = function()
									return not DB.profile.baroptions.k.soundson or not DB.profile.baroptions.k.track
								end,
								values = SM:List("sound"),
								get = function() 
									return GetSMIndex("sound", DB.profile.baroptions.k.warningsound)
								end,
								set = function(info, v)
									DB.profile.baroptions.k.warningsound = SM:List("sound")[v]
									PlaySoundFile(SM:Fetch("sound", DB.profile.baroptions.k.warningsound))
								end,
							},
							expiredsound = {
								type = 'select',
								name = L["Expired Sound"],
								desc = L["Change the sound played when the buff expires"],
								order = 175,
								disabled = function()
									return not DB.profile.baroptions.k.soundson or not DB.profile.baroptions.k.track
								end,
								values = SM:List("sound"),
								get = function() 
									return GetSMIndex("sound", DB.profile.baroptions.k.expiredsound)
								end,
								set = function(info, v)
									DB.profile.baroptions.k.expiredsound = SM:List("sound")[v]
									PlaySoundFile(SM:Fetch("sound", DB.profile.baroptions.k.expiredsound))
								end,
							},
						},
					},
					l = {
						type = 'group',
						name = L["Shadow Mastery"],
						desc = L["Shadow Mastery"],
						args = {
							track = {
								type = 'toggle',
								name = L["Track Shadow Mastery"],
								desc = L["Track Shadow Mastery"],
								order = 100,
								width = "full",
								get = function()
									return DB.profile.baroptions.l.track
								end,
								set = function(info, v)
									DB.profile.baroptions.l.track = v
									Scorchio2:UpdateAnchors()
								end
							},                        
							show = {
								type = 'toggle',
								name = L["Show Shadow Mastery Bars"],
								desc = L["Show Shadow Mastery Bars"],
								order = 105,
								disabled = function()
									return not DB.profile.baroptions.l.track
								end,
								get = function()
									return DB.profile.baroptions.l.show
								end,
								set = function(info, v)
									DB.profile.baroptions.l.show = v
									Scorchio2:UpdateAnchors()
								end
							},
							clearooc = {
								type = 'toggle',
								name = L["Fade bars when out of combat"],
								desc = L["Fade bars when out of combat"],
								order = 107,
								disabled = function()
									return not DB.profile.baroptions.l.track
								end,
								get = function()
									return DB.profile.baroptions.l.clearooc
								end,
								set = function(info, v)
									DB.profile.baroptions.l.clearooc = v
								end
							},
							bartext = {
								type = 'input',
								name = L["Bar Text String"],
								desc = L["Enter text to appear on Shadow Mastery Bars."] .. L[" $s will be replaced by the spell stack. $m will be replaced by the mob name. Everything else will remain as-is."],
								width = "full",
								order = 110,
								disabled = function()
									return not DB.profile.baroptions.l.track
								end,
								get = function()
									return DB.profile.baroptions.l.bar
								end,
								set = function(info, v)
									DB.profile.baroptions.l.bar = v
									Scorchio2:UpdateAnchors()
								end
							},
							barcolour = {
								type = 'color',
								name = L["Bar Colour"],
								desc = L["Change bar colour"],
								order = 115,
								disabled = function()
									return not DB.profile.baroptions.l.track
								end,
								get = function(info)
									return unpack(DB.profile.baroptions.l.fg)
								end,
								set = function(info, r, g, b)
									DB.profile.baroptions.l.fg = {r, g, b}
									Scorchio2:UpdateAnchors()
								end,
								hasAlpha = false
							},
							backgroundcolour = {
								type = 'color',
								name = L["Background Colour"],
								desc = L["Change background colour"],
								order = 120,
								disabled = function()
									return not DB.profile.baroptions.l.track
								end,
								get = function(info)
									return unpack(DB.profile.baroptions.l.bg)
								end,
								set = function(info, r, g, b)
									DB.profile.baroptions.l.bg = {r, g, b}
									Scorchio2:UpdateAnchors()
								end,
								hasAlpha = false
							},
							targetanchor = {
								type = 'select',
								name = L["Target Anchor"],
								desc = L["Which Anchor to Attach Bars to When Targeted"],
								order = 121,
								values = { ["targeted"]=L["Targeted"], ["nontargeted"]=L["Non-Targeted"], ["buffs"]=L["Buffs"], ["none"]=L["None"] },
								get = function()
								return DB.profile.baroptions.l.targetanchor
								end,
								set = function(info, v)
								DB.profile.baroptions.l.targetanchor = v
								Scorchio2:UpdateAnchors()
								end
							},
							nontargetanchor = {
								type = 'select',
								name = L["Non-Target Anchor"],
								desc = L["Which Anchor to Attach Bars to When NOT Targeted"],
								order = 123,
								values = { ["targeted"]=L["Targeted"], ["nontargeted"]=L["Non-Targeted"], ["buffs"]=L["Buffs"], ["none"]=L["None"] },
								get = function()
								return DB.profile.baroptions.l.nontargetanchor
								end,
								set = function(info, v)
								DB.profile.baroptions.l.nontargetanchor = v
								Scorchio2:UpdateAnchors()
								end
							},
							targetalpha = {
								type = 'range',
								name = L["Target Alpha"],
								desc = L["Alpha to Apply to Bars When Targeted"],
								order = 122,
								disabled = function()
									return not DB.profile.baroptions.l.track
								end,
								get = function()
									return DB.profile.baroptions.l.targetalpha
								end,
								set = function(info, v)
									DB.profile.baroptions.l.targetalpha = v
									Scorchio2:UpdateAnchors()                   
								end,
								min = 0,
								max = 1,
								step = 0.1,
							},
							nontargetalpha = {
								type = 'range',
								name = L["Non-Target Alpha"],
								desc = L["Alpha to Apply to Bars When NOT Targeted"],
								order = 124,
								disabled = function()
									return not DB.profile.baroptions.l.track
								end,
								get = function()
									return DB.profile.baroptions.l.nontargetalpha
								end,
								set = function(info, v)
									DB.profile.baroptions.l.nontargetalpha = v
									Scorchio2:UpdateAnchors()                   
								end,
								min = 0,
								max = 1,
								step = 0.1,
							},
							showwarning = {
								type = 'toggle',
								name = L["Show Warnings"],
								desc = L["Show warning when spell is about to expire"],
								order = 125,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.l.track
								end,
								get = function()
									return DB.profile.baroptions.l.showwarning
								end,
								set = function(info, v)
									DB.profile.baroptions.l.showwarning = v
									Scorchio2:UpdateAnchors()
								end
							},
							warningtime = {
								type = 'range',
								name = L["Warning Time"],
								desc = L["Warning Time for Shadow Mastery"],
								order = 130,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.l.track
								end,
								get = function()
									return DB.profile.baroptions.l.warningtime
								end,
								set = function(info, v)
									DB.profile.baroptions.l.warningtime = v
									Scorchio2:UpdateAnchors()                   
								end,
								min = 0,
								max = 30,
								step = 1,
							},
							warningtext = {
								type = 'input',
								name = L["Warning Text String"],
								desc = L["Enter warning to appear when Shadow Mastery will fade."],
								width = "full",
								order = 135,
								disabled = function()
									return not DB.profile.baroptions.l.track
								end,
								get = function()
									return DB.profile.baroptions.l.warning
								end,
								set = function(info, v)
									DB.profile.baroptions.l.warning = v
								end
							},
							showexpire = {
								type = 'toggle',
								name = L["Show Expire Notices"],
								desc = L["Show notice when spell expires"],
								order = 140,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.l.track
								end,
								get = function()
									return DB.profile.baroptions.l.showexpire
								end,
								set = function(info, v)
									DB.profile.baroptions.l.showexpire = v
									Scorchio2:UpdateAnchors()
								end
							},
							expirytext = {
								type = 'input',
								name = L["Expiry Text String"],
								desc = L["Enter warning to appear when Shadow Mastery expires."],
								width = "full",
								order = 145,
								disabled = function()
									return not DB.profile.baroptions.l.track
								end,
								get = function()
									return DB.profile.baroptions.l.message
								end,
								set = function(info, v)
									DB.profile.baroptions.l.message = v
								end
							},
							on = {
								type = 'toggle',
								name = L["Toggle Sounds"],
								desc = L["Enable/Disable sounds for Shadow Mastery"],
								order = 150,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.l.track
								end,
								get = function()
									return DB.profile.baroptions.l.soundson
								end,
								set = function()
									DB.profile.baroptions.l.soundson = not DB.profile.baroptions.l.soundson
								end
							},
							warningsound = {
								type = 'select',
								name = L["Warning Sound"],
								desc = L["Change the sound played when warning time is reached"],
								order = 155,
								disabled = function()
									return not DB.profile.baroptions.l.soundson or not DB.profile.baroptions.l.track
								end,
								values = SM:List("sound"),
								get = function() 
									return GetSMIndex("sound", DB.profile.baroptions.l.warningsound)
								end,
								set = function(info, v)
									DB.profile.baroptions.l.warningsound = SM:List("sound")[v]
									PlaySoundFile(SM:Fetch("sound", DB.profile.baroptions.l.warningsound))
								end,
							},
							expiredsound = {
								type = 'select',
								name = L["Expired Sound"],
								desc = L["Change the sound played when the debuff expires"],
								order = 160,
								disabled = function()
									return not DB.profile.baroptions.l.soundson or not DB.profile.baroptions.l.track
								end,
								values = SM:List("sound"),
								get = function() 
									return GetSMIndex("sound", DB.profile.baroptions.l.expiredsound)
								end,
								set = function(info, v)
									DB.profile.baroptions.l.expiredsound = SM:List("sound")[v]
									PlaySoundFile(SM:Fetch("sound", DB.profile.baroptions.l.expiredsound))
								end,
							},
						},
					},
					m = {
						type = 'group',
						name = L["Water Elemental"],
						desc = L["Water Elemental"],
						args = {
							track = {
								type = 'toggle',
								name = L["Track Water Elemental"],
								desc = L["Track Water Elemental"],
								order = 100,
								width = "full",
								get = function()
									return DB.profile.baroptions.m.track
								end,
								set = function(info, v)
									DB.profile.baroptions.m.track = v
									Scorchio2:UpdateAnchors()
								end
							},                        
							show = {
								type = 'toggle',
								name = L["Show Water Elemental Bar"],
								desc = L["Show Water Elemental Bar"],
								order = 105,
								disabled = function()
									return not DB.profile.baroptions.m.track
								end,
								get = function()
									return DB.profile.baroptions.m.show
								end,
								set = function(info, v)
									DB.profile.baroptions.m.show = v
									Scorchio2:UpdateAnchors()
								end
							},
							clearooc = {
								type = 'toggle',
								name = L["Fade bars when out of combat"],
								desc = L["Fade bars when out of combat"],
								order = 107,
								disabled = function()
									return not DB.profile.baroptions.m.track
								end,
								get = function()
									return DB.profile.baroptions.m.clearooc
								end,
								set = function(info, v)
									DB.profile.baroptions.m.clearooc = v
								end
							},
							bartext = {
								type = 'input',
								name = L["Bar Text String"],
								desc = L["Enter text to appear on Water Elemental Bar."],
								width = "full",
								order = 110,
								disabled = function()
									return not DB.profile.baroptions.m.track
								end,
								get = function()
									return DB.profile.baroptions.m.bar
								end,
								set = function(info, v)
									DB.profile.baroptions.m.bar = v
									Scorchio2:UpdateAnchors()
								end
							},
							barcolour = {
								type = 'color',
								name = L["Bar Colour"],
								desc = L["Change bar colour"],
								order = 115,
								disabled = function()
									return not DB.profile.baroptions.m.track
								end,
								get = function(info)
									return unpack(DB.profile.baroptions.m.fg)
								end,
								set = function(info, r, g, b)
									DB.profile.baroptions.m.fg = {r, g, b}
									Scorchio2:UpdateAnchors()
								end,
								hasAlpha = false
							},
							backgroundcolour = {
								type = 'color',
								name = L["Background Colour"],
								desc = L["Change background colour"],
								order = 120,
								disabled = function()
									return not DB.profile.baroptions.m.track
								end,
								get = function(info)
									return unpack(DB.profile.baroptions.m.bg)
								end,
								set = function(info, r, g, b)
									DB.profile.baroptions.m.bg = {r, g, b}
									Scorchio2:UpdateAnchors()
								end,
								hasAlpha = false
							},
							targetanchor = {
								type = 'select',
								name = L["Anchor"],
								desc = L["Which Anchor to Attach Bars"],
								order = 123,
								values = { ["targeted"]=L["Targeted"], ["nontargeted"]=L["Non-Targeted"], ["buffs"]=L["Buffs"], ["none"]=L["None"] },
								get = function()
								return DB.profile.baroptions.m.targetanchor
								end,
								set = function(info, v)
								DB.profile.baroptions.m.targetanchor = v
								DB.profile.baroptions.m.nontargetanchor = v
								Scorchio2:UpdateAnchors()
								end
							},
							targetalpha = {
								type = 'range',
								name = L["Alpha"],
								desc = L["Alpha to Apply to Bars"],
								order = 124,
								disabled = function()
									return not DB.profile.baroptions.m.track
								end,
								get = function()
									return DB.profile.baroptions.m.targetalpha
								end,
								set = function(info, v)
									DB.profile.baroptions.m.targetalpha = v
									DB.profile.baroptions.m.nontargetalpha = v
									Scorchio2:UpdateAnchors()                   
								end,
								min = 0,
								max = 1,
								step = 0.1,
							},
							showwarning = {
								type = 'toggle',
								name = L["Show Warnings"],
								desc = L["Show warning when Water Elemental is about to die"],
								order = 125,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.m.track
								end,
								get = function()
									return DB.profile.baroptions.m.showwarning
								end,
								set = function(info, v)
									DB.profile.baroptions.m.showwarning = v
									Scorchio2:UpdateAnchors()
								end
							},
							warningtime = {
								type = 'range',
								name = L["Warning Time"],
								desc = L["Warning Time for Water Elemental"],
								order = 130,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.m.track
								end,
								get = function()
									return DB.profile.baroptions.m.warningtime
								end,
								set = function(info, v)
									DB.profile.baroptions.m.warningtime = v
									Scorchio2:UpdateAnchors()                   
								end,
								min = 0,
								max = 30,
								step = 1,
							},
							warningtext = {
								type = 'input',
								name = L["Warning Text String"],
								desc = L["Enter warning to appear when Water Elemental is about to die."],
								width = "full",
								order = 135,
								disabled = function()
									return not DB.profile.baroptions.m.track
								end,
								get = function()
									return DB.profile.baroptions.m.warning
								end,
								set = function(info, v)
									DB.profile.baroptions.m.warning = v
								end
							},
							showexpire = {
								type = 'toggle',
								name = L["Show Expire Notices"],
								desc = L["Show notice when Water Elemental dies"],
								order = 140,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.m.track
								end,
								get = function()
									return DB.profile.baroptions.m.showexpire
								end,
								set = function(info, v)
									DB.profile.baroptions.m.showexpire = v
									Scorchio2:UpdateAnchors()
								end
							},
							expirytext = {
								type = 'input',
								name = L["Expiry Text String"],
								desc = L["Enter warning to appear when Water Elemental dies."],
								width = "full",
								order = 145,
								disabled = function()
									return not DB.profile.baroptions.m.track
								end,
								get = function()
									return DB.profile.baroptions.m.message
								end,
								set = function(info, v)
									DB.profile.baroptions.m.message = v
								end
							},
							on = {
								type = 'toggle',
								name = L["Toggle Sounds"],
								desc = L["Enable/Disable sounds for Water Elemental"],
								order = 150,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.m.track
								end,
								get = function()
									return DB.profile.baroptions.m.soundson
								end,
								set = function()
									DB.profile.baroptions.m.soundson = not DB.profile.baroptions.m.soundson
								end
							},
							warningsound = {
								type = 'select',
								name = L["Warning Sound"],
								desc = L["Change the sound played when warning time is reached"],
								order = 155,
								disabled = function()
									return not DB.profile.baroptions.m.soundson or not DB.profile.baroptions.m.track
								end,
								values = SM:List("sound"),
								get = function() 
									return GetSMIndex("sound", DB.profile.baroptions.m.warningsound)
								end,
								set = function(info, v)
									DB.profile.baroptions.m.warningsound = SM:List("sound")[v]
									PlaySoundFile(SM:Fetch("sound", DB.profile.baroptions.m.warningsound))
								end,
							},
							expiredsound = {
								type = 'select',
								name = L["Expired Sound"],
								desc = L["Change the sound played when the Water Elemental dies"],
								order = 160,
								disabled = function()
									return not DB.profile.baroptions.m.soundson or not DB.profile.baroptions.m.track
								end,
								values = SM:List("sound"),
								get = function() 
									return GetSMIndex("sound", DB.profile.baroptions.m.expiredsound)
								end,
								set = function(info, v)
									DB.profile.baroptions.m.expiredsound = SM:List("sound")[v]
									PlaySoundFile(SM:Fetch("sound", DB.profile.baroptions.m.expiredsound))
								end,
							},
						},
					},
					n = {
						type = 'group',
						name = L["Mirror Image"],
						desc = L["Mirror Image"],
						args = {
							track = {
								type = 'toggle',
								name = L["Track Mirror Image"],
								desc = L["Track Mirror Image"],
								order = 100,
								width = "full",
								get = function()
									return DB.profile.baroptions.n.track
								end,
								set = function(info, v)
									DB.profile.baroptions.n.track = v
									Scorchio2:UpdateAnchors()
								end
							},                        
							show = {
								type = 'toggle',
								name = L["Show Mirror Image Bar"],
								desc = L["Show Mirror Image Bar"],
								order = 105,
								disabled = function()
									return not DB.profile.baroptions.n.track
								end,
								get = function()
									return DB.profile.baroptions.n.show
								end,
								set = function(info, v)
									DB.profile.baroptions.n.show = v
									Scorchio2:UpdateAnchors()
								end
							},
							clearooc = {
								type = 'toggle',
								name = L["Fade bars when out of combat"],
								desc = L["Fade bars when out of combat"],
								order = 107,
								disabled = function()
									return not DB.profile.baroptions.n.track
								end,
								get = function()
									return DB.profile.baroptions.n.clearooc
								end,
								set = function(info, v)
									DB.profile.baroptions.n.clearooc = v
								end
							},
							bartext = {
								type = 'input',
								name = L["Bar Text String"],
								desc = L["Enter text to appear on Mirror Image Bar."],
								width = "full",
								order = 110,
								disabled = function()
									return not DB.profile.baroptions.n.track
								end,
								get = function()
									return DB.profile.baroptions.n.bar
								end,
								set = function(info, v)
									DB.profile.baroptions.n.bar = v
									Scorchio2:UpdateAnchors()
								end
							},
							barcolour = {
								type = 'color',
								name = L["Bar Colour"],
								desc = L["Change bar colour"],
								order = 115,
								disabled = function()
									return not DB.profile.baroptions.n.track
								end,
								get = function(info)
									return unpack(DB.profile.baroptions.n.fg)
								end,
								set = function(info, r, g, b)
									DB.profile.baroptions.n.fg = {r, g, b}
									Scorchio2:UpdateAnchors()
								end,
								hasAlpha = false
							},
							backgroundcolour = {
								type = 'color',
								name = L["Background Colour"],
								desc = L["Change background colour"],
								order = 120,
								disabled = function()
									return not DB.profile.baroptions.n.track
								end,
								get = function(info)
									return unpack(DB.profile.baroptions.n.bg)
								end,
								set = function(info, r, g, b)
									DB.profile.baroptions.n.bg = {r, g, b}
									Scorchio2:UpdateAnchors()
								end,
								hasAlpha = false
							},
							targetanchor = {
								type = 'select',
								name = L["Anchor"],
								desc = L["Which Anchor to Attach Bars"],
								order = 123,
								values = { ["targeted"]=L["Targeted"], ["nontargeted"]=L["Non-Targeted"], ["buffs"]=L["Buffs"], ["none"]=L["None"] },
								get = function()
								return DB.profile.baroptions.n.targetanchor
								end,
								set = function(info, v)
								DB.profile.baroptions.n.targetanchor = v
								DB.profile.baroptions.n.nontargetanchor = v
								Scorchio2:UpdateAnchors()
								end
							},
							targetalpha = {
								type = 'range',
								name = L["Alpha"],
								desc = L["Alpha to Apply to Bars"],
								order = 124,
								disabled = function()
									return not DB.profile.baroptions.n.track
								end,
								get = function()
									return DB.profile.baroptions.n.targetalpha
								end,
								set = function(info, v)
									DB.profile.baroptions.n.targetalpha = v
									DB.profile.baroptions.n.nontargetalpha = v
									Scorchio2:UpdateAnchors()                   
								end,
								min = 0,
								max = 1,
								step = 0.1,
							},
							showwarning = {
								type = 'toggle',
								name = L["Show Warnings"],
								desc = L["Show warning when spell is about to expire"],
								order = 125,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.n.track
								end,
								get = function()
									return DB.profile.baroptions.n.showwarning
								end,
								set = function(info, v)
									DB.profile.baroptions.n.showwarning = v
									Scorchio2:UpdateAnchors()
								end
							},
							warningtime = {
								type = 'range',
								name = L["Warning Time"],
								desc = L["Warning Time for Mirror Image"],
								order = 130,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.n.track
								end,
								get = function()
									return DB.profile.baroptions.n.warningtime
								end,
								set = function(info, v)
									DB.profile.baroptions.n.warningtime = v
									Scorchio2:UpdateAnchors()                   
								end,
								min = 0,
								max = 30,
								step = 1,
							},
							warningtext = {
								type = 'input',
								name = L["Warning Text String"],
								desc = L["Enter warning to appear when Mirror Image is about to expire."],
								width = "full",
								order = 135,
								disabled = function()
									return not DB.profile.baroptions.n.track
								end,
								get = function()
									return DB.profile.baroptions.n.warning
								end,
								set = function(info, v)
									DB.profile.baroptions.n.warning = v
								end
							},
							showexpire = {
								type = 'toggle',
								name = L["Show Expire Notices"],
								desc = L["Show notice when spell expires"],
								order = 140,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.n.track
								end,
								get = function()
									return DB.profile.baroptions.n.showexpire
								end,
								set = function(info, v)
									DB.profile.baroptions.n.showexpire = v
									Scorchio2:UpdateAnchors()
								end
							},
							expirytext = {
								type = 'input',
								name = L["Expiry Text String"],
								desc = L["Enter warning to appear when Mirror Image expires"],
								width = "full",
								order = 145,
								disabled = function()
									return not DB.profile.baroptions.n.track
								end,
								get = function()
									return DB.profile.baroptions.n.message
								end,
								set = function(info, v)
									DB.profile.baroptions.n.message = v
								end
							},
							on = {
								type = 'toggle',
								name = L["Toggle Sounds"],
								desc = L["Enable/Disable sounds for Mirror Image"],
								order = 150,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.n.track
								end,
								get = function()
									return DB.profile.baroptions.n.soundson
								end,
								set = function()
									DB.profile.baroptions.n.soundson = not DB.profile.baroptions.n.soundson
								end
							},
							warningsound = {
								type = 'select',
								name = L["Warning Sound"],
								desc = L["Change the sound played when warning time is reached"],
								order = 155,
								disabled = function()
									return not DB.profile.baroptions.n.soundson or not DB.profile.baroptions.n.track
								end,
								values = SM:List("sound"),
								get = function() 
									return GetSMIndex("sound", DB.profile.baroptions.n.warningsound)
								end,
								set = function(info, v)
									DB.profile.baroptions.n.warningsound = SM:List("sound")[v]
									PlaySoundFile(SM:Fetch("sound", DB.profile.baroptions.n.warningsound))
								end,
							},
							expiredsound = {
								type = 'select',
								name = L["Expired Sound"],
								desc = L["Change the sound played when the buff expires"],
								order = 160,
								disabled = function()
									return not DB.profile.baroptions.n.soundson or not DB.profile.baroptions.n.track
								end,
								values = SM:List("sound"),
								get = function() 
									return GetSMIndex("sound", DB.profile.baroptions.n.expiredsound)
								end,
								set = function(info, v)
									DB.profile.baroptions.n.expiredsound = SM:List("sound")[v]
									PlaySoundFile(SM:Fetch("sound", DB.profile.baroptions.n.expiredsound))
								end,
							},
						},
					},
					o = {
					type = 'group',
					name = L["Torment The Weak"],
					desc = L["Torment The Weak"],
					args = {
						track = {
							type = 'toggle',
							name = L["Track Torment The Weak"],
							desc = L["Track Torment The Weak"],
							order = 100,
							width = "full",
							get = function()
								return DB.profile.baroptions.o.track
							end,
							set = function(info, v)
								DB.profile.baroptions.o.track = v
								Scorchio2:UpdateAnchors()
							end
						}, 
						show = {
							type = 'toggle',
							name = L["Show Torment The Weak Bars"],
							desc = L["Show Torment The Weak Bars"],
							order = 105,
							disabled = function()
								return not DB.profile.baroptions.o.track
							end,
							get = function()
								return DB.profile.baroptions.o.show
							end,
							set = function(info, v)
								DB.profile.baroptions.o.show = v
								Scorchio2:UpdateAnchors()
							end
						},
						clearooc = {
							type = 'toggle',
							name = L["Fade bars when out of combat"],
							desc = L["Fade bars when out of combat"],
							order = 107,
							disabled = function()
								return not DB.profile.baroptions.o.track
							end,
							get = function()
								return DB.profile.baroptions.o.clearooc
							end,
							set = function(info, v)
								DB.profile.baroptions.o.clearooc = v
							end
						},
						bartext = {
							type = 'input',
							name = L["Bar Text String"],
							desc = L["Enter text to appear on Torment The Weak Bars."] .. L[" $s will be replaced by the spell stack. $m will be replaced by the mob name. Everything else will remain as-is."],
							width = "full",
							order = 110,
							disabled = function()
								return not DB.profile.baroptions.o.track
							end,
							get = function()
								return DB.profile.baroptions.o.bar
							end,
							set = function(info, v)
								DB.profile.baroptions.o.bar = v
								Scorchio2:UpdateAnchors()
							end
						},
						barcolour = {
							type = 'color',
							name = L["Bar Colour"],
							desc = L["Change bar colour"],
							order = 115,
							disabled = function()
								return not DB.profile.baroptions.o.track
							end,
							get = function(info)
								return unpack(DB.profile.baroptions.o.fg)
							end,
							set = function(info, r, g, b)
								DB.profile.baroptions.o.fg = {r, g, b}
								Scorchio2:UpdateAnchors()
							end,
							hasAlpha = false
						},
						backgroundcolour = {
							type = 'color',
							name = L["Background Colour"],
							desc = L["Change background colour"],
							order = 120,
							disabled = function()
								return not DB.profile.baroptions.o.track
							end,
							get = function(info)
								return unpack(DB.profile.baroptions.o.bg)
							end,
							set = function(info, r, g, b)
								DB.profile.baroptions.o.bg = {r, g, b}
								Scorchio2:UpdateAnchors()
							end,
							hasAlpha = false
						},
							targetanchor = {
								type = 'select',
								name = L["Target Anchor"],
								desc = L["Which Anchor to Attach Bars to When Targeted"],
								order = 121,
								values = { ["targeted"]=L["Targeted"], ["nontargeted"]=L["Non-Targeted"], ["buffs"]=L["Buffs"], ["none"]=L["None"] },
								get = function()
								return DB.profile.baroptions.o.targetanchor
								end,
								set = function(info, v)
								DB.profile.baroptions.o.targetanchor = v
								Scorchio2:UpdateAnchors()
								end
							},
							nontargetanchor = {
								type = 'select',
								name = L["Non-Target Anchor"],
								desc = L["Which Anchor to Attach Bars to When NOT Targeted"],
								order = 123,
								values = { ["targeted"]=L["Targeted"], ["nontargeted"]=L["Non-Targeted"], ["buffs"]=L["Buffs"], ["none"]=L["None"] },
								get = function()
								return DB.profile.baroptions.o.nontargetanchor
								end,
								set = function(info, v)
								DB.profile.baroptions.o.nontargetanchor = v
								Scorchio2:UpdateAnchors()
								end
							},
							targetalpha = {
								type = 'range',
								name = L["Target Alpha"],
								desc = L["Alpha to Apply to Bars When Targeted"],
								order = 122,
								disabled = function()
									return not DB.profile.baroptions.o.track
								end,
								get = function()
									return DB.profile.baroptions.o.targetalpha
								end,
								set = function(info, v)
									DB.profile.baroptions.o.targetalpha = v
									Scorchio2:UpdateAnchors()                   
								end,
								min = 0,
								max = 1,
								step = 0.1,
							},
							nontargetalpha = {
								type = 'range',
								name = L["Non-Target Alpha"],
								desc = L["Alpha to Apply to Bars When NOT Targeted"],
								order = 124,
								disabled = function()
									return not DB.profile.baroptions.o.track
								end,
								get = function()
									return DB.profile.baroptions.o.nontargetalpha
								end,
								set = function(info, v)
									DB.profile.baroptions.o.nontargetalpha = v
									Scorchio2:UpdateAnchors()                   
								end,
								min = 0,
								max = 1,
								step = 0.1,
							},
						showexpire = {
							type = 'toggle',
							name = L["Show Expire Notices"],
							desc = L["Show notice when Torment The Weak expires"],
							order = 125,
							width = "full",
							disabled = function()
								return not DB.profile.baroptions.o.track
							end,
							get = function()
								return DB.profile.baroptions.o.showexpire
							end,
							set = function(info, v)
								DB.profile.baroptions.o.showexpire = v
								Scorchio2:UpdateAnchors()
							end
						},
						expirytext = {
							type = 'input',
							name = L["Expiry Text String"],
							desc = L["Enter warning to appear when Torment The Weak expires"],
							width = "full",
							order = 130,
							disabled = function()
								return not DB.profile.baroptions.o.track
							end,
							get = function()
								return DB.profile.baroptions.o.message
							end,
							set = function(info, v)
								DB.profile.baroptions.o.message = v
							end
						},
						on = {
							type = 'toggle',
							name = L["Toggle Sounds"],
							desc = L["Enable/Disable sounds for Torment The Weak"],
							order = 135,
							disabled = function()
								return not DB.profile.baroptions.o.track
							end,
							get = function()
								return DB.profile.baroptions.o.soundson
							end,
							set = function()
								DB.profile.baroptions.o.soundson = not DB.profile.baroptions.o.soundson
							end
						},
						expiredsound = {
							type = 'select',
							name = L["Expired Sound"],
							desc = L["Change the sound played when the debuff expires"],
							order = 140,
							disabled = function()
								return not DB.profile.baroptions.o.soundson or not DB.profile.baroptions.o.track
							end,
							values = SM:List("sound"),
							get = function() 
								return GetSMIndex("sound", DB.profile.baroptions.o.expiredsound)
							end,
							set = function(info, v)
								DB.profile.baroptions.o.expiredsound = SM:List("sound")[v]
								PlaySoundFile(SM:Fetch("sound", DB.profile.baroptions.o.expiredsound))
							end,
						},
					},
				},
				p = {
					type = 'group',
					name = L["13% Spell Damage"],
					desc = L["13% Spell Damage"],
					args = {
						track = {
							type = 'toggle',
							name = L["Track 13% Spell Damage"],
							desc = L["Track 13% Spell Damage"],
							order = 100,
							width = "full",
							get = function()
								return DB.profile.baroptions.p.track
							end,
							set = function(info, v)
								DB.profile.baroptions.p.track = v
								Scorchio2:UpdateAnchors()
							end
						}, 
						show = {
							type = 'toggle',
							name = L["Show 13% Spell Damage Bars"],
							desc = L["Show 13% Spell Damage Bars"],
							order = 105,
							disabled = function()
								return not DB.profile.baroptions.p.track
							end,
							get = function()
								return DB.profile.baroptions.p.show
							end,
							set = function(info, v)
								DB.profile.baroptions.p.show = v
								Scorchio2:UpdateAnchors()
							end
						},
						clearooc = {
							type = 'toggle',
							name = L["Fade bars when out of combat"],
							desc = L["Fade bars when out of combat"],
							order = 107,
							disabled = function()
								return not DB.profile.baroptions.p.track
							end,
							get = function()
								return DB.profile.baroptions.p.clearooc
							end,
							set = function(info, v)
								DB.profile.baroptions.p.clearooc = v
							end
						},
						bartext = {
							type = 'input',
							name = L["Bar Text String"],
							desc = L["Enter text to appear on 13% Spell Damage Bars."] .. L[" $s will be replaced by the spell stack. $m will be replaced by the mob name. Everything else will remain as-is."],
							width = "full",
							order = 110,
							disabled = function()
								return not DB.profile.baroptions.p.track
							end,
							get = function()
								return DB.profile.baroptions.p.bar
							end,
							set = function(info, v)
								DB.profile.baroptions.p.bar = v
								Scorchio2:UpdateAnchors()
							end
						},
						barcolour = {
							type = 'color',
							name = L["Bar Colour"],
							desc = L["Change bar colour"],
							order = 115,
							disabled = function()
								return not DB.profile.baroptions.p.track
							end,
							get = function(info)
								return unpack(DB.profile.baroptions.p.fg)
							end,
							set = function(info, r, g, b)
								DB.profile.baroptions.p.fg = {r, g, b}
								Scorchio2:UpdateAnchors()
							end,
							hasAlpha = false
						},
						backgroundcolour = {
							type = 'color',
							name = L["Background Colour"],
							desc = L["Change background colour"],
							order = 120,
							disabled = function()
								return not DB.profile.baroptions.p.track
							end,
							get = function(info)
								return unpack(DB.profile.baroptions.p.bg)
							end,
							set = function(info, r, g, b)
								DB.profile.baroptions.p.bg = {r, g, b}
								Scorchio2:UpdateAnchors()
							end,
							hasAlpha = false
						},
							targetanchor = {
								type = 'select',
								name = L["Target Anchor"],
								desc = L["Which Anchor to Attach Bars to When Targeted"],
								order = 121,
								values = { ["targeted"]=L["Targeted"], ["nontargeted"]=L["Non-Targeted"], ["buffs"]=L["Buffs"], ["none"]=L["None"] },
								get = function()
								return DB.profile.baroptions.p.targetanchor
								end,
								set = function(info, v)
								DB.profile.baroptions.p.targetanchor = v
								Scorchio2:UpdateAnchors()
								end
							},
							nontargetanchor = {
								type = 'select',
								name = L["Non-Target Anchor"],
								desc = L["Which Anchor to Attach Bars to When NOT Targeted"],
								order = 123,
								values = { ["targeted"]=L["Targeted"], ["nontargeted"]=L["Non-Targeted"], ["buffs"]=L["Buffs"], ["none"]=L["None"] },
								get = function()
								return DB.profile.baroptions.p.nontargetanchor
								end,
								set = function(info, v)
								DB.profile.baroptions.p.nontargetanchor = v
								Scorchio2:UpdateAnchors()
								end
							},
							targetalpha = {
								type = 'range',
								name = L["Target Alpha"],
								desc = L["Alpha to Apply to Bars When Targeted"],
								order = 122,
								disabled = function()
									return not DB.profile.baroptions.p.track
								end,
								get = function()
									return DB.profile.baroptions.p.targetalpha
								end,
								set = function(info, v)
									DB.profile.baroptions.p.targetalpha = v
									Scorchio2:UpdateAnchors()                   
								end,
								min = 0,
								max = 1,
								step = 0.1,
							},
							nontargetalpha = {
								type = 'range',
								name = L["Non-Target Alpha"],
								desc = L["Alpha to Apply to Bars When NOT Targeted"],
								order = 124,
								disabled = function()
									return not DB.profile.baroptions.p.track
								end,
								get = function()
									return DB.profile.baroptions.p.nontargetalpha
								end,
								set = function(info, v)
									DB.profile.baroptions.p.nontargetalpha = v
									Scorchio2:UpdateAnchors()                   
								end,
								min = 0,
								max = 1,
								step = 0.1,
							},
						showexpire = {
							type = 'toggle',
							name = L["Show Expire Notices"],
							desc = L["Show notice when 13% Spell Damage expires"],
							order = 125,
							width = "full",
							disabled = function()
								return not DB.profile.baroptions.p.track
							end,
							get = function()
								return DB.profile.baroptions.p.showexpire
							end,
							set = function(info, v)
								DB.profile.baroptions.p.showexpire = v
								Scorchio2:UpdateAnchors()
							end
						},
						expirytext = {
							type = 'input',
							name = L["Expiry Text String"],
							desc = L["Enter warning to appear when 13% Spell Damage expires"],
							width = "full",
							order = 130,
							disabled = function()
								return not DB.profile.baroptions.p.track
							end,
							get = function()
								return DB.profile.baroptions.p.message
							end,
							set = function(info, v)
								DB.profile.baroptions.p.message = v
							end
						},
						on = {
							type = 'toggle',
							name = L["Toggle Sounds"],
							desc = L["Enable/Disable sounds for 13% Spell Damage"],
							order = 135,
							disabled = function()
								return not DB.profile.baroptions.p.track
							end,
							get = function()
								return DB.profile.baroptions.p.soundson
							end,
							set = function()
								DB.profile.baroptions.p.soundson = not DB.profile.baroptions.p.soundson
							end
						},
						expiredsound = {
							type = 'select',
							name = L["Expired Sound"],
							desc = L["Change the sound played when the debuff expires"],
							order = 140,
							disabled = function()
								return not DB.profile.baroptions.p.soundson or not DB.profile.baroptions.p.track
							end,
							values = SM:List("sound"),
							get = function() 
								return GetSMIndex("sound", DB.profile.baroptions.p.expiredsound)
							end,
							set = function(info, v)
								DB.profile.baroptions.p.expiredsound = SM:List("sound")[v]
								PlaySoundFile(SM:Fetch("sound", DB.profile.baroptions.p.expiredsound))
							end,
						},
					},
				},
					q = {
						type = 'group',
						name = L["Frostfire Bolt"],
						desc = L["Frostfire Bolt"],
						args = {
							track = {
								type = 'toggle',
								name = L["Track Frostfire Bolt"],
								desc = L["Track Frostfire Bolt"],
								order = 10,
								width = "full",
								get = function()
									return DB.profile.baroptions.q.track
								end,
								set = function(info, v)
									DB.profile.baroptions.q.track = v
									Scorchio2:UpdateAnchors()
								end
							}, 
							show = {
								type = 'toggle',
								name = L["Show Frostfire Bolt Bars"],
								desc = L["Show Frostfire Bolt Bars"],
								order = 20,
								disabled = function()
									return not DB.profile.baroptions.q.track
								end,
								get = function()
									return DB.profile.baroptions.q.show
								end,
								set = function(info, v)
									DB.profile.baroptions.q.show = v
									Scorchio2:UpdateAnchors()
								end
							},
							clearooc = {
								type = 'toggle',
								name = L["Fade bars when out of combat"],
								desc = L["Fade bars when out of combat"],
								order = 30,
								disabled = function()
									return not DB.profile.baroptions.q.track
								end,
								get = function()
									return DB.profile.baroptions.q.clearooc
								end,
								set = function(info, v)
									DB.profile.baroptions.q.clearooc = v
								end
							},
							bartext = {
								type = 'input',
								name = L["Bar Text String"],
								desc = L["Enter text to appear on Frostfire Bolt Bars."] .. L[" $s will be replaced by the spell stack. $m will be replaced by the mob name. Everything else will remain as-is."],
								width = "full",
								order = 40,
								disabled = function()
									return not DB.profile.baroptions.q.track
								end,
								get = function()
									return DB.profile.baroptions.q.bar
								end,
								set = function(info, v)
									DB.profile.baroptions.q.bar = v
									Scorchio2:UpdateAnchors()
								end
							},
							barcolour = {
								type = 'color',
								name = L["Bar Colour"],
								desc = L["Change bar colour"],
								order = 50,
								disabled = function()
									return not DB.profile.baroptions.q.track
								end,
								get = function(info)
									return unpack(DB.profile.baroptions.q.fg)
								end,
								set = function(info, r, g, b)
									DB.profile.baroptions.q.fg = {r, g, b}
									Scorchio2:UpdateAnchors()
								end,
								hasAlpha = false
							},
							backgroundcolour = {
								type = 'color',
								name = L["Background Colour"],
								desc = L["Change background colour"],
								order = 60,
								disabled = function()
									return not DB.profile.baroptions.q.track
								end,
								get = function(info)
									return unpack(DB.profile.baroptions.q.bg)
								end,
								set = function(info, r, g, b)
									DB.profile.baroptions.q.bg = {r, g, b}
									Scorchio2:UpdateAnchors()
								end,
								hasAlpha = false
							},
							targetanchor = {
								type = 'select',
								name = L["Target Anchor"],
								desc = L["Which Anchor to Attach Bars to When Targeted"],
								order = 70,
								disabled = function()
									return not DB.profile.baroptions.q.track
								end,
								values = { ["targeted"]=L["Targeted"], ["nontargeted"]=L["Non-Targeted"], ["buffs"]=L["Buffs"], ["none"]=L["None"] },
								get = function()
								return DB.profile.baroptions.q.targetanchor
								end,
								set = function(info, v)
								DB.profile.baroptions.q.targetanchor = v
								Scorchio2:UpdateAnchors()
								end
							},
							nontargetanchor = {
								type = 'select',
								name = L["Non-Target Anchor"],
								desc = L["Which Anchor to Attach Bars to When NOT Targeted"],
								order = 80,
								disabled = function()
									return not DB.profile.baroptions.q.track
								end,
								values = { ["targeted"]=L["Targeted"], ["nontargeted"]=L["Non-Targeted"], ["buffs"]=L["Buffs"], ["none"]=L["None"] },
								get = function()
								return DB.profile.baroptions.q.nontargetanchor
								end,
								set = function(info, v)
								DB.profile.baroptions.q.nontargetanchor = v
								Scorchio2:UpdateAnchors()
								end
							},
							targetalpha = {
								type = 'range',
								name = L["Target Alpha"],
								desc = L["Alpha to Apply to Bars When Targeted"],
								order = 90,
								disabled = function()
									return not DB.profile.baroptions.q.track
								end,
								get = function()
									return DB.profile.baroptions.q.targetalpha
								end,
								set = function(info, v)
									DB.profile.baroptions.q.targetalpha = v
									Scorchio2:UpdateAnchors()                   
								end,
								min = 0,
								max = 1,
								step = 0.1,
							},
							nontargetalpha = {
								type = 'range',
								name = L["Non-Target Alpha"],
								desc = L["Alpha to Apply to Bars When NOT Targeted"],
								order = 100,
								disabled = function()
									return not DB.profile.baroptions.q.track
								end,
								get = function()
									return DB.profile.baroptions.q.nontargetalpha
								end,
								set = function(info, v)
									DB.profile.baroptions.q.nontargetalpha = v
									Scorchio2:UpdateAnchors()                   
								end,
								min = 0,
								max = 1,
								step = 0.1,
							},
							showwarning = {
								type = 'toggle',
								name = L["Show Warnings"],
								desc = L["Show warning when spell is about to expire"],
								order = 110,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.q.track
								end,
								get = function()
									return DB.profile.baroptions.q.showwarning
								end,
								set = function(info, v)
									DB.profile.baroptions.q.showwarning = v
									Scorchio2:UpdateAnchors()
								end
							},
							warningtime = {
								type = 'range',
								name = L["Warning Time"],
								desc = L["Warning Time for Frostfire Bolt"],
								order = 120,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.q.track
								end,
								get = function()
									return DB.profile.baroptions.q.warningtime
								end,
								set = function(info, v)
									DB.profile.baroptions.q.warningtime = v
									Scorchio2:UpdateAnchors()                   
								end,
								min = 0,
								max = 12,
								step = 1,
							},
							warningtext = {
								type = 'input',
								name = L["Warning Text String"],
								desc = L["Enter warning to appear when Frostfire Bolt will fade."] .. L[" $s will be replaced by the spell stack. $m will be replaced by the mob name. Everything else will remain as-is."],
								width = "full",
								order = 130,
								disabled = function()
									return not DB.profile.baroptions.q.track
								end,
								get = function()
									return DB.profile.baroptions.q.warning
								end,
								set = function(info, v)
									DB.profile.baroptions.q.warning = v
								end
							},
							showexpire = {
								type = 'toggle',
								name = L["Show Expire Notices"],
								desc = L["Show notice when spell expires"],
								order = 140,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.q.track
								end,
								get = function()
									return DB.profile.baroptions.q.showexpire
								end,
								set = function(info, v)
									DB.profile.baroptions.q.showexpire = v
									Scorchio2:UpdateAnchors()
								end
							},
							expirytext = {
								type = 'input',
								name = L["Expiry Text String"],
								desc = L["Enter message to appear when Frostfire Bolt expires."] .. L[" $s will be replaced by the spell stack. $m will be replaced by the mob name. Everything else will remain as-is."],
								width = "full",
								order = 140,
								disabled = function()
									return not DB.profile.baroptions.q.track
								end,
								get = function()
									return DB.profile.baroptions.q.message
								end,
								set = function(info, v)
									DB.profile.baroptions.q.message = v
								end
							},
							on = {
								type = 'toggle',
								name = L["Toggle Sounds"],
								desc = L["Enable/Disable sounds for Frostfire Bolt"],
								order = 150,
								width = "full",
								disabled = function()
									return not DB.profile.baroptions.q.track
								end,
								get = function()
									return DB.profile.baroptions.q.soundson
								end,
								set = function()
									DB.profile.baroptions.q.soundson = not DB.profile.baroptions.q.soundson
								end
							},
							warningsound = {
								type = 'select',
								name = L["Warning Sound"],
								desc = L["Change the sound played when warning time is reached"],
								order = 160,
								disabled = function()
									return not DB.profile.baroptions.q.soundson or not DB.profile.baroptions.q.track
								end,
								values = SM:List("sound"),
								get = function() 
									return GetSMIndex("sound", DB.profile.baroptions.q.warningsound)
								end,
								set = function(info, v)
									DB.profile.baroptions.q.warningsound = SM:List("sound")[v]
									PlaySoundFile(SM:Fetch("sound", DB.profile.baroptions.q.warningsound))
								end,
							},
							expiredsound = {
								type = 'select',
								name = L["Expired Sound"],
								desc = L["Change the sound played when the debuff expires"],
								order = 170,
								disabled = function()
									return not DB.profile.baroptions.q.soundson or not DB.profile.baroptions.q.track
								end,
								values = SM:List("sound"),
								get = function() 
									return GetSMIndex("sound", DB.profile.baroptions.q.expiredsound)
								end,
								set = function(info, v)
									DB.profile.baroptions.q.expiredsound = SM:List("sound")[v]
									PlaySoundFile(SM:Fetch("sound", DB.profile.baroptions.q.expiredsound))
								end,
							},
						},
					},
			},
		},
    output = Scorchio2:GetSinkAce3OptionsDataTable(),
    }, -- closes top level group args
} -- closes options
    

    
-- Add-on Functions
function Scorchio2:OnInitialize()

    Scorchio2.db = LibStub("AceDB-3.0"):New("Scorchio2DB", defaults, "Default")
	DB = Scorchio2.db
    
    AceConfig:RegisterOptionsTable("Scorchio2", options)
	
	Scorchio2:RegisterChatCommand("scorchio", function() LibStub("AceConfigDialog-3.0"):Open("Scorchio2") end )
	Scorchio2:RegisterChatCommand("scorchio2", function() LibStub("AceConfigDialog-3.0"):Open("Scorchio2") end )
	local optFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Scorchio2", "Scorchio2")
	options.args.profile = LibStub("AceDBOptions-3.0"):GetOptionsTable(DB)
	Scorchio2:SetSinkStorage(DB.profile.sinkoptions)

	
	DB.RegisterCallback(Scorchio2, "OnProfileCopied", "UpdateAnchors")
    DB.RegisterCallback(Scorchio2, "OnProfileReset", "UpdateAnchors")	

    SM.RegisterCallback(Scorchio2, "LibSharedMedia_Registered", "UpdateAnchors")
    SM.RegisterCallback(Scorchio2, "LibSharedMedia_SetGlobal", "UpdateAnchors")
    
    Scorchio2:CreateAnchor("targeted")
	Scorchio2:CreateAnchor("nontargeted")
	Scorchio2:CreateAnchor("buffs")
    
    lastTargetGUID = "0"
    mobTable = { }
    combatFlag = false
    waterElementalGUID = nil
	
    -- Populate table with localised spellnames as Blizzard won't let us check auras against spellID's...
    localSpellNames = { }
	local GetSpellInfo = _G.GetSpellInfo
    for k, v in pairs(VULNERABILITIES) do
        for kk, vv in pairs(v) do
            local spellName = GetSpellInfo(kk)
            local insertFlag = true
            for i = 1, #localSpellNames do
                if localSpellNames[i] == spellName then insertFlag = false end
            end
			if spellName == nil then
				self:Print("|cffff2222Error: Vulnerability ID ("..kk..") produces nil spell name|r")
				insertFlag = false
			end
            if insertFlag then localSpellNames[spellName] = k end
        end
    end
--~ 	localJudgementNames = { }
--~ 	for k, v in pairs(JUDGEMENTS) do
--~ 		localJudgementNames[GetSpellInfo(k)] = 15
--~ 	end
end

function Scorchio2:OnEnable()
    Scorchio2:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
    Scorchio2:RegisterEvent("PLAYER_REGEN_ENABLED")
    Scorchio2:RegisterEvent("PLAYER_REGEN_DISABLED")
    Scorchio2:RegisterEvent("PLAYER_TARGET_CHANGED")
end

function Scorchio2:OnDisable()
	Scorchio2:UnregisterAllEvents()
end

-- Bar and Anchor Functions
function Scorchio2:CreateAnchor(anchor)
	Scorchio2[anchor] = Scorchio2:NewBarGroup(anchor, nil, DB.profile.anchoroptions[anchor].width, DB.profile.anchoroptions[anchor].height)
	Scorchio2[anchor]:ClearAllPoints()
	
	Scorchio2[anchor].id = anchor
	Scorchio2[anchor].RegisterCallback(Scorchio2, "AnchorClicked", "AnchorClicked")
	Scorchio2[anchor]:HideAnchor()
	Scorchio2[anchor]:SetSortFunction(Scorchio2.SortBars)
	Scorchio2:UpdateAnchor(anchor)
end

function Scorchio2:RunTest(anchor)
	if anchor == "buffs" then
		Scorchio2:UpdateTable("Test1", "Hot Streak", 6, GetTime(), 1, nil, nil, anchor)
		Scorchio2:UpdateTable("Test2", "Clearcasting", 8, GetTime(), 1, nil, nil, anchor)
	else
		Scorchio2:UpdateTable("Test1", "Test Mob 1", 1, GetTime(), 5, nil, nil, anchor)
		Scorchio2:UpdateTable("Test2", "Test Mob 2", 3, GetTime(), 1, nil, nil, anchor)
		Scorchio2:UpdateTable("Test3", "Test Mob 3", 2, GetTime(), 3, nil, nil, anchor)
		Scorchio2:UpdateTable("Test4", "Test Mob 4", 4, GetTime(), 1, nil, nil, anchor)
	end
end

function Scorchio2:AnchorClicked(callback, group, button)
	Scorchio2:SavePosition(group.id)
	if button == "RightButton" then
		group:HideAnchor()
		group:Lock()
	end
end
function Scorchio2:ToggleAnchors(anchor)
	if Scorchio2[anchor].button:IsVisible() then
		Scorchio2[anchor]:HideAnchor()
		Scorchio2[anchor]:Lock()
	else
		Scorchio2[anchor]:ShowAnchor()
		Scorchio2[anchor]:Unlock()
	end
end

function Scorchio2:SavePosition(anchor)
	local p,_,pr,px,py = Scorchio2[anchor]:GetPoint()
	DB.profile.anchoroptions[anchor].position.p = p
	DB.profile.anchoroptions[anchor].position.pr = pr
	DB.profile.anchoroptions[anchor].position.px = px
	DB.profile.anchoroptions[anchor].position.py = py
end

function Scorchio2:UpdateAnchor(anchor)
	Scorchio2[anchor]:SetTexture(SM:Fetch("statusbar", DB.profile.anchoroptions[anchor].texture))
	Scorchio2[anchor]:SetFont(SM:Fetch("font", DB.profile.anchoroptions[anchor].font), DB.profile.anchoroptions[anchor].fontsize)
	Scorchio2[anchor]:SetWidth(DB.profile.anchoroptions[anchor].width)
	Scorchio2[anchor]:SetHeight(DB.profile.anchoroptions[anchor].height)
	Scorchio2[anchor]:SetScale(DB.profile.anchoroptions[anchor].scale)
	Scorchio2[anchor]:ReverseGrowth(DB.profile.anchoroptions[anchor].growth)
    Scorchio2[anchor]:SetOrientation(DB.profile.anchoroptions[anchor].orientation)
    if DB.profile.anchoroptions[anchor].maxbars == 0 then
        Scorchio2[anchor]:SetMaxBars(nil)
    else
        Scorchio2[anchor]:SetMaxBars(DB.profile.anchoroptions[anchor].maxbars)
    end
	Scorchio2[anchor]:SetFlashPeriod(0)

	if DB.profile.anchoroptions[anchor].flash then
		Scorchio2[anchor]:SetFlashPeriod(DB.profile.anchoroptions[anchor].flashtime)
	end

	if not DB.profile.anchoroptions[anchor].position then DB.profile.anchoroptions[anchor].position = {} end
	if DB.profile.anchoroptions[anchor].position.p
       and DB.profile.anchoroptions[anchor].position.pr
       and DB.profile.anchoroptions[anchor].position.px
       and DB.profile.anchoroptions[anchor].position.py then
		Scorchio2[anchor]:ClearAllPoints()
		Scorchio2[anchor]:SetPoint(DB.profile.anchoroptions[anchor].position.p, UIParent, DB.profile.anchoroptions[anchor].position.pr, DB.profile.anchoroptions[anchor].position.px, DB.profile.anchoroptions[anchor].position.py)
		else
			Scorchio2[anchor]:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
		end
end

function Scorchio2:UpdateAnchors()
	Scorchio2:UpdateAnchor("targeted")
	Scorchio2:UpdateAnchor("nontargeted")
	Scorchio2:UpdateAnchor("buffs")
end

function Scorchio2.SortBars(a, b)
	if a.isTimer ~= b.isTimer then
		return a.isTimer
	end
	
	if a.maxValue == b.maxValue then
		if a.value == b.value then
			return a.name > b.name
		else
			return a.value > b.value
		end
	else
		return a.maxValue > b.maxValue
	end
end


-- Event Handling Functions

function Scorchio2:WaterElementalLifeSpan()
    local playerClass, englishClass = UnitClass("player")
    if englishClass ~= "MAGE" then return 0 end
    local _, _, _, _, currRank, _ = GetTalentInfo(3,26)
    return 45 + (currRank * 5)
end

function Scorchio2:inCombat()
    if combatFlag then return true end
    if InCombatLockdown("player") then return true end
    return false
end

function Scorchio2:COMBAT_LOG_EVENT_UNFILTERED(_, _, event, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, ...)
    local _, _, prefix, suffix = strfind(event, "(.-)_(.+)")

    local timeStamp = GetTime()
 	
	if (prefix == "SPELL") then
		local spellID, spellName, spellSchool, spellAuraType, spellCount, fvApplied
		local spellCount = -1
		local spellID = ...
		local isPlayer = false
		if bit_band(dstFlags, COMBATLOG_OBJECT_TYPE_PLAYER) == COMBATLOG_OBJECT_TYPE_PLAYER then
		    isPlayer = true
		end
		
		if (suffix == "CAST_START") then
		    if Scorchio2:inCombat() then return end
		    for k, v in pairs(SPELLIDS) do
                if v[spellID] then
                    if bit_band(srcFlags, AFFILIATION) ~= 0 then
                    Scorchio2:PLAYER_REGEN_DISABLED()
                    end
                end
		    end
		elseif (suffix == "CAST_FAILED") then
		    if InCombatLockdown("player") then return end
		    Scorchio2:PLAYER_REGEN_ENABLED()
		end
        
        if (suffix == "AURA_REMOVED") then	
		    spellCount = -1
			local spellID = ...
		    Scorchio2:CheckVuln(spellID, spellCount, timeStamp, dstGUID, dstName, isPlayer, srcFlags, dstFlags, srcGUID)
        end
        
        if (suffix == "SUMMON") then
            if spellID == 31687 and bit_band(srcFlags, COMBATLOG_OBJECT_AFFILIATION_MINE) ~= 0 and DB.profile.baroptions.m.track then
                waterElementalGUID = dstGUID
                Scorchio2:UpdateTable(waterElementalGUID, dstName, 13, timeStamp, 1, false, Scorchio2:WaterElementalLifeSpan())
            elseif spellID == 58833 and bit_band(srcFlags, COMBATLOG_OBJECT_AFFILIATION_MINE) ~= 0 and DB.profile.baroptions.n.track then
                Scorchio2:UpdateTable(srcGUID, srcName, 14, timeStamp, 1, true, 30)
            end
        end
        
		if not Scorchio2:inCombat() then return end
		
		if (suffix == "AURA_APPLIED") then
		    spellCount = 1
			local spellID = ...
		    Scorchio2:CheckVuln(spellID, spellCount, timeStamp, dstGUID, dstName, isPlayer, srcFlags, dstFlags, srcGUID)
		elseif (suffix == "AURA_APPLIED_DOSE") then
			local spellID,_,_,_,spellCount = ...
		    Scorchio2:CheckVuln(spellID, spellCount, timeStamp, dstGUID, dstName, isPlayer, srcFlags, dstFlags, srcGUID)
		elseif (suffix == "AURA_REFRESH") then
			local spellID = ...
		    Scorchio2:CheckVuln(spellID, nil, timeStamp, dstGUID, dstName, isPlayer, srcFlags, dstFlags, srcGUID)

		elseif (suffix == "AURA_REMOVED_DOSE") then						
			local spellID,_,_,_,spellCount = ...
		    Scorchio2:CheckVuln(spellID, spellCount, timeStamp, dstGUID, dstName, isPlayer, srcFlags, dstFlags, srcGUID)			
		elseif (suffix == "AURA_BROKEN_SPELL") then
			local _,_,_,_,spellCount = ...
		    Scorchio2:AuraBroken(dstGUID, srcName, spellCount)
		elseif (suffix == "AURA_BROKEN") then
		    Scorchio2:AuraBroken(dstGUID, srcName, L["Hitting It!"])
		end
	elseif (prefix == "UNIT") then
        if dstGUID == waterElementalGUID then
            Scorchio2:LostVuln(waterElementalGUID, 13)
            Scorchio2:MobDies(waterElementalGUID, dstName)
            waterElementalGUID = nil
        elseif dstName ~= nil and mobTable[dstGUID] ~= nil then
			Scorchio2:MobDies(dstGUID, dstName)
		end
	end
end

function Scorchio2:PLAYER_REGEN_ENABLED()
    combatFlag = false
    for k, v in pairs(mobTable) do
        for kk = 1,#T do
            if DB.profile.baroptions[T[kk]].clearooc then
                if mobTable[k][T[kk]] then
                    if mobTable[k][T[kk]][BAR] then
                        mobTable[k][T[kk]][BAR]:Fade(0.5)
                        Scorchio2:ReleaseBar(mobTable[k][T[kk]][BAR])
                    end
                    if mobTable[k][T[kk]][TIMER] then
                        Scorchio2:CancelTimer(mobTable[k][T[kk]][TIMER], true)
                    end
                    mobTable[k][T[kk]] = nil
                end
            end
        end
    end
    lastTargetGUID = "0"
end

function Scorchio2:PLAYER_REGEN_DISABLED()
    combatFlag = true
    Scorchio2:ScanAuras("target")
end

function Scorchio2:PLAYER_TARGET_CHANGED()
    if mobTable[lastTargetGUID] then
        for k = 1,#T do
            if mobTable[lastTargetGUID][T[k]] then
                if mobTable[lastTargetGUID][T[k]][BAR] then
					mobTable[lastTargetGUID][T[k]][BAR]:Fade(0.5)
					Scorchio2:ReleaseBar(mobTable[lastTargetGUID][T[k]][BAR])
					mobTable[lastTargetGUID][T[k]][BAR] = nil  
					Scorchio2:UpdateTable(lastTargetGUID, mobTable[lastTargetGUID][T[k]][MOBNAME], k, GetTime(), mobTable[lastTargetGUID][T[k]][STACK], false, mobTable[lastTargetGUID][T[k]][EXPIRATIONTIME]-GetTime(),DB.profile.baroptions[T[k]].nontargetanchor, DB.profile.baroptions[T[k]].nontargetalpha)
                end
            end
        end
    end
    if UnitExists("target") then
		lastTargetGUID = UnitGUID("target")
        for k = 1,#T do
            if mobTable[lastTargetGUID] then
                if mobTable[lastTargetGUID][T[k]] then
					if mobTable[lastTargetGUID][T[k]][BAR] then
						mobTable[lastTargetGUID][T[k]][BAR]:Fade(0.5)
						Scorchio2:ReleaseBar(mobTable[lastTargetGUID][T[k]][BAR])
						mobTable[lastTargetGUID][T[k]][BAR] = nil 
						Scorchio2:UpdateTable(lastTargetGUID, mobTable[lastTargetGUID][T[k]][MOBNAME], k, GetTime(), mobTable[lastTargetGUID][T[k]][STACK], false, mobTable[lastTargetGUID][T[k]][EXPIRATIONTIME]-GetTime(),DB.profile.baroptions[T[k]].targetanchor, DB.profile.baroptions[T[k]].targetalpha)
                    end
                end
            end
        end
        Scorchio2:ScanAuras("target")
	else
		lastTargetGUID = "0"
	end
end

-- mobTable Handling Functions
function Scorchio2:MobDies(dstGUID, dstName)
    for k = 1,#T do
        if mobTable[dstGUID][T[k]] then
            if mobTable[dstGUID][T[k]][BAR] then
                mobTable[dstGUID][T[k]][BAR]:Fade(0.5)
                Scorchio2:ReleaseBar(mobTable[dstGUID][T[k]][BAR])
            end
            if mobTable[dstGUID][T[k]][TIMER] then
                Scorchio2:CancelTimer(mobTable[dstGUID][T[k]][TIMER], true) 
            end
        end
    end
    mobTable[dstGUID] = nil
--~     raidIconTable[self:GetGUID(fullMobName)] = nil
--~     self:UnregisterEnniBarWithGroup(fullMobName,SB)
--~     self:UnregisterEnniBar(fullMobName)
end

function Scorchio2:CheckVuln(spellID, spellCount, timeStamp, dstGUID, dstName, isPlayer, srcFlags, dstFlags, srcGUID)
    for k, v in pairs(VULNERABILITIES) do
        if v[spellID] then
            if VULNDATA[k].self then
                if bit_band(dstFlags, VULNDATA[k].valid) ~= 0 and DB.profile.baroptions[T[k]].track then
                    Scorchio2:UpdateTable(dstGUID, dstName, k, timeStamp, spellCount, isPlayer)
					Scorchio2:ScanAuras("player")
                end
            else
                if bit_band(srcFlags, VULNDATA[k].valid) ~= 0 and DB.profile.baroptions[T[k]].track then
					Scorchio2:UpdateTable(dstGUID, dstName, k, timeStamp, spellCount, isPlayer)
					Scorchio2:ScanAuras("target")
                end
            end
        end
    end
end


function Scorchio2:AuraBroken(dstGUID, srcName, cause)
    if dstGUID then
        if mobTable[dstGUID] then
            if mobTable[dstGUID][T[4]] and DB.profile.baroptions.d.telltale then
				local telltale = L["Polymorph broken on "] .. tostring(mobTable[dstGUID][T[4]][MOBNAME]) .. L[" by "] .. srcName .. " (" .. tostring(cause) .. ")"
                Scorchio2:Pour(telltale, 1, 1, 1)
				Scorchio2:Print(telltale)
            end
        end
    end
end 
    
function Scorchio2:LostVuln(dstGUID, vulnKey)
	if mobTable[dstGUID][T[vulnKey]][BAR] then
        mobTable[dstGUID][T[vulnKey]][BAR]:Fade(0.5)
        Scorchio2:ReleaseBar(mobTable[dstGUID][T[vulnKey]][BAR])
    end
    if mobTable[dstGUID][T[vulnKey]][TIMER] then
        Scorchio2:CancelTimer(mobTable[dstGUID][T[vulnKey]][TIMER], true)
    end
    
    if Scorchio2:inCombat() or not DB.profile.baroptions[T[vulnKey]].clearooc then
        if (GetTime() - mobTable[dstGUID][T[vulnKey]][REFRESHTIME] > ( mobTable[dstGUID][T[vulnKey]][DURATION] - 0.25 )) or (dstGUID == waterElementalGUID) then
            if DB.profile.baroptions[T[vulnKey]].soundson then
                PlaySoundFile(SM:Fetch("sound", DB.profile.baroptions[T[vulnKey]].expiredsound))
            end
            if DB.profile.baroptions[T[vulnKey]].showexpire then
                Scorchio2:Pour(SubTokens(DB.profile.baroptions[T[vulnKey]].message, mobTable[dstGUID][T[vulnKey]][MOBNAME]), 1, 0, 0)
            end
        end
    end

    mobTable[dstGUID][T[vulnKey]] = nil
end

function Scorchio2:TimerComplete(info)
    local dstGUID, vulnKey = info[1], info[2]
	local timerTime = GetTime()
    if mobTable[dstGUID][T[vulnKey]] then
		if floor((timerTime - mobTable[dstGUID][T[vulnKey]][REFRESHTIME]) + 0.5) >= (mobTable[dstGUID][T[vulnKey]][DURATION] - DB.profile.baroptions[T[vulnKey]].warningtime) then
			if DB.profile.baroptions[T[vulnKey]].soundson then
				PlaySoundFile(SM:Fetch("sound", DB.profile.baroptions[T[vulnKey]].warningsound))
			end
			Scorchio2:Pour(SubTokens(DB.profile.baroptions[T[vulnKey]].warning, mobTable[dstGUID][T[vulnKey]][MOBNAME]), 1, 0.647, 0)
		end
	end
end


function Scorchio2:ScanAuras(unitID)
    if not UnitExists(unitID) then return end
    if not Scorchio2:inCombat() then return end
    local dstGUID = UnitGUID(unitID)
    local dstName = UnitName(unitID)
    local isPlayer = UnitIsPlayer(unitID)
    if isPlayer == nil then isPlayer = false end
    for i = 1, 40 do
        local name, _, _, count, _, duration, expirationTime, unitCaster, _ = UnitDebuff(unitID, i)
		local isName = localSpellNames[name]
--        for k, v in pairs(localSpellNames) do
--            if k == name and DB.profile.baroptions[T[v]].track then
            if isName and DB.profile.baroptions[T[isName]].track then
				if (VULNDATA[isName].valid == COMBATLOG_OBJECT_AFFILIATION_MINE and unitCaster == "player") or VULNDATA[isName].valid ~= COMBATLOG_OBJECT_AFFILIATION_MINE then
						Scorchio2:UpdateTable(dstGUID, dstName, isName, GetTime(), count, isPlayer, expirationTime - GetTime())
				end
--            end
        end
    end
end    

function Scorchio2:UpdateTable(dstGUID, dstName, vulnKey, timeStamp, spellCount, isPlayer, timeToRun, anchor, alpha)
	if mobTable[dstGUID] == nil then
        mobTable[dstGUID] = { }
    end
    if mobTable[dstGUID][T[vulnKey]] == nil then
        mobTable[dstGUID][T[vulnKey]] = {dstName, timeStamp, 0, 0, 0, nil }
        if DB.profile.baroptions[T[vulnKey]].soundson then
            PlaySoundFile(SM:Fetch("sound", DB.profile.baroptions[T[vulnKey]].procsound))
        end
        if DB.profile.baroptions[T[vulnKey]].showproc then 
            Scorchio2:Pour(DB.profile.baroptions[T[vulnKey]].apply, 1, 0, 0)
        end    
    end
	
	if anchor == nil then
		if tostring(dstGUID) == UnitGUID("target") then
			lastTargetGUID = dstGUID
			anchor = DB.profile.baroptions[T[vulnKey]].targetanchor
			alpha = DB.profile.baroptions[T[vulnKey]].targetalpha
		else
			anchor = DB.profile.baroptions[T[vulnKey]].nontargetanchor
			alpha = DB.profile.baroptions[T[vulnKey]].nontargetalpha
		end
	end
	
    if spellCount == nil then spellCount = mobTable[dstGUID][T[vulnKey]][STACK] + 1 end
    if spellCount > VULNDATA[vulnKey].maxstacks then spellCount = VULNDATA[vulnKey].maxstacks end
    if spellCount < 0 then
        Scorchio2:LostVuln(dstGUID, vulnKey)
    else
        local warningTime = DB.profile.baroptions[T[vulnKey]].warningtime
        local icon = DB.profile.baroptions[T[vulnKey]].icon
		local duration
        if isPlayer == true then
            duration = VULNDATA[vulnKey].durationpvp
        else
            duration = VULNDATA[vulnKey].durationpve
        end
        mobTable[dstGUID][T[vulnKey]][STACK] = spellCount
        mobTable[dstGUID][T[vulnKey]][REFRESHTIME] = timeStamp
		
        if timeToRun == nil then
            timeToRun = duration - (GetTime() - timeStamp)
        end
        mobTable[dstGUID][T[vulnKey]][DURATION] = timeToRun
		mobTable[dstGUID][T[vulnKey]][EXPIRATIONTIME] = timeStamp + timeToRun
		if mobTable[dstGUID][T[vulnKey]][BAR] then
			if mobTable[dstGUID][T[vulnKey]][BAR].value > timeToRun then
				return
			end
		end
        
        if DB.profile.baroptions[T[vulnKey]].show and anchor ~= "none" then
            if VULNDATA[vulnKey].unique then
               for k, v in pairs(mobTable) do
                    if mobTable[k][T[vulnKey]] then
                        if mobTable[k][T[vulnKey]][BAR] then
                            mobTable[k][T[vulnKey]][BAR]:Fade(0.5)
                            Scorchio2:ReleaseBar(mobTable[k][T[vulnKey]][BAR])
                        end
                        if mobTable[k][T[vulnKey]][TIMER] then
                            Scorchio2:CancelTimer(mobTable[k][T[vulnKey]][TIMER], true)
                        end
                    end
                end
            end
            
			local barText = SubTokens(DB.profile.baroptions[T[vulnKey]].bar, dstName, spellCount)

			mobTable[dstGUID][T[vulnKey]][BAR] = Scorchio2[anchor]:NewTimerBar(tostring(dstGUID .. "_" .. T[vulnKey]), barText, timeToRun, duration, icon)

			mobTable[dstGUID][T[vulnKey]][BAR].texture:SetVertexColor(Colours(DB.profile.baroptions[T[vulnKey]].fg, alpha))
			mobTable[dstGUID][T[vulnKey]][BAR].bgtexture:SetVertexColor(Colours(DB.profile.baroptions[T[vulnKey]].bg, alpha))
        end
        
        if warningTime > 0 and DB.profile.baroptions[T[vulnKey]].showwarning then
            if mobTable[dstGUID][T[vulnKey]][TIMER] ~= nil then
                Scorchio2:CancelTimer(mobTable[dstGUID][T[vulnKey]][TIMER], true)
            end
            mobTable[dstGUID][T[vulnKey]][TIMER] = Scorchio2:ScheduleTimer("TimerComplete", (timeToRun - warningTime), { dstGUID , vulnKey })
        end
    end
end